function RoBTick(%count)
{
	if(isEventPending($RoB::TickSchedule)) cancel($RoB::TickSchedule);
	//if(!isobject(serverconnection.getcontrolobject())) return; //let's try to make this thing dedi
	%count--;
	if(%count <= 0) {
		%count = 10;
		$RoB::Saving = true;
	}
	if($RoB::Dynamic::GameStarted) RoBDoUpdate();
	else if($RoB::Saving) {
		$RoB::Saving = false;
		RobSave();
	}
	%time = getDateTime();
	%ETS = (360 - ((getsubstr(%time, 12, 2) % 6) * 60) - getsubstr(%time, 15, 2) + 1) * 1000; //6 minute ticks
	if(%ETS < 300000) %ETS = 360000; //making sure some clock fuck-up doesn't make us double-Tick.
	if($RoB::LoadComplete && !$DONOTSIMULATE) $RoB::Dynamic::LastUpdate = getsubstr(%time, 0, 2) SPC getsubstr(%time, 3, 2) SPC ((10 * getsubstr(%time, 9, 2)) +  mfloor(getsubstr(%time, 12, 2) / 6));

	for(%i = 0; %i < clientgroup.getcount(); %i++) {
			%c = clientgroup.getobject(%i);
			$RoB::PData[%c.bl_id, lastupdate] = $RoB::Dynamic::LastUpdate;
	}
	
	$RoB::GlobalProdTotal = 0;
	$RoB::GlobalSummation = 0;
	for(%x = $RoB::Dynamic::MinX; %x <= $RoB::Dynamic::MaxX; %x++) {
		for(%y = $RoB::Dynamic::MinY; %y <= $RoB::Dynamic::MaxY; %y++){
			CheckForRepossess(%x, %y);
			if(isBusiness($RoB::Plot[%x,%y])) {
				%producing = false;
				initContainerBoxSearch(getplotcenter(%x SPC %y) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) * 0.25), getplotXsize(%x SPC %y) SPC getplotYsize(%x SPC %y) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2) / 2), $typemasks::fxbrickobjecttype);
				while((%target=containersearchnext()) != 0 && !%producing) {
					if(%target.getdatablock().getname() $= "brickProductionData" && %target.isplanted) %producing = true;
				}
				if(!%producing) {
					initContainerBoxSearch(getplotcenter(%x SPC %y) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) * 0.75), getplotXsize(%x SPC %y) SPC getplotYsize(%x SPC %y) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2) / 2), $typemasks::fxbrickobjecttype);
					while((%target=containersearchnext()) != 0 && !%producing) {
							if(%target.getdatablock().getname() $= "brickProductionData" && %target.isplanted) %producing = true;
					}
				}
				if(%producing) {
					if(HasGoodHome($RoB::plot[%x, %y].blid)) {
						$RoB::GlobalProdTotal += $RoB::Plot[%x, %y].prodfactor;
						$RoB::GlobalSummation += $RoB::Plot[%x, %y].prodfactor * (getPlotRating($RoB::Plot[%x, %y]) + 1);
					} else {
						$RoB::GlobalProdTotal += $RoB::Dynamic::CoreProdRate;
						$RoB::GlobalSummation += $RoB::Dynamic::CoreProdRate * (getPlotRating($RoB::Plot[%x, %y]) + 1);
					}
				}
			}
		}
	}
	$RoB::TickSchedule = schedule(%ETS,0,"RoBTick",%count);
}

function RoBDoUpdate()
{
	bottomPrintAll("\c7The city is producing goods...", 5, 3);
	schedule(90, 0, "ValueValidation");
	for(%i = 0; %i <= $RoB::Dynamic::HighestBLID; %i++) {
		if($RoB::PData[%i, cashtimer] > 0) $RoB::PData[%i, cashtimer] -= $RoB::Dynamic::PlayerCoreRateSpeed;
		EvaluateCapacity(%i);
	}
	if($RoB::Dynamic::MinX $= "") return;
	$RoB::ProdUnit = $RoB::GlobalProdTotal / $RoB::GlobalSummation; //amount of a single rating point
	schedule(100, 0, "RoBUpdateStep", $RoB::Dynamic::MinX);
}

function RoBUpdateStep(%x)
{
	%pct = mfloor((100 * (%x - $RoB::Dynamic::MinX)) / ($RoB::Dynamic::MaxX - $RoB::Dynamic::MinX));
	bottomPrintAll("\c7The city is producing goods: %" @ %pct @ "...", 5, 3);
	for(%y = $RoB::Dynamic::MinY; %y <= $RoB::Dynamic::MaxY; %y++){
		%producing = false;
		initContainerBoxSearch(getplotcenter(%x SPC %y) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) * 0.25), getplotXsize(%x SPC %y) SPC getplotYsize(%x SPC %y) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2) / 2), $typemasks::fxbrickobjecttype);
		while((%target=containersearchnext()) != 0 && !%producing) {
			if(%target.getdatablock().getname() $= "brickProductionData" && %target.isplanted) %producing = true;
		}
		if(!%producing) {
			initContainerBoxSearch(getplotcenter(%x SPC %y) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) * 0.75), getplotXsize(%x SPC %y) SPC getplotYsize(%x SPC %y) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2) / 2), $typemasks::fxbrickobjecttype);
			while((%target=containersearchnext()) != 0 && !%producing) {
					if(%target.getdatablock().getname() $= "brickProductionData" && %target.isplanted) %producing = true;
			}
		}
		if(%producing && isBusiness($RoB::plot[%x, %y])) {
			if(getword($RoB::Dynamic::LastUpdate, 2) % 2 == 1 || !$RoB::PData[$RoB::plot[%x, %y].blid, twoind]) {
				if($RoB::plot[%x, %y].newbiz) $RoB::plot[%x, %y].newbiz = false;
				else {
					if(HasGoodHome($RoB::plot[%x, %y].blid)) {
						%add = $RoB::plot[%x, %y].prodfactor * $RoB::ProdUnit * (getPlotRating($RoB::Plot[%x, %y]) + 1) * 2;
						%prod = mfloor(%add);
						$RoB::plot[%x, %y].prodfrac += %add - %prod;
						if($RoB::plot[%x, %y].prodfrac >= 1) {
							$RoB::plot[%x, %y].prodfrac--;
							%prod++;
						}
						$RoB::plot[%x, %y].produced += %prod;
					} else {
						%add = $RoB::Dynamic::CoreProdRate * $RoB::ProdUnit * (getPlotRating($RoB::Plot[%x, %y]) + 1) * 2;
						%prod = mfloor(%add);
						$RoB::plot[%x, %y].prodfrac += %add - %prod;
						if($RoB::plot[%x, %y].prodfrac >= 1) {
							$RoB::plot[%x, %y].prodfrac--;
							%prod++;
						}
						$RoB::plot[%x, %y].produced += %prod;
					}	
					if($RoB::plot[%x, %y].produced > $RoB::Dynamic::CoreProdCap * $RoB::plot[%x, %y].prodfactor) $RoB::plot[%x, %y].produced = $RoB::Dynamic::CoreProdCap * $RoB::plot[%x, %y].prodfactor;
				}
			}
		}
		for(%i = 1; %i <= $RoB::plot[%x, %y].ratings[index]; %i++) {
			$RoB::Plot[%x, %y].ratetimer[%i]--;
			if($RoB::Plot[%x, %y].cashtimer[%i] > 0) $RoB::Plot[%x, %y].cashtimer[%i]--;
			if($RoB::Plot[%x, %y].ratetimer[%i] < 1) {
				%blid = getword($RoB::Plot[%x, %y].ratings[%i], 0);
				%rating = getword($RoB::Plot[%x, %y].ratings[%i], 1);
				$RoB::PData[%blid, ratings, %rating]--;
				for(%j = %i + 1; %j <= $RoB::plot[%x, %y].ratings[index]; %j++) {
					$RoB::Plot[%x, %y].ratings[%j] = $RoB::Plot[%x, %y].ratings[%j-1];
					$RoB::Plot[%x, %y].ratetimer[%j] = $RoB::Plot[%x, %y].ratetimer[%j-1];
					$RoB::Plot[%x, %y].cashtimer[%j] = $RoB::Plot[%x, %y].cashtimer[%j-1];
				}
				$RoB::plot[%x, %y].ratings[index]--;
			} //don't forget - any rating changes go in simulation AND live ticks.
		}
	}
	%x++;
	if(%x <= $RoB::Dynamic::MaxX) schedule(100,0,"RoBUpdateStep",%x);
	else {
		bottomPrintAll("\c7The city is producing goods: Finished.", 3, 3);
		if($RoB::Saving) {
			$RoB::Saving = false;
			RoBSave();
		}
	}
}

function RoBSave()
{
	//CenterPrintAll("The server is now saving data. If the city is large, it will lag out for a while, but please be patient; you will not be disconnected.", 10, 3);
	
	if(!$Server::Dedicated) { //this method may not be necessary, but it works, so why fuck with it.
		SaveBricks_FileName.setValue("RoB");
		SaveBricks_Description.setValue("Rise of Blockland save.");
		SaveBricks_ExtendedInfo.setValue(1);
		SaveBricks_Ownership.setValue(1);
		SaveBricks_Save();
		eval(MessageBoxYesNoDlg.yesCallback);
		canvas.popDialog(MessageBoxYesNoDlg);
	} else {
		saveBricks("RoB", 1, 1);
	}
	
	deleteVariables("$RoB::PData-1*");
	export("$RoB::PData*", "config/Rise of Blockland/Save Data/playersavedata.cs", False);
	export("$RoB::Property*", "config/Rise of Blockland/Save Data/propertysavedata.cs", False);
	%file = new FileObject();
	%file.openforWrite("config/Rise of Blockland/Save Data/plotsavedata.dat");
	for(%x = $RoB::Dynamic::MinX; %x <= $RoB::Dynamic::MaxX; %x++) {
		for(%y = $RoB::Dynamic::MinY; %y <= $RoB::Dynamic::MaxY; %y++){
			%plot = $RoB::Plot[%x, %y];
			if(isObject(%plot)) {
				//current list:
				//type
				//blid
				//value
				//prodfactor
				//produced
				//prodfrac
				//capacity
				//stored
				//closed
				//price
				//repoed
				
				//ratetimers
				
				//cashtimers
				
				//ID/rating pairs
				
				//owner
				
				//name
				
				%file.writeline(%x SPC %y SPC %plot.type SPC %plot.blid SPC %plot.value SPC %plot.prodfactor SPC %plot.produced SPC %plot.prodfrac SPC %plot.capacity SPC %plot.stored SPC %plot.closed SPC %plot.price SPC %plot.repoed);
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.ratetimer[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.cashtimer[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.ratings[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%file.writeline(%plot.owner);
				%file.writeline(%plot.name);
			}
			%plot = $RoB::Plot[%x @ "to" @ (%x+1), %y];
			if(isObject(%plot)) {
				%file.writeline(%x @ "to" @ (%x+1) SPC %y SPC %plot.type SPC %plot.blid SPC %plot.value SPC %plot.prodfactor SPC %plot.produced SPC %plot.prodfrac SPC %plot.capacity SPC %plot.stored SPC %plot.closed SPC %plot.price SPC %plot.repoed);
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.ratetimer[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.cashtimer[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.ratings[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%file.writeline(%plot.owner);
				%file.writeline(%plot.name);
			}
			%plot = $RoB::Plot[%x, %y @ "to" @ (%y+1)];
			if(isObject(%plot)) {
				%file.writeline(%x SPC %y @ "to" @ (%y+1) SPC %plot.type SPC %plot.blid SPC %plot.value SPC %plot.prodfactor SPC %plot.produced SPC %plot.prodfrac SPC %plot.capacity SPC %plot.stored SPC %plot.closed SPC %plot.price SPC %plot.repoed);
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.ratetimer[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.cashtimer[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.ratings[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%file.writeline(%plot.owner);
				%file.writeline(%plot.name);
			}
			%plot = $RoB::Plot[%x @ "to" @ (%x+1), %y @ "to" @ (%y+1)];
			if(isObject(%plot)) {
				%file.writeline(%x @ "to" @ (%x+1) SPC %y @ "to" @ (%y+1) SPC %plot.type SPC %plot.blid SPC %plot.value SPC %plot.prodfactor SPC %plot.produced SPC %plot.prodfrac SPC %plot.capacity SPC %plot.stored SPC %plot.closed SPC %plot.price SPC %plot.repoed);
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.ratetimer[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.cashtimer[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%ratestr = "";
				for(%i = 1; %i <= %plot.ratings[index]; %i++) {
					%ratestr = %ratestr SPC %plot.ratings[%i];
				}
				%file.writeline(ltrim(%ratestr));
				%file.writeline(%plot.owner);
				%file.writeline(%plot.name);
			}
		}
	}
	%file.close();
	//export("$RoB::Plot*", "config/Rise of Blockland/Save Data/plotsavedata.cs", False);
	export("$RoB::Dynamic::*", "config/Rise of Blockland/Save Data/dynamics.cs", False);
	%file.openforWrite("config/Rise of Blockland/Save Data/roadsavedata.dat");
	for(%x = $RoB::Dynamic::MinX; %x < $RoB::Dynamic::MaxX; %x++) {
		%name = %x @ "to" @ (%x+1);
		if($RoB::RoadName[x, %name] !$= "") %file.writeline("x" SPC %name SPC $RoB::RoadName[x, %name]);
	}
	for(%y = $RoB::Dynamic::MinY; %y < $RoB::Dynamic::MaxY; %y++) {
		%name = %y @ "to" @ (%y+1);
		if($RoB::RoadName[y, %name] !$= "") %file.writeline("y" SPC %name SPC $RoB::RoadName[y, %name]);
	}
	%file.close();
	%file.delete();
	//export("$RoB::RoadName*", "config/Rise of Blockland/Save Data/roadsavedata.cs", False);
	export("$RoB::Log*", "config/Rise of Blockland/Save Data/log.cs", False);
	export("$RoB::Event*", "config/Rise of Blockland/Save Data/events.cs", True);
	deleteVariables("$RoB::Event*");
	
	//clientCmdCenterPrint("Data Saved.",4); //dedi ftw
}

function servercmdRoBLoadBricks(%client)
{
	if(!%client.robadmin) return;
	fileCopy("saves/Slate/RoB.bls", "base/server/temp/temp.bls");
	schedule(1000, 0, "RoBLoadBricks", %client);
}

function RoBLoadBricks(%client)
{
	$brickload = true;
	//serverDirectSaveFileLoad("saves/" @ $RoB::MapDir @ "/RoB.bls", 0);
	serverCmdReloadBricks(%client);
}

function servercmdRoBLoadData(%client) //This must be used AFTER bricks are loaded!!
{
	if(!%client.robadmin) return;
	RobLoadData();
}

function RoBLoadData()
{
	cancel($RoB::TickSchedule);
	cancel($RoB::FuelSchedule);
	deletevariables("$RoB::RateTMP*");
	
	bottomPrintAll("\c7Loading data: players...", 5, 3);
	exec("config/Rise of Blockland/Save Data/playersavedata.cs");
	bottomPrintAll("\c7Loading data: property lists...", 5, 3);
	exec("config/Rise of Blockland/Save Data/propertysavedata.cs");
	bottomPrintAll("\c7Loading data: lots...", 5, 3);
	%file = new fileObject();
	%file.openforread("config/Rise of Blockland/Save Data/plotsavedata.dat");
	while(!%file.isEoF) {
		%line = %file.readline();
		//echo("line read:" SPC %line);
		if(strlen(%line)) {
			%plot = RoBCreatePlotObject(getword(%line, 0), getword(%line, 1));
			%plot.type = getword(%line, 2);
			%plot.blid = getword(%line, 3);
			%plot.value = getword(%line, 4);
			%plot.prodfactor = getword(%line, 5);
			%plot.produced = getword(%line, 6);
			%plot.prodfrac = getword(%line, 7);
			%plot.capacity = getword(%line, 8);
			%plot.stored = getword(%line, 9);
			%plot.closed = getword(%line, 10);
			%plot.price = getword(%line, 11);
			%plot.repoed = getword(%line, 12);
			%rtstr = %file.readline();
			%ctstr = %file.readline();
			%ratestr = %file.readline();
			for(%i = 0; %i < getWordCount(%rtstr); %i++) {
				%plot.ratings[index]++;
				%plot.ratetimer[%i] = getword(%rtstr, %i);
				%plot.cashtimer[%i] = getword(%ctstr, %i);
				%plot.ratings[%i] = getwords(%ratestr, (%i*2), (%i*2)+1);
				%blid = getword(%ratestr, (%i*2));
				%rating = getword(%ratestr, (%i*2)+1);
				$RoB::RateTMP[%blid, %rating]++;
			}
			%plot.owner = %file.readline();
			%plot.name = %file.readline();
		} else break;
	}
	%file.close();
	bottomPrintAll("\c7Loading data: addl. global data...", 5, 3);
	exec("config/Rise of Blockland/Save Data/dynamics.cs");
	bottomPrintAll("\c7Loading data: roads...", 5, 3);
	%file.openforread("config/Rise of Blockland/Save Data/roadsavedata.dat");
	while(!%file.isEoF) {
		%line = %file.readline();
		//echo("line read:" SPC %line);
		if(strlen(%line)) {
			$RoB::RoadName[getword(%line, 0), getword(%line, 1)] = getwords(%line, 2, getwordcount(%line)-1);
		} else break;
	}
	%file.close();
	%file.delete();
	//exec("config/Rise of Blockland/Save Data/roadsavedata.cs");
	bottomPrintAll("\c7Loading data: datalogs...", 5, 3);
	exec("config/Rise of Blockland/Save Data/log.cs");
	
	$brickload = false;
	$RoB2GUI::PlotBuyList = "Residential Food Material Design Engineering Technology Gas";
	
	if($RoB::Dynamic::GameStarted && !$DONOTSIMULATE) {
		bottomPrintAll("\c7Simulating offline production...", 5, 3);
		%time = getDateTime();
		
		%ETS = (360 - ((getsubstr(%time, 12, 2) % 6) * 60) - getsubstr(%time, 15, 2) + 1) * 1000;
		$RoB::TickSchedule = schedule(%ETS,0,"RoBTick",10);
		$RoB::FuelSchedule = schedule(1000,0,"RoBFuelValidation");
		
		if($RoB::Dynamic::LastUpdate $= "") {
			$RoB::Dynamic::LastUpdate = getsubstr(%time, 0, 2) SPC getsubstr(%time, 3, 2) SPC ((10 * getsubstr(%time, 9, 2)) +  mfloor(getsubstr(%time, 12, 2) / 6));
			messageclient(%client, "", "NO UPDATE DATA FOUND, INITIALIZING $RoB::Dynamic::LastUpdate.");
			return;
		}
		
		%months = getsubstr(%time, 0, 2) - getword($RoB::Dynamic::LastUpdate, 0);
		%days = getsubstr(%time, 3, 2) - getword($RoB::Dynamic::LastUpdate, 1);
		%Ticks = (10 * getsubstr(%time, 9, 2)) + mfloor(getsubstr(%time, 12, 2) / 6) - getword($RoB::Dynamic::LastUpdate, 2);
		$RoB::Dynamic::LastUpdate = getsubstr(%time, 0, 2) SPC getsubstr(%time, 3, 2) SPC ((10 * getsubstr(%time, 9, 2)) + mfloor(getsubstr(%time, 12, 2) / 6));
		if(%months < 0) %months += 12;
		for(%i = 0; %i < %months; %i++)
		{
			%cur = getsubstr(%time, 0, 2) - %i;
			if(%cur < 1) %cur += 12;
			switch(%cur)
			{
				case 1:
					%Ticks += 31 * 240;
				case 2:
					if(getsubstr(%time, 6, 2) % 4 == 0) %Ticks += 28 * 240;
					else %Ticks += 29 * 240;
				case 3:
					%Ticks += 31 * 240;
				case 4:
					%Ticks += 30 * 240;
				case 5:
					%Ticks += 31 * 240;
				case 6:
					%Ticks += 30 * 240;
				case 7:
					%Ticks += 31 * 240;
				case 8:
					%Ticks += 31 * 240;
				case 9:
					%Ticks += 30 * 240;
				case 10:
					%Ticks += 31 * 240;
				case 11:
					%Ticks += 30 * 240;
				case 12:
					%Ticks += 31 * 240;
			}
		}
		if(%days < 0) {
			switch(getsubstr(%time, 0, 2) - 1)
			{
				case 1:
					%days += 31;
				case 2:
					if(getsubstr(%time, 6, 2) % 4 == 0) %days += 28;
					else %days += 29;
				case 3:
					%days += 31;
				case 4:
					%days += 30;
				case 5:
					%days += 31;
				case 6:
					%days += 30;
				case 7:
					%days += 31;
				case 8:
					%days += 31;
				case 9:
					%days += 30;
				case 10:
					%days += 31;
				case 11:
					%days += 30;
				case 12:
					%days += 31;
			}
		}
		%Ticks += %days * 240;
		if(%Ticks < 0) %Ticks += 240;
		echo("UPDATES TO MAKE: " @ %Ticks @ " (capped at 250)");
		if(%Ticks > 480) {
			for(%i = 0; %i <= $RoB::Dynamic::HighestBLID; %i++) {
				if($RoB::PData[%i, lastupdate] !$= "") $RoB::PData[%i, lastupdate] = $RoB::Dynamic::LastUpdate;
			}
		}
		if(%Ticks > 250) %Ticks = 250;
		%tenspot = getword($RoB::Dynamic::LastUpdate, 2) - %Ticks;
		if(%tenspot < 0) %tenspot += 240;
		%tenspot = %tenspot % 10;
		%twoindmod = (getword($RoB::Dynamic::LastUpdate, 2) + 1) % 2;
		for(%x = $RoB::Dynamic::MinX; %x <= $RoB::Dynamic::MaxX; %x++) {
			for(%y = $RoB::Dynamic::MinY; %y <= $RoB::Dynamic::MaxY; %y++){
				if(isObject($RoB::Plot[%x, %y])) {
					if(!$RoB::Plot[%x, %y].prodfactor) $RoB::Plot[%x, %y].prodfactor = 1;
					%producing = false;
					%type = $RoB::Plot[%x, %y].type;
					initContainerBoxSearch(getplotcenter(%x SPC %y) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%x SPC %y) SPC getplotYsize(%x SPC %y) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
					while((%target=containersearchnext()) != 0) {
						if(%target.getdatablock().getname() $= "brickProductionData" && %target.isplanted) %producing = true;
					}
					if(%producing && isBusiness($RoB::Plot[%x, %y])) {
						for(%i = 0; %i < %Ticks; %i++) {
							if(%i % 2 == %twoindmod || !$RoB::PData[$RoB::Plot[%x, %y].blid, twoind]) {
								if($RoB::plot[%x, %y].newbiz) $RoB::plot[%x, %y].newbiz = false;
								else {
									if(HasGoodHome($RoB::plot[%x, %y].blid)) {
										%add = $RoB::plot[%x, %y].prodfactor * $RoB::ProdUnit * (getPlotRating($RoB::Plot[%x, %y]) + 1) * 2;
										%prod = mfloor(%add);
										$RoB::plot[%x, %y].prodfrac += %add - %prod;
										if($RoB::plot[%x, %y].prodfrac >= 1) {
											$RoB::plot[%x, %y].prodfrac--;
											%prod++;
										}
										$RoB::plot[%x, %y].produced += %prod;
									} else {
										%add = $RoB::Dynamic::CoreProdRate * $RoB::ProdUnit * (getPlotRating($RoB::Plot[%x, %y]) + 1) * 2;
										%prod = mfloor(%add);
										$RoB::plot[%x, %y].prodfrac += %add - %prod;
										if($RoB::plot[%x, %y].prodfrac >= 1) {
											$RoB::plot[%x, %y].prodfrac--;
											%prod++;
										}
										$RoB::plot[%x, %y].produced += %prod;
									}	
									if($RoB::plot[%x, %y].produced > $RoB::Dynamic::CoreProdCap * $RoB::plot[%x, %y].prodfactor) $RoB::plot[%x, %y].produced = $RoB::Dynamic::CoreProdCap * $RoB::plot[%x, %y].prodfactor;
								}
							}
						}
					}
					for(%i = 1; %i <= $RoB::plot[%x, %y].ratings[index]; %i++) {
						$RoB::Plot[%x, %y].ratetimer[%i]--;
						if($RoB::Plot[%x, %y].cashtimer[%i] > 0) $RoB::Plot[%x, %y].cashtimer[%i]--;
						if($RoB::Plot[%x, %y].ratetimer[%i] < 1) {
							%blid = getword($RoB::Plot[%x, %y].ratings[%i], 0);
							%rating = getword($RoB::Plot[%x, %y].ratings[%i], 1);
							$RoB::PData[%blid, ratings, %rating]--;
							for(%j = %i + 1; %j <= $RoB::plot[%x, %y].ratings[index]; %j++) {
								$RoB::Plot[%x, %y].ratings[%j] = $RoB::Plot[%x, %y].ratings[%j-1];
								$RoB::Plot[%x, %y].ratetimer[%j] = $RoB::Plot[%x, %y].ratetimer[%j-1];
								$RoB::Plot[%x, %y].cashtimer[%j] = $RoB::Plot[%x, %y].cashtimer[%j-1];
							}
							$RoB::plot[%x, %y].ratings[index]--;
						}
					} //don't forget - any rating changes go in simulation AND live ticks.
				}
			}
		}
	}
	
	$RoB::LoadComplete = true;
	messageclient(%client, "", "LOAD COMPLETE");
	bottomPrintAll("\c7Load complete.\c7If you've already spawned in and encounter an error, \c7you \c7should \c7reconnect.", 5, 3);
}