function servercmdignorehelp(%client)
{
	if(%client.isadmin) {
		messageclient(%client, "", "\c2Admins must always listen to the help channel.");
		return;
	}
	if($RoB::PData[%client.bl_id, ignorehelp]){
		$RoB::PData[%client.bl_id, ignorehelp] = false;
		messageclient(%client, "", "\c2You are no longer ignoring the help channel.");
	} else {
		$RoB::PData[%client.bl_id, ignorehelp] = true;
		messageclient(%client, "", "\c2You are now ignoring the help channel.");
	}
}

function servercmdthetime(%client)
{
	messageclient(%client, "", "\c1The time is now " @ getsubstr(getdatetime(), 9, 5) @ " BLST (Blockland Standard Time).");
}

function servercmdroburl(%client)
{
	messageclient(%client, "", "<a:" @ $RoBGUI::DLURL @ ">This is a web page link to the download.</a>");
}

function servercmdejectme(%client)
{
	if(!isobject(%client.player)) return;
	%plot = findPlotFromObject(%client.player);
	%quad = getRelativeQuadrant(%plot);
	%center = getPlotCenter(%plot);
	%cex = getword(%center, 0);
	%cey = getword(%center, 1);
	%plx = getword(%client.player.getTransform(), 0);
	%ply = getword(%client.player.getTransform(), 1);
	%relx = %plx - %cex;
	%rely = %ply - %cey;
	if(%quad $= "1 1") {
		%test = %relx > %rely;
		%tresult = (%cex + 12) SPC %ply SPC "0.21";
		%fresult = %plx SPC (%cey + 12) SPC "0.21";
	} else if(%quad $= "1 -1") {
		%test = -%relx > %rely;
		%tresult = %plx SPC (%cey - 12) SPC "0.21";
		%fresult = (%cex + 12) SPC %ply SPC "0.21";
	} else if(%quad $= "-1 -1") {
		%test = %relx > %rely;
		%tresult = %plx SPC (%cey - 12) SPC "0.21";
		%fresult = (%cex - 12) SPC %ply SPC "0.21";
	} else {
		%test = -%relx > %rely;
		%tresult = (%cex - 12) SPC %ply SPC "0.21";
		%fresult = %plx SPC (%cey + 12) SPC "0.21";
	}
	if(%test) %client.player.setTransform(%tresult);
	else %client.player.setTransform(%fresult);
}

function servercmdeject(%client)
{
	for(%i = 1; $RoB::Property[%client.bl_id, %i] !$= "" || %i == 1; %i++) {
		%plot = $RoB::Property[%client.bl_id, %i];
		if(%plot !$= "") {
			initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)), $TypeMasks::PlayerObjectType);
			while(%target=containersearchnext()) {
				if(%target.client != %client && !%target.client.isAdmin && findPlotFromObject(%target) $= %plot) ejectPlayerFromPlot(%target);
			}
		}
	}
}

function ejectPlayerFromPlot(%player)
{
	if(!isobject(%player)) return;
	%plot = findPlotFromObject(%player);
	%quad = getRelativeQuadrant(%plot);
	%center = getPlotCenter(%plot);
	%cex = getword(%center, 0);
	%cey = getword(%center, 1);
	%plx = getword(%player.getTransform(), 0);
	%ply = getword(%player.getTransform(), 1);
	%relx = %plx - %cex;
	%rely = %ply - %cey;
	if(%quad $= "1 1") {
		%test = %relx > %rely;
		%tresult = (%cex + 12) SPC %ply SPC "0.21";
		%fresult = %plx SPC (%cey + 12) SPC "0.21";
	} else if(%quad $= "1 -1") {
		%test = -%relx > %rely;
		%tresult = %plx SPC (%cey - 12) SPC "0.21";
		%fresult = (%cex + 12) SPC %ply SPC "0.21";
	} else if(%quad $= "-1 -1") {
		%test = %relx > %rely;
		%tresult = %plx SPC (%cey - 12) SPC "0.21";
		%fresult = (%cex - 12) SPC %ply SPC "0.21";
	} else {
		%test = -%relx > %rely;
		%tresult = (%cex - 12) SPC %ply SPC "0.21";
		%fresult = %plx SPC (%cey + 12) SPC "0.21";
	}
	if(%test) %player.setTransform(%tresult);
	else %player.setTransform(%fresult);
}