function cleancenter()
{
	initContainerBoxSearch("0 0 0.1", "0.1 0.1 0.1", -1);
	while(%target=containersearchnext()) {
		%target.delete();
	}
}

function robroadcheck()
{
	for(%x = $RoB::Dynamic::MinX; %x < $RoB::Dynamic::MaxX; %x++) {
		for(%y = $RoB::Dynamic::MinY; %y < $RoB::Dynamic::MaxY; %y++){
			%plotx = %x - (mabs(%x) % 2);
			%ploty = %y - (mabs(%y) % 2);
			if(isObject($RoB::Plot[%plotx, %ploty])) {
				if(!isObject($RoB::Plot[(%plotx-1) @ "to" @ %plotx, (%ploty-1) @ "to" @ %ploty])) {
					%plot = RoBCreatePlotObject((%plotx-1) @ "to" @ %plotx, (%ploty-1) @ "to" @ %ploty);
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
				if(!isObject($RoB::Plot[%plotx, (%ploty-1) @ "to" @ %ploty])) {
					%plot = RoBCreatePlotObject(%plotx, (%ploty-1) @ "to" @ %ploty);
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
				if(!isObject($RoB::Plot[(%plotx-1) @ "to" @ %plotx, %ploty])) {
					%plot = RoBCreatePlotObject((%plotx-1) @ "to" @ %plotx, %ploty);
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
				if(!isObject($RoB::Plot[(%plotx+1) @ "to" @ (%plotx+2), (%ploty-1) @ "to" @ %ploty])) {
					%plot = RoBCreatePlotObject((%plotx-1) @ "to" @ %plotx, (%ploty-1) @ "to" @ %ploty);
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
				if(!isObject($RoB::Plot[(%plotx+1), (%ploty-1) @ "to" @ %ploty])) {
					%plot = RoBCreatePlotObject((%plotx+1), (%ploty-1) @ "to" @ %ploty);
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
				if(!isObject($RoB::Plot[(%plotx+1) @ "to" @ (%plotx+2), %ploty])) {
					%plot = RoBCreatePlotObject((%plotx+1) @ "to" @ (%plotx+2), %ploty);
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
				if(!isObject($RoB::Plot[(%plotx-1) @ "to" @ %plotx, (%ploty+1) @ "to" @ (%ploty+2)])) {
					%plot = RoBCreatePlotObject((%plotx-1) @ "to" @ %plotx, (%ploty+1) @ "to" @ (%ploty+2));
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
				if(!isObject($RoB::Plot[%plotx, (%ploty+1) @ "to" @ (%ploty+2)])) {
					%plot = RoBCreatePlotObject(%plotx, (%ploty+1) @ "to" @ (%ploty+2));
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
				if(!isObject($RoB::Plot[(%plotx-1) @ "to" @ %plotx, (%ploty+1)])) {
					%plot = RoBCreatePlotObject((%plotx-1) @ "to" @ %plotx, (%ploty+1));
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
				if(!isObject($RoB::Plot[(%plotx+1) @ "to" @ (%plotx+2), (%ploty+1) @ "to" @ (%ploty+2)])) {
					%plot = RoBCreatePlotObject((%plotx+1) @ "to" @ (%plotx+2), (%ploty+1) @ "to" @ (%ploty+2));
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
				if(!isObject($RoB::Plot[(%plotx+1), (%ploty+1) @ "to" @ (%ploty+2)])) {
					%plot = RoBCreatePlotObject((%plotx+1), (%ploty+1) @ "to" @ (%ploty+2));
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
				if(!isObject($RoB::Plot[(%plotx+1) @ "to" @ (%plotx+2), (%ploty+1)])) {
					%plot = RoBCreatePlotObject((%plotx+1) @ "to" @ (%plotx+2), (%ploty+1));
					%plot.type = "C";
					%plot.blid = -1;
					%plot.owner = "City";
					%plot.name = "road";
				}
			}
		}
	}
}

function newgamesetup()
{
	$RoB2GUI::PlotBuyList = "Residential Food Material Design Engineering Technology Gas";
	$RoB::Dynamic::CoreProdCap = 250;
	$RoB::Dynamic::CoreStorAmt = 250;
	$RoB::Dynamic::PlayerCoreRateMax = 5250;
	$RoB::Dynamic::PlayerCoreRateSpeed = 21;
	$RoB::Dynamic::PlotCoreRateMax = 750;
	$RoB::Dynamic::CoreResPrice = 10000;
	$RoB::Dynamic::CoreBusPrice = 20000;
	$RoB::Dynamic::PoorWorthCutoff = 20000;
	$RoB::Dynamic::CoreProdRate = 1;
	
	echo("NEW GAME SETUP");
	for(%i = 0; %i < 2; %i++) {
		for(%j = 0; %j < 2; %j++) { //duplicate road creations are fine because it just points us to the old one in the creation function.
			%plot = RoBCreatePlotObject(%i, %j);
			%plot.type = "C";
			%plot.blid = -1;
			%plot.owner = "City";
			%plot.name = "Origin Park";
			%plot = RoBCreatePlotObject("-1to0", %j);
			%plot.type = "C";
			%plot.blid = -1;
			%plot.owner = "City";
			%plot.name = "road";
			%plot = RoBCreatePlotObject("1to2", %j);
			%plot.type = "C";
			%plot.blid = -1;
			%plot.owner = "City";
			%plot.name = "road";
			%plot = RoBCreatePlotObject(%i, "-1to0");
			%plot.type = "C";
			%plot.blid = -1;
			%plot.owner = "City";
			%plot.name = "road";
			%plot = RoBCreatePlotObject(%i, "1to2");
			%plot.type = "C";
			%plot.blid = -1;
			%plot.owner = "City";
			%plot.name = "road";
		}
	}
	%plot = RoBCreatePlotObject("-1to0", "-1to0");
	%plot.type = "C";
	%plot.blid = -1;
	%plot.owner = "City";
	%plot.name = "road";
	%plot = RoBCreatePlotObject("-1to0", "1to2");
	%plot.type = "C";
	%plot.blid = -1;
	%plot.owner = "City";
	%plot.name = "road";
	%plot = RoBCreatePlotObject("1to2", "-1to0");
	%plot.type = "C";
	%plot.blid = -1;
	%plot.owner = "City";
	%plot.name = "road";
	%plot = RoBCreatePlotObject("1to2", "1to2");
	%plot.type = "C";
	%plot.blid = -1;
	%plot.owner = "City";
	%plot.name = "road";
	
	RoBTick(10);
	AddEvent("newgame: New game started.");
}

function RoBCreatePlotObject(%x, %y) {
	if(isObject($RoB::plot[%x, %y])) return $RoB::plot[%x, %y];
	$RoB::plot[%x, %y] = new ScriptObject() {
	};
	MissionCleanup.add($RoB::plot[%x, %y]);
	return $RoB::plot[%x, %y];
}

function RoBNewPlot(%plot)
{
	if(strpos(%plot, "to", 0) >= 0) return "ROAD";
	%plotx = getword(%plot, 0);
	%plotx -= mabs(%plotx) % 2;
	%ploty = getword(%plot, 1);
	%ploty -= mabs(%ploty) % 2;
	if(isObject($RoB::Plot[%plotx, %ploty])) return "EXISTS";
	%plot = RoBCreatePlotObject(%plotx, %ploty);
	%plot.type = "U";
	%plot.blid = -1;
	%plot.owner = "Unowned";
	%plot.name = %plotx SPC %ploty;
	%plot.prodfactor = $RoB::Dynamic::CoreProdRate;
	%plot.produced = 0;
	%plot.prodfrac = 0;
	%plot.stored = 0;
	%plot.capacity = 0;
	%plot.closed = 0;
	%plot.price = 15;
	%plot.value = 0;
	%plot.newbiz = false;
	%plot = RoBCreatePlotObject(%plotx+1, %ploty);
	%plot.type = "U";
	%plot.blid = -1;
	%plot.owner = "Unowned";
	%plot.name = %plotx+1 SPC %ploty;
	%plot.prodfactor = $RoB::Dynamic::CoreProdRate;
	%plot.produced = 0;
	%plot.prodfrac = 0;
	%plot.stored = 0;
	%plot.capacity = 0;
	%plot.closed = 0;
	%plot.price = 15;
	%plot.value = 0;
	%plot.newbiz = false;
	%plot = RoBCreatePlotObject(%plotx, %ploty+1);
	%plot.type = "U";
	%plot.blid = -1;
	%plot.owner = "Unowned";
	%plot.name = %plotx SPC %ploty+1;
	%plot.prodfactor = $RoB::Dynamic::CoreProdRate;
	%plot.produced = 0;
	%plot.prodfrac = 0;
	%plot.stored = 0;
	%plot.capacity = 0;
	%plot.closed = 0;
	%plot.price = 15;
	%plot.value = 0;
	%plot.newbiz = false;
	%plot = RoBCreatePlotObject(%plotx+1, %ploty+1);
	%plot.type = "U";
	%plot.blid = -1;
	%plot.owner = "Unowned";
	%plot.name = %plotx+1 SPC %ploty+1;
	%plot.prodfactor = $RoB::Dynamic::CoreProdRate;
	%plot.produced = 0;
	%plot.prodfrac = 0;
	%plot.stored = 0;
	%plot.capacity = 0;
	%plot.closed = 0;
	%plot.price = 15;
	%plot.value = 0;
	%plot.newbiz = false;
	
	if($RoB::Dynamic::minX > %plotx) $RoB::Dynamic::minX = %plotx;
	if($RoB::Dynamic::maxX < (%plotx + 1)) $RoB::Dynamic::maxX = %plotx + 1;
	if($RoB::Dynamic::minY > %ploty) $RoB::Dynamic::minY = %ploty;
	if($RoB::Dynamic::maxY < (%ploty + 1)) $RoB::Dynamic::maxY = %ploty + 1;
	
	if(!isObject($RoB::Plot[(%plotx - 1) @ "to" @ %plotx, (%ploty - 1) @ "to" @ %ploty])) {	
		%plot = RoBCreatePlotObject((%plotx - 1) @ "to" @ %plotx, (%ploty - 1) @ "to" @ %ploty);
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	
	if(!isObject($RoB::Plot[%plotx, (%ploty - 1) @ "to" @ %ploty])) {	
		%plot = RoBCreatePlotObject(%plotx, (%ploty - 1) @ "to" @ %ploty);
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	if(!isObject($RoB::Plot[(%plotx + 1), (%ploty - 1) @ "to" @ %ploty])) {	
		%plot = RoBCreatePlotObject((%plotx + 1), (%ploty - 1) @ "to" @ %ploty);
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	if(!isObject($RoB::Plot[(%plotx + 1) @ "to" @ (%plotx + 2), (%ploty - 1) @ "to" @ %ploty])) {	
		%plot = RoBCreatePlotObject((%plotx + 1) @ "to" @ (%plotx + 2), (%ploty - 1) @ "to" @ %ploty);
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	if(!isObject($RoB::Plot[(%plotx - 1) @ "to" @ %plotx, %ploty])) {	
		%plot = RoBCreatePlotObject((%plotx - 1) @ "to" @ %plotx, %ploty);
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	if(!isObject($RoB::Plot[(%plotx + 1) @ "to" @ (%plotx + 2), %ploty])) {	
		%plot = RoBCreatePlotObject((%plotx + 1) @ "to" @ (%plotx + 2), %ploty);
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	if(!isObject($RoB::Plot[(%plotx - 1) @ "to" @ %plotx, (%ploty + 1)])) {	
		%plot = RoBCreatePlotObject((%plotx - 1) @ "to" @ %plotx, (%ploty + 1));
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	if(!isObject($RoB::Plot[(%plotx + 1) @ "to" @ (%plotx + 2), (%ploty + 1)])) {	
		%plot = RoBCreatePlotObject((%plotx + 1) @ "to" @ (%plotx + 2), (%ploty + 1));
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	if(!isObject($RoB::Plot[(%plotx - 1) @ "to" @ %plotx, (%ploty + 1) @ "to" @ (%ploty + 2)])) {
		%plot = RoBCreatePlotObject((%plotx - 1) @ "to" @ %plotx, (%ploty + 1) @ "to" @ (%ploty + 2));
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	if(!isObject($RoB::Plot[%plotx, (%ploty + 1) @ "to" @ (%ploty + 2)])) {	
		%plot = RoBCreatePlotObject(%plotx, (%ploty + 1) @ "to" @ (%ploty + 2));
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	if(!isObject($RoB::Plot[(%plotx + 1), (%ploty + 1) @ "to" @ (%ploty + 2)])) {	
		%plot = RoBCreatePlotObject((%plotx + 1), (%ploty + 1) @ "to" @ (%ploty + 2));
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	if(!isObject($RoB::Plot[(%plotx + 1) @ "to" @ (%plotx + 2), (%ploty + 1) @ "to" @ (%ploty + 2)])) {	
		%plot = RoBCreatePlotObject((%plotx + 1) @ "to" @ (%plotx + 2), (%ploty + 1) @ "to" @ (%ploty + 2));
		%plot.blid = -1;
		%plot.owner = "city";
		%plot.name = "road";
		%plot.type = "C";
		%plot.produced = 0;
		%plot.stored = 0;
		%plot.capacity = 0;
		%plot.closed = 0;
		%plot.price = 10;
		%plot.value = 0;
	}
	return "GOOD";
}

function RoBConnect(%client)
{
	if(%client.bl_id == 0) {
		%client.bl_id = "0"; //why the hell would badspot make his ID 0?? Maybe this will work...
		messageClient(%client, "", "It seems that you have, for whatever reason, made your BL_ID the TorqueScript equivalent of \"null\". Way to go, Einstein.");
		messageClient(%client, "", "Also, I can't package GameConnection::OnConnect(), what's up with that?");
		messageClient(%client, "", "Also, thanks for denying us the option of modding jets.");
		messageClient(%client, "", "...so yeah, anyway, no guarantees that any of this will work unless you have a non-zero BL_ID. Sorry.");
	}
	$RoB::PData[%client.bl_id, lastupdate] = $RoB::Dynamic::LastUpdate;
	
	RemoveLostProperties(%client.bl_id);
	
	for(%i = 1; ($RoB::Property[%client.bl_id, %i] !$= "" || %i == 1); %i++) {
		if($RoB::Property[%client.bl_id, %i] !$= "") {
			%x = getword($RoB::Property[%client.bl_id, %i], 0);
			%y = getword($RoB::Property[%client.bl_id, %i], 1);
			$RoB::plot[%x, %y].owner = %client.name;
		}
	}
}

function RoBNewPlayer(%client)
{
	if(%client.bl_id > $RoB::Dynamic::HighestBLID) $RoB::Dynamic::HighestBLID = %client.bl_id;
	$RoB::PData[%client.bl_id, money] = 5000;
	$RoB::PData[%client.bl_id, fud] = 100;
	$RoB::PData[%client.bl_id, mat] = 80;
	$RoB::PData[%client.bl_id, des] = 0;
	$RoB::PData[%client.bl_id, eng] = 90;
	$RoB::PData[%client.bl_id, tec] = 30;
	$RoB::PData[%client.bl_id, gas] = 0;
	$RoB::PData[%owner, lastupdate] = $RoB::Dynamic::LastUpdate;
	commandtoclient(%client, 'MessageBoxOK', "Rise of Blockland", "Welcome to Rise of Blockland! Please check the \"Getting Started\" info before trying to do more than look around. If you need help, use team chat.");
	MessageAll("\c5" @ %client.name @ " has joined the Rise of Blockland!");
	AddEvent("join: " @ %client.name SPC "(" @ %client.bl_id @ ")" @ " joined the game." );
	$RoB::Log[total, players]++;
	if($RoB::Log[avg, plyrplots] != 0) $RoB::Log[avg, plyrplots] *= ($RoB::Log[total, players] - 1) / $RoB::Log[total, players];
	if($RoB::Log[avg, plyrworth] != 0) $RoB::Log[avg, plyrworth] *= ($RoB::Log[total, players] - 1) / $RoB::Log[total, players];
	$RoB::Log[avg, plyrworth] += 9500 / $RoB::Log[total, players];
	$RoB::Log[total, plyrworth] += 9500;
	$RoB::PData[%client.bl_id, networth] = 9500;
}

	//msgs everyone except the given client %notme.
function MessageExcept(%notme, %msg) {
	for(%i = 0; %i < clientgroup.getcount(); %i++) {
		%client = clientgroup.getobject(%i);
		if(%client != %notme) messageClient(%client,"",%msg);	
	}
	echo("everyone but " @ %notme.name @ " was messaged: " @ %msg);
}

function AddEvent(%event)
{
	$RoB::Event[$RoB::Dynamic::NextEvent] = getDateTime() SPC %event;
	$RoB::Dynamic::NextEvent++;
}

function HasGoodHome(%blid)
{
	for(%i = 1; ($RoB::Property[%blid, %i] !$= ""); %i++) {
		%x = getword($RoB::Property[%blid, %i], 0);
		%y = getword($RoB::Property[%blid, %i], 1);
		if($RoB::plot[%x, %y].type $= "R" && $RoB::plot[%x, %y].value >= $RoB::Dynamic::CoreResPrice) return true;
	}
	return false;
}

function RoBGasValidation()
{
	for(%i = 0; %i < clientgroup.getcount(); %i++) {
		%cl = clientgroup.getobject(%i);
		if(isobject(%cl.player)) {
			if(%cl.player.getdatablock().getname() $= "PlayerRoB" && %cl.player.validGas) {
				$RoB::PData[%cl.bl_id, Gas] = mceil(%cl.player.getenergylevel());
				$RoB::TmpGas[%cl.bl_id] = mfloor(1000 * %cl.player.getenergylevel()) / 1000;
				if($RoB::TmpGas[%cl.bl_id] <= PlayerRoB.jetEnergyDrain) $RoB::TmpGas[%cl.bl_id] = "Empty";
			}
		}
	}
	$RoB::GasSchedule = schedule(1000,0,"RoBGasValidation");
}

function GetEngCost(%brick)
{
	%db = %brick.getdatablock();
	if(%db.getname() $= "brickProductionData" || %db.getname() $= "brickStorageData" || %db.getname() $= "brickSalePointData" || %db.getname() $= "brickSpawnPointData") return 0;
	if(%db.category $= "Ramps" || %db.category $= "Rounds" || %db.category $= "Special" || %db.getname() $= "brick2x2cornerData") %eng+=3;
	if(strstr($RoB::TransparentColors, " " @ %brick.colorID @ " ") != -1) %eng+=3;
	return %eng;
}

function getTechCost(%brick)
{
	if(%brick.getdatablock().subcategory $= "Prints") %tec = 3;
	%tec -= getColorFXTecCost(%brick, 0);
	%tec -= getShapeFXTecCost(%brick, 0);
	%tec += getBrickEventTotalPrice(%brick);
	return %tec;
}

function SetPlayerEnergy(%b)
{
	if(!isObject(%b)) return;
	if($RoB::TmpGas[%b.client.bl_id] $= "Empty") {
		%b.setEnergyLevel(0);
	} else if($RoB::TmpGas[%b.client.bl_id] !$= "") {
		%b.setEnergyLevel($RoB::TmpGas[%b.client.bl_id]);
	} else {
		%b.setEnergyLevel($RoB::PData[%b.client.bl_id, gas]);
	}
	%b.validgas = true;
}

function isbusiness(%plot)
{
	if(!isObject(%plot) || %plot.owner $= "") {
		%x = getword(%plot, 0);
		%y = getword(%plot, 1);
		%plot = $RoB::Plot[%x, %y];
		if(!isObject(%plot)) return false;
	}
	if(%plot.type $= "F" || %plot.type $= "M" || %plot.type $= "D" || %plot.type $= "E" || %plot.type $= "T" || %plot.type $= "G") return true;
	else return false;
}

function SetColor(%brick, %color)
{
	%brick.SetColor(%color);
}

function SetPrint(%brick, %print)
{
	%brick.SetPrint(%print);
}

function ConfirmColor(%brick)
{
	if(%brick.colorID == 61 || %brick.colorID == 62 || %brick.colorID == 63) %brick.SetColor(0);
}

function processColorFXChange(%client, %brick, %fx)
{
	%plot = findplotfromobject(%brick);
	%x = getword(%plot, 0);
	%y = getword(%plot, 1);
	%owner = $RoB::Plot[%x, %y].blid;
	%cost = getColorFXTecCost(%brick, %fx);
	if(%cost < 0 && $RoB::PData[%owner, tec] - %cost > evaluateCapacity(%client.bl_id) && !%client.robadmin) commandtoclient(%client, 'MessageBoxOK', "ERROR", "You can't hold the technology refund of this action.");
	else if(%cost > 0 && %cost > $RoB::PData[%owner, tec]) commandtoclient(%client, 'MessageBoxOK', "ERROR", "You don't have enough technology.");
	else {
		%brick.setColorFX(%fx);
		$RoB::PData[%owner, tec] -= %cost;
		$RoB::Plot[%x, %y].extravalue += %cost * 15;
	}
}

function processShapeFXChange(%client, %brick, %fx)
{
	%plot = findplotfromobject(%brick);
	%x = getword(%plot, 0);
	%y = getword(%plot, 1);
	%owner = $RoB::Plot[%x, %y].blid;
	%cost = getShapeFXTecCost(%brick, %fx);
	if(%cost < 0 && $RoB::PData[%owner, tec] - %cost > evaluateCapacity(%client.bl_id) && !%client.robadmin) commandtoclient(%client, 'MessageBoxOK', "ERROR", "You can't hold the technology refund of this action.");
	else if(%cost > 0 && %cost > $RoB::PData[%owner, tec]) commandtoclient(%client, 'MessageBoxOK', "ERROR", "You don't have enough technology.");
	else {
		%brick.setShapeFX(%fx);
		$RoB::PData[%owner, tec] -= %cost;
		$RoB::Plot[%x, %y].extravalue += %cost * 15;
	}
}

function findPlotFromObject(%this)
{
	%pos = %this.getTransform();
	%x = getword(%pos, 0);
	%y = getword(%pos, 1);
	%xm = %x;
	%ym = %y;
	%x = mfloor(%x / 40) * 2;
	%y = mfloor(%y / 40) * 2;
	while(%xm < 0) %xm += 40;
	while(%ym < 0) %ym += 40;
	%xm = mfloor((%xm % 40) / 8);
	%ym = mfloor((%ym % 40) / 8);
	if(%xm == 4) {
		if(%ym == 4) return (%x + 1) @ "to" @ (%x + 2) SPC (%y + 1) @ "to" @ (%y + 2);
		else if(%ym >= 2) return (%x + 1) @ "to" @ (%x + 2) SPC (%y + 1);
		else return (%x + 1) @ "to" @ (%x + 2) SPC %y;
	} else if(%xm >= 2) {
		if(%ym == 4) return (%x + 1) SPC (%y + 1) @ "to" @ (%y + 2);
		else if(%ym >= 2) return (%x + 1) SPC (%y + 1);
		else return (%x + 1) SPC %y;
	} else {
		if(%ym == 4) return %x SPC (%y + 1) @ "to" @ (%y + 2);
		else if(%ym >= 2) return %x SPC (%y + 1);
		else return %x SPC %y;
	}
}

function findPlotOwnerBLID(%plot)
{
	%x = getword(%plot, 0);
	%y = getword(%plot, 1);
	if($RoB::Plot[%x, %y].blid >= 0) return $RoB::Plot[%x, %y].blid;
	else return -1;
}

function getplotcenter(%plot)
{
	%plotx = getword(%plot, 0);
	if(strpos(%plotx, "to", 0) >= 0) {
		%plotx = getsubstr(%plotx, 0, strpos(%plotx, "to", 0)) * 16;
		if(%plotx < 0) %plotx -= 8;
		if(%plotx >= 0) %plotx += mfloor(%plotx / 32) * 8;
		else %plotx += mceil(%plotx / 32) * 8;
		%plotx += 20;
	} else {
		%plotx *= 16;
		%plotx += (mfloor(%plotx / 32) * 8) + 8;
	}
	%ploty = getword(%plot, 1);
	if(strpos(%ploty, "to", 0) >= 0) {
		%ploty = getsubstr(%ploty, 0, strpos(%ploty, "to", 0)) * 16;
		if(%ploty < 0) %ploty -= 8;
		if(%ploty >= 0) %ploty += mfloor(%ploty / 32) * 8;
		else %ploty += mceil(%ploty / 32) * 8;
		%ploty += 20;
	} else {
		%ploty *= 16;
		%ploty += (mfloor(%ploty / 32) * 8) + 8;
	}
	return %plotx SPC %ploty;
}

function getRelativeQuadrant(%plot) //clockwise from upper left: returns "1 1", "1 -1", "-1 -1", or "-1 1"
{
	%plotx = getword(%plot, 0);
	while(%plotx < 0) %plotx += 2;
	while(%plotx > 1) %plotx -= 2;
	if(%plotx == 0) %plotx = -1;
	%ploty = getword(%plot, 1);
	while(%ploty < 0) %ploty += 2;
	while(%ploty > 1) %ploty -= 2;
	if(%ploty == 0) %ploty = -1;
	return %plotx SPC %ploty;
}

function getplotxsize(%plot)
{
	%x = getword(%plot, 0);
	if(strpos(%x, "to", 0) >= 0) {
		return 7.99;
	} else {
		return 15.99;
	}
}

function getplotysize(%plot)
{
	%y = getword(%plot, 1);
	if(strpos(%y, "to", 0) >= 0) {
		return 7.99;
	} else {
		return 15.99;
	}
}

function getdesigncost(%Z, %Zsize)
{
	%bricktop = %Z + (0.1 * %Zsize);
	%cost = (mfloor((%bricktop / ($RoB::LevelHeight / 5)) - ($RoB::GroundLevel * 0.2))) * 2;
	if(%cost < 0) %cost = 0;
	return %cost;
}

function getColorFXTecCost(%brick, %newfx)
{
	if(%newfx == %brick.colorFXID) return 0;
	%fxc[0] = 0; //flat
	%fxc[1] = 0; //pearl
	%fxc[2] = 0; //chrome
	%fxc[3] = 3; //glow
	%fxc[4] = 15; //blink
	%fxc[5] = 20; //swirl
	%fxc[6] = 22; //rainbow
	
	return (%fxc[%newfx] - %fxc[%brick.colorFXID]);
}

function getShapeFXTecCost(%brick, %newfx)
{
	if(%newfx == %brick.shapeFXID) return 0;
	%fxc[0] = 0; //stable
	%fxc[1] = 24; //jello
	
	return (%fxc[%newfx] - %fxc[%brick.shapeFXID]);
}

function SetupSpawn(%brick)
{
	if($brickload) {
		schedule(1000, 0, "SetupSpawn", %brick);
		return;
	}
	if(%brick.colorID == 61 || %brick.colorID == 62 || %brick.colorID == 63) %brick.SetColor(0);
	for(%i = 0; %i < clientgroup.getcount(); %i++) {
		%plyrcheck = clientgroup.getobject(%i);
		if(%plyrcheck.bl_id == %brick.getgroup().bl_id) %client = %plyrcheck;
	}
	%plot = findplotfromobject(%brick);
	%x = getword(%plot, 0);
	%y = getword(%plot, 1);
	if($RoB::Plot[%x, %y].owner $= "City") {
		%i = 0;
		while($RoB::Dynamic::DefaultSpawn[%i] !$= "") {
			if($RoB::Dynamic::DefaultSpawn[%i] $= %brick.gettransform()) return;
			%i++;
		}
		$RoB::Dynamic::DefaultSpawn[%i] = %brick.gettransform();
	} else if(%client.robadmin && $RoB::Plot[%x, %y].blid != %client.bl_id) return;
	else {
		%i = 1;
		while(%client.spawn[%i]) %i++;
		%client.spawn[%i] = %brick.gettransform();
	}
}

function GameConnection::FloodOff(%this)
{
	%this.floodControl = false;
}

function RemoveSpawn(%brick)
{
	for(%i = 0; $RoB::Dynamic::DefaultSpawn[%i] !$= ""; %i++) {
		if($RoB::Dynamic::DefaultSpawn[%i] $= %brick.gettransform()) %Dspawnfound = true;
		if(%Dspawnfound) $RoB::Dynamic::DefaultSpawn[%i] = $RoB::Dynamic::DefaultSpawn[(%i + 1)];
	}
	%plot = FindPlotFromObject(%brick);
	%owner = FindPlotOwnerBLID(%plot);
	for(%i = 0; %i < clientgroup.getcount(); %i++) {
		%plyrcheck = clientgroup.getobject(%i);
		if(%plyrcheck.bl_id == %owner) %client = %plyrcheck;
	}
	if(!%client) return;
	for(%i = 1; %client.spawn[%i] !$= ""; %i++) {
		if(%client.spawn[%i] $= %brick.gettransform()) %spawnfound = true;
		if(%spawnfound) %client.spawn[%i] = %client.spawn[(%i + 1)];
	}
}

function GetTotalProd(%blid)
{
	for(%i = 2; $RoB::Property[%blid, %i] !$= ""; %i++) {
		%lx = getword($RoB::Property[%blid, %i], 0);
		%ly = getword($RoB::Property[%blid, %i], 1);
		if(isBusiness($RoB::Plot[%lx, %ly])) {
			if(hasGoodHome(%blid)) %totalprod += $RoB::Plot[%lx, %ly].prodfactor;
			else %totalprod++;
		}
	}
	return %totalprod;
}

function evaluateCapacity(%blid)
{
	for(%i = 1; $RoB::Property[%blid, %i] !$= ""; %i++) {
		%lx = getword($RoB::Property[%blid, %i], 0);
		%ly = getword($RoB::Property[%blid, %i], 1);
		if($RoB::Plot[%lx, %ly].type $= "R") {
			%points += getPlotRating($RoB::Plot[%lx, %ly]);
		}
	}
	$RoB::PData[%blid, capacity] = mfloor(50 + (16.667 * %points));
}

function buildbrick(%owner, %brick, %plotx, %ploty, %cost, %des, %eng, %tec)
{
	%plot = %plotx SPC %ploty;
	if(!isobject(%brick)) return;
	if(%brick.getdatablock().getname() !$= "brickProductionData" && %brick.getdatablock().getname() !$= "brickStorageData" && %brick.getdatablock().getname() !$= "brickSalePointData" && %brick.getdatablock().getname() !$= "brickSpawnPointData") %vcost = %cost + (15 * (%des + 1)); //+1 is material
	else %vcost = (15 * %des);
	%vcost += %eng * 5;
	if(isobject($RoB::Plot[%plotx, %ploty])) {
		$RoB::Plot[%plotx, %ploty].value += %vcost;
		CheckForProdChange(%plot);
		$RoB::Log[total, plotvalue] += %vcost;
		$RoB::Log[total, plotextravalue] += (%eng * 10) + (%tec * 15);
		$RoB::Plot[%plotx, %ploty].extravalue += (%eng * 10) + (%tec * 15);
	}
	if($RoB::Log[total, plyrplots] != 0) $RoB::Log[avg, plotvalue] = $RoB::Log[total, plotvalue] / $RoB::Log[total, plyrplots];
	%creator = getBrickGroupFromObject(%brick).client;
	if(!%creator.robadmin) {
		$RoB::PData[%owner, money] -= %cost;
		$RoB::PData[%owner, des] -= %des;
		$RoB::PData[%owner, eng] -= %eng;
		$RoB::PData[%owner, tec] -= %tec;
		if(%brick.getdatablock().getname() !$= "brickProductionData" && %brick.getdatablock().getname() !$= "brickStorageData" && %brick.getdatablock().getname() !$= "brickSalePointData" && %brick.getdatablock().getname() !$= "brickSpawnPointData") {
			$RoB::PData[%owner, mat]--;
			$RoB::PData[%owner, fud]--;
			AddWorth(%owner, -15);
		}
	}
	if(isobject(%creator)) ServerCmdRoB2GUIGetPlayerInfo(%creator);
}

function CheckForProdChange(%plot)
{
	if($brickload) return;
	%x = getword(%plot, 0);
	%y = getword(%plot, 1);
	if(!isObject($RoB::Plot[%x, %y]) || $RoB::Plot[%x, %y].type $= "R" || $RoB::Plot[%x, %y].type $= "P") return;
	%Ks = mfloor($RoB::Plot[%x, %y].value / 10000);
	switch($RoB::Plot[%x, %y].prodfactor - $RoB::Dynamic::CoreProdRate) {
		case 0:
			if(%Ks >= 3) %pro = true;
		case $RoB::Dynamic::ProdRateStep:
			if(%Ks < 3) %de = true;
			else if(%Ks >= 7) %pro = true;
		case ($RoB::Dynamic::ProdRateStep * 2):
			if(%Ks < 7) %de = true;
			else if(%Ks >= 12) %pro = true;
		case ($RoB::Dynamic::ProdRateStep * 3):
			if(%Ks < 12) %de = true;
			else if(%Ks >= 18) %pro = true;
		case ($RoB::Dynamic::ProdRateStep * 4):
			if(%Ks < 18) %de = true;
	}
	%totalprod = GetTotalProd($RoB::Plot[%x, %y].blid);
	%unit = mfloor(%totalprod * $RoB::Dynamic::CoreCashRate);
	%playercashcap = $RoB::Dynamic::PlayerCoreRateMax * %unit;
	%playercashamt = %playercashcap - ($RoB::PData[$RoB::Plot[%x, %y].blid, cashtimer] * %unit);
	if(%playercashamt < 0) %playercashamt = 0;
	if(%pro) {
		%newunit = mfloor((%totalprod + $RoB::Dynamic::ProdRateStep) * $RoB::Dynamic::CoreCashRate);
		%newcap = $RoB::Dynamic::PlayerCoreRateMax * %newunit;
		$RoB::PData[$RoB::Plot[%x, %y].blid, cashtimer] = $RoB::Dynamic::PlayerCoreRateMax - mfloor(%playercashamt / %newunit);
		$RoB::Plot[%x, %y].prodfactor += $RoB::Dynamic::ProdRateStep;
		%client = findClientByBL_ID($RoB::Plot[%x, %y].blid);
		if(isobject(%client)) {
			messageclient(%client, "", "\c5Your development of this property has raised its production level!");
			messageclient(%client, "", "\c5It now has about " @ mfloor(($RoB::Plot[%x, %y].prodfactor / $RoB::Dynamic::CoreProdRate)*100) @ "% the normal production speed, production capacity, and max storage bricks!");
			messageclient(%client, "", "\c5The production speed bonus will only apply if you have a home with a brick value of $20,000.");
		}
	} else if(%de) {
		%newunit = mfloor((%totalprod - $RoB::Dynamic::ProdRateStep) * $RoB::Dynamic::CoreCashRate);
		%newcap = $RoB::Dynamic::PlayerCoreRateMax * %newunit;
		$RoB::PData[$RoB::Plot[%x, %y].blid, cashtimer] = $RoB::Dynamic::PlayerCoreRateMax - mfloor(%playercashamt / %newunit);
		$RoB::Plot[%x, %y].prodfactor -= $RoB::Dynamic::ProdRateStep;
		%client = findClientByBL_ID($RoB::Plot[%x, %y].blid);
		if(isobject(%client)) {
			messageclient(%client, "", "\c5Your destruction of this property has lowered its production level!");
			messageclient(%client, "", "\c5It now only has about " @ mfloor(($RoB::Plot[%x, %y].prodfactor / $RoB::Dynamic::CoreProdRate)*100) @ "% the normal production speed, production capacity, and max storage bricks! (old storage bricks will stay)");
		}
	}
}


function GetPlotPrice(%blid, %type, %mode)
{
	if(!%mode) %blid = %blid.bl_id;
	switch$(%type) {
		case "R":
			for(%i = 1; ($RoB::Property[%blid, %i] !$= "" || %i == 1); %i++) {
				%Rx = getword($RoB::Property[%blid, %i], 0);
				%Ry = getword($RoB::Property[%blid, %i], 1);
				if($RoB::Plot[%rx, %ry].type $= "R") %price += $RoB::Dynamic::CoreResPrice;
			}
		default:
			for(%i = 1; ($RoB::Property[%blid, %i] !$= "" || %i == 1); %i++) {
				%Rx = getword($RoB::Property[%blid, %i], 0);
				%Ry = getword($RoB::Property[%blid, %i], 1);
				if(isObject($RoB::Plot[%rx, %ry])) if($RoB::Plot[%rx, %ry].type !$= "R") %price += $RoB::Dynamic::CoreBusPrice;
			}
	}
	return %price;
}

function getPlotRating(%plot) //returns adjusted average rating for a lot
{
	if(!isObject(%plot)) {
		%x = getword(%plot, 0);
		%y = getword(%plot, 1);
		%plot = $RoB::Plot[%x, %y];
		if(!isObject(%plot)) return 0;
	}
	
	for(%i = 1; %i <= %plot.ratings[index]; %i++) {
		%c++;
		%t += getword(%plot.ratings[%i],1);
	}
	if(%c <= 5) return 3; 
	
	WorthValidation(%plot.blid);
	if($RoB::PData[%plot.blid, networth] < $RoB::Dynamic::PoorWorthCutoff) return 3;
	
	//[1, 1.8) [1.8, 2.6) [2.6, 3.4] (3.4, 4.2] (4.2, 5]
	%avg = %t/%c;
	if(%avg < 1.8) return 1;
	else if(%avg < 2.6) return 2;
	else if (%avg > 4.2) return 5;
	else if (%avg > 3.4) return 4;
	else return 3;
}

function GetCongestionPrice(%plot)
{
	return 0; //TO DO ?
	
	
	if(strpos(%plot, "to", 0) >= 0) return 0;
	%X = nneg(getword(%plot, 0));
	%Y = nneg(getword(%plot, 1));
	for(%sX = %X - 1; %sX <= %X + 1; %sX++) {
		for(%sY = %Y - 1; %sY <= %Y + 1; %sY++) {
			if((%sX != %X || %sY != %Y) && $RoB::Plot[negn(%sX), negn(%sY), type] !$= "" && $RoB::Plot[negn(%sX), negn(%sY), type] !$= "U") {
				%C++;
			}
		}
	}
	return %C * 1250;
}















function RepossessEmptyLots(%blid)
{
	for(%i = 1; ($RoB::Property[%blid, %i] !$= "" || %i == 1); %i++) {
		%plot = $RoB::Property[%blid, %i];
		if(%plot !$= "") {
			%plotx = getword(%plot, 0);
			%ploty = getword(%plot, 1);
			switch$($RoB::Plot[%plotx, %ploty].type) {
				case "R":
					%price = GetPlotPrice(%owner, $RoB::Plot[%plotx, %ploty].type, 1) - $RoB::Dynamic::CoreResPrice;
					$RoB::Log[total, rplots]--;
				case "F":
					%price = GetPlotPrice(%owner, $RoB::Plot[%plotx, %ploty].type, 1) - $RoB::Dynamic::CoreBusPrice;
					$RoB::Log[total, fplots]--;
				case "M":
					%price = GetPlotPrice(%owner, $RoB::Plot[%plotx, %ploty].type, 1) - $RoB::Dynamic::CoreBusPrice;
					$RoB::Log[total, mplots]--;
				case "D":
					%price = GetPlotPrice(%owner, $RoB::Plot[%plotx, %ploty].type, 1) - $RoB::Dynamic::CoreBusPrice;
					$RoB::Log[total, dplots]--;
				case "T":
					%price = GetPlotPrice(%owner, $RoB::Plot[%plotx, %ploty].type, 1) - $RoB::Dynamic::CoreBusPrice;
					$RoB::Log[total, tplots]--;
				default:
					return;
			}	
			
			
			initContainerBoxSearch(getplotcenter(%plotx SPC %ploty) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plotx SPC %ploty) SPC getplotYsize(%plotx SPC %ploty) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
			if(containersearchnext()) return;
			
			
			%price += GetCongestionPrice(%plotx SPC %ploty);
			%finalprice = %price + $RoB::Plot[%plotx, %ploty].value + $RoB::Plot[%plotx, %ploty].extravalue;
			$RoB::PData[%owner, money] += %finalprice;
			
			%totalprod = GetTotalProd($RoB::Plot[%x, %y].blid);
			%unit = mfloor(%totalprod * $RoB::Dynamic::CoreCashRate);
			%playercashcap = $RoB::Dynamic::PlayerCoreRateMax * %unit;
			%playercashamt = %playercashcap - ($RoB::PData[$RoB::Plot[%x, %y].blid, cashtimer] * %unit);
			if(%playercashamt < 0) %playercashamt = 0;
			%newunit = mfloor((%totalprod - $RoB::Plot[%plotx, %ploty].prodfactor) * $RoB::Dynamic::CoreCashRate);
			%newcap = $RoB::Dynamic::PlayerCoreRateMax * %newunit;
			$RoB::PData[$RoB::Plot[%x, %y].blid, cashtimer] = $RoB::Dynamic::PlayerCoreRateMax - mfloor(%playercashamt / %newunit);
			$RoB::Plot[%plotx, %ploty].blid = -1;
			$RoB::Plot[%plotx, %ploty].owner = "Repossessed Lot";
			$RoB::Plot[%plotx, %ploty].name = %plotx SPC %ploty;
			%type = $RoB::Plot[%plotx, %ploty].type;
			$RoB::Plot[%plotx, %ploty].type = "U";
			$RoB::Plot[%plotx, %ploty].produced = 0;
			$RoB::Plot[%plotx, %ploty].prodfrac = 0;
			%stor = $RoB::Plot[%plotx, %ploty].stored;
			$RoB::Plot[%plotx, %ploty].stored = 0;
			schedule(200, "RepoCapacityNull", %plotx, %ploty);
			$RoB::Plot[%plotx, %ploty].price = 15;
			$RoB::Plot[%plotx, %ploty].newbiz = false;
			$RoB::Plot[%plotx, %ploty].closed = false;
			$RoB::Plot[%plotx, %ploty].repoed = true;
			initContainerBoxSearch(getplotcenter(%plotx SPC %ploty) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plotx SPC %ploty) SPC getplotYsize(%plotx SPC %ploty) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
			while(%target=containersearchnext()) {
				if(%target.getdatablock().subcategory $= "Prints" ) %target.setPrint($RoB::APrint);
			}
			
			RemoveLostProperties(%owner);
			
			$RoB::Log[total, plyrplots]--;
			$RoB::Log[total, plotvalue] -= $RoB::Plot[%plotx, %ploty].value;
			if($RoB::Log[total, plyrplots] != 0) $RoB::Log[avg, plotvalue] = $RoB::Log[total, plotvalue] / $RoB::Log[total, plyrplots];
			$RoB::Log[avg, plyrplots] = $RoB::Log[total, plyrplots] / $RoB::Log[total, players];
			AddWorth(%owner, %stor * -15);
			
			AddEvent("repossess: (" @ %plotx @ ", " @ %ploty @ ") repossessed with " @ %stor SPC %type @ " from (" @ %owner @ ") for $" @ %finalprice @ ". (" @ %tics @ " vs. " @ %mintics @ ") months: " @ %months @ " days: " @ %days);
			
			%xa = %plotx - 1;
			%xb = %plotx + 1;
			%ya = %ploty - 1;
			%yb = %ploty + 1;
			RepoRoad(%xa @ "to" @ %plotx, %ya @ "to" @ %ploty, %owner);
			RepoRoad(%xa @ "to" @ %plotx, %ploty, %owner);
			RepoRoad(%xa @ "to" @ %plotx, %ploty @ "to" @ %yb, %owner);
			RepoRoad(%plotx, %ya @ "to" @ %ploty, %owner);
			RepoRoad(%plotx, %ploty @ "to" @ %yb, %owner);
			RepoRoad(%plotx @ "to" @ %xb, %ya @ "to" @ %ploty, %owner);
			RepoRoad(%plotx @ "to" @ %xb, %ploty, %owner);
			RepoRoad(%plotx @ "to" @ %xb, %ploty @ "to" @ %yb, %owner);
		}
	}
}


function CheckForRepossess(%plotx, %ploty)
{
	if(!isObject($RoB::Plot[%plotx, %ploty])) return;
	%owner = $RoB::Plot[%plotx, %ploty].blid;
	if(%owner < 0) return;
	
	%mintics = mfloor((($RoB::Plot[%plotx, %ploty].value / $RoB::Dynamic::CoreResPrice) + 3) * 240); //3 days plus one day per $20k value (one 6-minute tick per $83.333 value)
	if(%mintics > 5520) %mintics = 5520;
	
	if($RoB::PData[%owner, lastupdate] $= "") {
		$RoB::PData[%owner, lastupdate] = $RoB::Dynamic::LastUpdate;
		return;
	}
	%time = getDateTime();
	%months = getword($RoB::Dynamic::LastUpdate, 0) - getword($RoB::PData[%owner, lastupdate], 0);
	%days = getword($RoB::Dynamic::LastUpdate, 1) - getword($RoB::PData[%owner, lastupdate], 1);
	%tics = getword($RoB::Dynamic::LastUpdate, 2) - getword($RoB::PData[%owner, lastupdate], 2);
	if(%months < 0) %months += 12;
	for(%i = 0; %i < %months; %i++)
	{
		%cur = getword($RoB::Dynamic::LastUpdate, 0) - %i;
		if(%cur < 1) %cur += 12;
		switch(%cur)
		{
			case 1:
				%tics += 31 * 240;
			case 2:
				if(getsubstr(%time, 6, 2) % 4 == 0) %tics += 28 * 240;
				else %tics += 29 * 240;
			case 3:
				%tics += 31 * 240;
			case 4:
				%tics += 30 * 240;
			case 5:
				%tics += 31 * 240;
			case 6:
				%tics += 30 * 240;
			case 7:
				%tics += 31 * 240;
			case 8:
				%tics += 31 * 240;
			case 9:
				%tics += 30 * 240;
			case 10:
				%tics += 31 * 240;
			case 11:
				%tics += 30 * 240;
			case 12:
				%tics += 31 * 240;
		}
	}
	if(%days < 0) {
		switch(getword($RoB::PData[%owner, lastupdate], 0))
		{
			case 1:
				%days += 31;
			case 2:
				if(getsubstr(%time, 6, 2) % 4 == 0) %days += 28;
				else %days += 29;
			case 3:
				%days += 31;
			case 4:
				%days += 30;
			case 5:
				%days += 31;
			case 6:
				%days += 30;
			case 7:
				%days += 31;
			case 8:
				%days += 31;
			case 9:
				%days += 30;
			case 10:
				%days += 31;
			case 11:
				%days += 30;
			case 12:
				%days += 31;
		}
	}
	%tics += %days * 240;
	if(%tics < %mintics) return;
	
	switch$($RoB::Plot[%plotx, %ploty].type) {
		case "R":
			%price = GetPlotPrice(%owner, $RoB::Plot[%plotx, %ploty].type, 1) - $RoB::Dynamic::CoreResPrice;
			$RoB::Log[total, rplots]--;
		case "F":
			%price = GetPlotPrice(%owner, $RoB::Plot[%plotx, %ploty].type, 1) - $RoB::Dynamic::CoreBusPrice;
			$RoB::Log[total, fplots]--;
		case "M":
			%price = GetPlotPrice(%owner, $RoB::Plot[%plotx, %ploty].type, 1) - $RoB::Dynamic::CoreBusPrice;
			$RoB::Log[total, mplots]--;
		case "D":
			%price = GetPlotPrice(%owner, $RoB::Plot[%plotx, %ploty].type, 1) - $RoB::Dynamic::CoreBusPrice;
			$RoB::Log[total, dplots]--;
		case "T":
			%price = GetPlotPrice(%owner, $RoB::Plot[%plotx, %ploty].type, 1) - $RoB::Dynamic::CoreBusPrice;
			$RoB::Log[total, tplots]--;
		default:
			return;
	}	
	initContainerBoxSearch(getplotcenter(%plotx SPC %ploty) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plotx SPC %ploty) SPC getplotYsize(%plotx SPC %ploty) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
	while(%target=containersearchnext()) {
		if(%target.getdatablock().getname() $= "brickProductionData" || %target.getdatablock().getname() $= "brickStorageData" || %target.getdatablock().getname() $= "brickSalePointData" || %target.getdatablock().getname() $= "brickSpawnPointData") {
			%target.killbrick();
		}
	}
	%price += GetCongestionPrice(%plotx SPC %ploty);
	%finalprice = %price + $RoB::Plot[%plotx, %ploty].value + $RoB::Plot[%plotx, %ploty].extravalue;
	$RoB::PData[%owner, money] += %finalprice;
	$RoB::Plot[%plotx, %ploty].blid = -1;
	$RoB::Plot[%plotx, %ploty].owner = "Repossessed Lot";
	$RoB::Plot[%plotx, %ploty].name = %plotx SPC %ploty;
	%type = $RoB::Plot[%plotx, %ploty].type;
	$RoB::Plot[%plotx, %ploty].type = "U";
	$RoB::Plot[%plotx, %ploty].produced = 0;
	$RoB::Plot[%plotx, %ploty].prodfrac = 0;
	%stor = $RoB::Plot[%plotx, %ploty].stored;
	$RoB::Plot[%plotx, %ploty].stored = 0;
	schedule(200, "RepoCapacityNull", %plotx, %ploty);
	$RoB::Plot[%plotx, %ploty].price = 15;
	$RoB::Plot[%plotx, %ploty].newbiz = false;
	$RoB::Plot[%plotx, %ploty].closed = false;
	$RoB::Plot[%plotx, %ploty].repoed = true;
	initContainerBoxSearch(getplotcenter(%plotx SPC %ploty) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plotx SPC %ploty) SPC getplotYsize(%plotx SPC %ploty) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
	while(%target=containersearchnext()) {
		if(%target.getdatablock().subcategory $= "Prints" ) %target.setPrint($RoB::APrint);
	}
	
	RemoveLostProperties(%owner);
	
	$RoB::Log[total, plyrplots]--;
	$RoB::Log[total, plotvalue] -= $RoB::Plot[%plotx, %ploty].value;
	if($RoB::Log[total, plyrplots] != 0) $RoB::Log[avg, plotvalue] = $RoB::Log[total, plotvalue] / $RoB::Log[total, plyrplots];
	$RoB::Log[avg, plyrplots] = $RoB::Log[total, plyrplots] / $RoB::Log[total, players];
	AddWorth(%owner, %stor * -15);
	
	AddEvent("repossess: (" @ %plotx @ ", " @ %ploty @ ") repossessed with " @ %stor SPC %type @ " from (" @ %owner @ ") for $" @ %finalprice @ ". (" @ %tics @ " vs. " @ %mintics @ ") months: " @ %months @ " days: " @ %days);
	
	%xa = %plotx - 1;
	%xb = %plotx + 1;
	%ya = %ploty - 1;
	%yb = %ploty + 1;
	RepoRoad(%xa @ "to" @ %plotx, %ya @ "to" @ %ploty, %owner);
	RepoRoad(%xa @ "to" @ %plotx, %ploty, %owner);
	RepoRoad(%xa @ "to" @ %plotx, %ploty @ "to" @ %yb, %owner);
	RepoRoad(%plotx, %ya @ "to" @ %ploty, %owner);
	RepoRoad(%plotx, %ploty @ "to" @ %yb, %owner);
	RepoRoad(%plotx @ "to" @ %xb, %ya @ "to" @ %ploty, %owner);
	RepoRoad(%plotx @ "to" @ %xb, %ploty, %owner);
	RepoRoad(%plotx @ "to" @ %xb, %ploty @ "to" @ %yb, %owner);
	
	//for(%cX = %plotx - 1; %cX <= %plotx + 1; %cX++) { //TO DO ?
	//	for(%cY = %ploty - 1; %cY <= %ploty + 1; %cY++) {
	//		if((%cX != %plotx || %cY != %ploty) && $RoB::Plot[%sX, %sY].type !$= "" && $RoB::Plot[%sX, %sY].type !$= "U") {
	//			%C = 0;
	//			for(%sX = %cX - 1; %sX <= %cX + 1; %sX++) {
	//				for(%sY = %cY - 1; %sY <= %cY + 1; %sY++) {
	//					if((%cX != %plotx || %cY != %ploty) && $RoB::Plot[%sX, %sY].type !$= "" && $RoB::Plot[%sX, %sY].type !$= "U") {
	//						%C++;
	//					}
	//				}
	//			}
	//			AddWorth($RoB::Plot[%cX, %cY].blid, -1250);
	//		}
	//	}
	//}
}




function RepoRoad(%x, %y, %owner)
{
	if(!isObject($RoB::Plot[%x, %y]) || $RoB::Plot[%x, %y].blid != %owner) return;
	$RoB::Plot[%x, %y].blid = -1;
	$RoB::Plot[%x, %y].owner = "City";
	$RoB::Plot[%x, %y].type = "C";
	$RoB::PData[%owner, money] += $RoB::Dynamic::CoreResPrice + $RoB::Plot[%x, %y].value;
	initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2) + 0.2) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2) - 0.21), $typemasks::fxbrickobjecttype);
	while(%target=containersearchnext()) {
		if(%target.isplanted()) {
			%target.killbrick();
		}
	}
	AddEvent("repossess: (" @ %x @ ", " @ %y @ ") repossessed from (" @ %owner @ ") for $" @ ($RoB::Dynamic::CoreResPrice + $RoB::Plot[%x, %y].value) @ ".");
}

function RepoCapacityNull(%plotx, %ploty)
{
	$RoB::Plot[%plotx, %ploty].capacity = 0;
}

function RemoveLostProperties(%blid)
{
	for(%i = 1; ($RoB::Property[%blid, %i] !$= "" || %i == 1); %i++) {
		%x = getword($RoB::Property[%blid, %i], 0);
		%y = getword($RoB::Property[%blid, %i], 1);
		%plot = $RoB::Plot[%x, %y];
		if(!isObject(%plot) || %plot.blid != %blid) $RoB::Property[%blid, %i] = "";
	}
	%listlen = %i;
	if($RoB::Property[%blid, 1] $= "") {
		for(%i = 2; %i < %listlen && !%done; %i++) {
			if($RoB::Property[%blid, %i] !$= "") {
				%x = getword($RoB::Property[%blid, %i], 0);
				%y = getword($RoB::Property[%blid, %i], 1);
				%plot = $RoB::Plot[%x, %y];
				if(isObject(%plot) && %plot.type $= "R") {
					$RoB::Property[%blid, 1] = $RoB::Property[%blid, %i];
					$RoB::Property[%blid, %i] = "";
					%done = true;
				}
			}
		}
	}
	for(%i = 2; %i < %listlen; %i++) {
		%done = false;
		if($RoB::Property[%blid, %i] $= "") {
			for(%j = %i+1; %j < %listlen && !%done; %j++) {
				if($RoB::Property[%blid, %j] !$= "") {
					%done = true;
					$RoB::Property[%blid, %i] = $RoB::Property[%blid, %j];
					$RoB::Property[%blid, %j] = "";
				}
			}
		}
	}
}

















function AddWorth(%blid, %amt)
{
	if(%amt == 0) return;
	$RoB::Log[total, plyrworth] += %amt;
	$RoB::PData[%blid, networth] += %amt;
	if($RoB::PData[%blid, networth] > $RoB::PData[$RoB::Log[top, plyrworth], networth]) $RoB::Log[top, plyrworth] = %blid;
	if($RoB::Log[total, players] > 0) $RoB::Log[avg, plyrworth] = $RoB::Log[total, plyrworth] / $RoB::Log[total, players];
	schedule(200, 0, "WorthValidation", %blid);
}

function WorthValidation(%blid)
{
	if(%blid $= "" || %blid < 0) return;
	for(%i = 1; ($RoB::Property[%blid, %i] !$= "" || %i == 1); %i++) {
		%x = getword($RoB::Property[%blid, %i], 0);
		%y = getword($RoB::Property[%blid, %i], 1);
		%plyrworth += $RoB::Plot[%x, %y].value;
		%plyrworth += $RoB::Plot[%x, %y].extravalue;
		if(isbusiness(%x SPC %y)) %plyrworth += $RoB::Plot[%x, %y].stored * 15;
		switch$($RoB::Plot[%x, %y].type) {
			case "R":
				%price = $RoB::Dynamic::CoreResPrice * %Rcount;
				%Rcount++;
				%price += GetCongestionPrice(%x SPC %y);
			case "F":
				%price = $RoB::Dynamic::CoreBusPrice * %Bcount;
				%Bcount++;
				%price += GetCongestionPrice(%x SPC %y);
			case "M":
				%price = $RoB::Dynamic::CoreBusPrice * %Bcount;
				%Bcount++;
				%price += GetCongestionPrice(%x SPC %y);
			case "D":
				%price = $RoB::Dynamic::CoreBusPrice * %Bcount;
				%Bcount++;
				%price += GetCongestionPrice(%x SPC %y);
			case "E":
				%price = $RoB::Dynamic::CoreBusPrice * %Bcount;
				%Bcount++;
				%price += GetCongestionPrice(%x SPC %y);
			case "T":
				%price = $RoB::Dynamic::CoreBusPrice * %Bcount;
				%Bcount++;
				%price += GetCongestionPrice(%x SPC %y);
			case "G":
				%price = $RoB::Dynamic::CoreBusPrice * %Bcount;
				%Bcount++;
				%price += GetCongestionPrice(%x SPC %y);
			default:
				%price = $RoB::Dynamic::CoreBusPrice * %Bcount;
				%Bcount++;
				%price += GetCongestionPrice(%x SPC %y);
		}
		%plyrworth += %price;
	}
	%plyrworth += $RoB::PData[%blid, money];
	%plyrworth += ($RoB::PData[%blid, fud] + $RoB::PData[%blid, mat] + $RoB::PData[%blid, des] + $RoB::PData[%blid, eng] + $RoB::PData[%blid, tec] + $RoB::PData[%blid, gas]) * 15;
	if(%plyrworth != $RoB::PData[%blid, networth] && %plyrworth !$= $RoB::PData[%blid, networth]) { //added the string check becasue I'm getting some "from $x to $x" fixes and I can't explain why.
		echo("worthfix: (" @ %blid @ ") worth adusted from $" @ $RoB::PData[%blid, networth] @ " to $" @ %plyrworth @ ".");
		AddEvent("worthfix: (" @ %blid @ ") worth adusted from $" @ $RoB::PData[%blid, networth] @ " to $" @ %plyrworth @ ".");
		$RoB::PData[%blid, networth] = %plyrworth;
	}
}

function ValueValidation()
{
	$RoB::Log[total, plotvalue] = 0;
	$RoB::Log[total, plotextravalue] = 0;
	for(%x = $RoB::Dynamic::MinX; %x <= $RoB::Dynamic::MaxX; %x++) {
		for(%y = $RoB::Dynamic::MinY; %y <= $RoB::Dynamic::MaxY; %y++){
			%plot = %x SPC %y;
			%plotval = 0;
			%extraval = 0;
			if(isObject($RoB::Plot[%x, %y])) {
				initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
				while(%target=containersearchnext()) {
					if(%target.isplanted) {
						%bx = %target.getdatablock().bricksizeX;
						%by = %target.getdatablock().bricksizeY;
						%bz = %target.getdatablock().bricksizeZ;
						%design = GetDesignCost(getword(%target.position, 2), %bz);
						if(%target.getdatablock().getname() !$= "brickProductionData" && %target.getdatablock().getname() !$= "brickStorageData" && %target.getdatablock().getname() !$= "brickSalePointData" && %target.getdatablock().getname() !$= "brickSpawnPointData") {
							%cost = (%bx * %by * %bz);
							%dolfactor += %cost;
							%cost += (%design + 1) * 15;
							%plotval += %cost;
							%matfactor += 15;
						} else %plotval += %design * 15;
						%desfactor += 15 * %design;
						%plotval += GetEngCost(%target) * 7.5;
						%engfactor += GetEngCost(%target) * 5;
						%tecfactor += GetTechCost(%target) * 15;
						//%events = getBrickEventTotalPrice(%target) * 15;
						//%eventfactor += %events;
						//%plotval += %events;
						%extraval += (GetEngCost(%target)*10) + (GetTechCost(%target)*15);
					}
				}
				if(%plotval !$= $RoB::Plot[%x, %y].value) { //why is this a string comparison? Because integer comparisons sometimes read false positives: "(120315 old vs. 120315 new)"
					echo("ERROR IN VALUE VALIDATION AT " @ %X SPC %Y @ "! (" @ $RoB::Plot[%x, %y].value @ " old vs. " @ %plotval @ " new)");
					$RoB::Plot[%x, %y].value = %plotval;
				}
				if(%extraval != $RoB::Plot[%x, %y].extravalue) {
					echo("ERROR IN EXTRA VALUE VALIDATION AT " @ %X SPC %Y @ "! (" @ $RoB::Plot[%x, %y].extravalue @ " old vs. " @ %extraval @ " new)");
					$RoB::Plot[%x, %y].extravalue = %extraval;
				}
				if(%plotval+%extraval > %maxval) %maxval = %plotval+%extraval;
				$RoB::Log[total, plotvalue] += %plotval;
				$RoB::Log[total, plotextravalue] += %extraval;
			}
		}
	}
	echo("$$ (no spec.): " @ %dolfactor @ " / f$ (estimated): " @ %matfactor*1.25 @ " / m$: " @ %matfactor @ " / d$: " @ %desfactor @ " / e$: " @ %engfactor @ " / t$: " @ %tecfactor);
	echo("maximum lot price (with extra): " @ %maxval);
	echo("total plot B-value (no extra): " @ $RoB::Log[total, plotvalue]);
	echo("total extra plot value: " @ $RoB::Log[total, plotextravalue]);
}

function ValueCheck(%client)
{
	%OK = true;
	%M = 0;
	for(%i = 2; $RoB::Property[%client.bl_id, %i] !$= ""; %i++) {
		%x = getword($RoB::Property[%client.bl_id, %i], 0);
		%y = getword($RoB::Property[%client.bl_id, %i], 1);
		if(strpos($RoB::Property[%client.bl_id, %i], "to", 0) == -1 && $RoB::Plot[%x, %y].type !$= "R") {
			%bizzes++;
			%hasbiz = true;
		}
	}
	switch(%bizzes) {
		case 0:
			%M = 0;
		case 1:
			%M = 10000;
		case 2:
			%M = 30000;
		case 3:
			%M = 70000;
		case 4:
			%M = 120000;
		default:
			%M = 180000;
	}
	if($RoB::Property[%client.bl_id, 1] $= "") %i = 2;
	else %i = 1;
	while($RoB::Property[%client.bl_id, %i] !$= "") {
		%x = getword($RoB::Property[%client.bl_id, %i], 0);
		%y = getword($RoB::Property[%client.bl_id, %i], 1);
		if(($RoB::Plot[%x, %y].type !$= "R" && $RoB::Plot[%x, %y].value < %M) || ($RoB::Plot[%x, %y].type $= "R" && $RoB::Plot[%x, %y].value < $RoB::Dynamic::CoreResPrice && %hasbiz)) {
			if(!%j) {
				%OK = false;
				messageclient(%client, "", "\c4You require a property value from bricks of $" @ %M @ " per business and $" @ $RoB::Dynamic::CoreResPrice @ " per home to buy more land!");
			}
			if(%j >= 3) {
				messageclient(%client, "", "\c4I could go on, but that should give you something to work on.");
			} else {
				messageclient(%client, "", "\c7Property \c6" @ $RoB::Plot[%x, %y].name @ "\c7 only has a brick value of \c6$" @ $RoB::Plot[%x, %y].value);
				%j++;
			}
		}
		%i++;
	}
	return %OK;
}


function EventCharges(%client)
{
	%plot = FindPlotFromObject(%client.wrenchBrick);
	%plotx = getword(%plot, 0);
	%ploty = getword(%plot, 1);
	%owner = $RoB::Plot[%plotx, %ploty].blid;
	if(!%client.robadmin) {
		$RoB::PData[%owner, tec] -= %client.eventPricing;
		if($RoB::PData[%owner, tec] < 0 && %client.eventUse) {
			commandToClient(%client, 'MessageBoxOK', "ERROR", "You don't have enough Technology! All events have been cleared from the brick.");
			servercmdClearEvents(%client);
			return;
		} else if(%client.eventPricing > 0) {
			MessageClient(%client, "", "\c2You spent " @ %client.eventPricing @ " Technology by changing the brick's events.");
		} else if(%client.eventPricing < 0) {
			MessageClient(%client, "", "\c2You gained " @ mabs(%client.eventPricing) @ " Technology by changing the brick's events.");
		} else {
			MessageClient(%client, "", "\c2You changed the brick's events.");
		}
	}
	if(!$brickload) {
		AddEvent("events edited: " @ %client.name @ " (" @ %client.bl_id @ ") changed a brick's events at plot (" @ %plotx @ ", " @ %ploty @ ").");
		$RoB::Plot[%plotx, %ploty].extravalue += %client.eventPricing * 15;
		//CheckForProdChange(%plot);
		$RoB::Log[total, extravalue] += %client.eventPricing * 15;
		//if($RoB::Log[total, plyrplots] != 0) $RoB::Log[avg, plotvalue] = $RoB::Log[total, plotvalue] / $RoB::Log[total, plyrplots];
		//if($RoB::PData[%owner, tec] > 100) $RoB::PData[%owner, tec] = 100;
		if(isobject(findClientByBL_ID(%owner))) ServerCmdRoB2GUIGetPlayerInfo(findClientByBL_ID(%owner));
	}
	%client.eventPricing = "";
	%client.eventUse = false;
}

function getBrickEventTotalPrice(%brick)
{
	%price = 0;
	for(%i = 0; %i < %brick.numEvents; %i++) {
		eval("%output = %brick.eventOutput" @ %i @ ";");
		switch$(%output) {
			case "disappear":
				%price += 5;
			case "playSound":
				%price += 10;
			case "bottomPrint":
				%price += 3;
		}
	}
	return %price;
}

function getBrickEventPrice(%brick, %event)
{
	eval("%output = %brick.eventOutput" @ %event @ ";");
	switch$(%output) {
		case "disappear":
			return 5;
		case "playSound":
			return 10;
		case "bottomPrint":
			return 3;
		default:
			return 0;
	}
}



function PropertyAllowablePlant(%client, %brick, %bx, %by, %bz)
{
	if(%client.RoBadmin) return "ADMIN";
	%plot = FindPlotFromObject(%brick);
	%owner = FindPlotOwnerBLID(%plot);
	if(%client.bl_id != %owner) return "NOTOWNER";
	%x = getword(%brick.gettransform(), 0);
	%y = getword(%brick.gettransform(), 1);
	if(%brick.angleID % 2 == 0) {
		%xmin = %x - (0.25 * %bx);
		%xmax = %x + (0.25 * %bx);
		%ymin = %y - (0.25 * %by);
		%ymax = %y + (0.25 * %by);
	} else {
		%xmin = %x - (0.25 * %by);
		%xmax = %x + (0.25 * %by);
		%ymin = %y - (0.25 * %bx);
		%ymax = %y + (0.25 * %bx);
	}
	%plotx = getword(%plot, 0);
	if(strpos(%plotx, "to", 0) >= 0) {
		%px = getsubstr(%plotx, 0, strpos(%plotx, "to", 0));
		%plotminx = (%px * 16);
		if(%px >= 0) %plotminx += (mfloor(%px / 2) * 8) + 16;
		else {
			%plotminx += (mceil(%px / 2) * 8) + 16;
			%plotminx -= 8;
		}
		%plotmaxx = %plotminx + 8;
		%nowallx = true;
	} else {
		%plotminx = (%plotx * 16);
		if(%plotx >= 0) %plotminx += mfloor(%plotx / 2) * 8;
		else {
			%plotminx += (mceil(%plotx / 2) * 8);
			if(mabs(%plotx) % 2 == 1) %plotminx -= 8;
		}
		%plotmaxx = %plotminx + 16;
	}
	%ploty = getword(%plot, 1);
	if(strpos(%ploty, "to", 0) >= 0) {
		%py = getsubstr(%ploty, 0, strpos(%ploty, "to", 0));
		%plotminy = (%py * 16);
		if(%py >= 0) %plotminy += (mfloor(%py / 2) * 8) + 16;
		else {
			%plotminy += (mceil(%py / 2) * 8) + 16;
			%plotminy -= 8;
		}
		%plotmaxy = %plotminy + 8;
		%nowally = true;
	} else {
		%plotminy = (%ploty * 16);
		if(%ploty >= 0) %plotminy += mfloor(%ploty / 2) * 8;
		else {
			%plotminy += (mceil(%ploty / 2) * 8);
			if(mabs(%ploty) % 2 == 1) %plotminy -= 8;
		}
		%plotmaxy = %plotminy + 16;
	}
	if(%xmin < %plotminx || %xmax > %plotmaxx || %ymin < %plotminy || %ymax > %plotmaxy || getword(%brick.gettransform(), 2) - (%bz * 0.099) < 0) return "OVERLAP";
	//set up a build range and check opposite corners of the brick
	if(%nowallx || %nowally) {
		if(%nowallx) %xbr = 2.5;
		else %xbr = 0;
		if(%nowally) %ybr = 2.5;
		else %ybr = 0;
		if(((%xmin > %plotminx + %xbr && %xmin < %plotmaxx - %xbr && %ymin > %plotminy + %ybr && %ymin < %plotmaxy - %ybr) || (%xmax > %plotminx + %xbr && %xmax < %plotmaxx - %xbr && %ymax > %plotminy + %ybr && %ymax < %plotmaxy - %ybr) || (%xmin < %plotminx + %xbr && %xmax > %plotmaxx - %xbr) || (%ymin < %plotminy + %ybr && %ymax > %plotmaxy - %ybr)) && getword(%brick.gettransform(), 2) - (%bz * 0.1) < 3.8) return "CLEARPATH";
	}
	if((%bz * 0.1) + getword(%brick.gettransform(), 2) > (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2))) return "TOOHIGH";
	if(%brick.getdatablock().getname() $= "brickProductionData") {
		if(!isbusiness(%plot)) return "BUSONLY";
		initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
		while(%target=containersearchnext()) {
			if(%target != %brick && %target.getdatablock().getname() $= "brickProductionData") return "PRODLIM";
		}
	} else if(%brick.getdatablock().getname() $= "brickStorageData") {
		initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
		while(%target=containersearchnext()) {
			if(%target != %brick && %target.getdatablock().getname() $= "brickStorageData") %storcount++;
		}
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "R":
				%storlim = 0;
			case "P":
				%storlim = 0;
			default:
				%storlim = 6 * mceil($RoB::Plot[%plotx, %ploty].prodfactor);
		}
		if(%storcount >= %storlim) return "STORLIM";
	} else if(%brick.getdatablock().getname() $= "brickSalePointData" && !isbusiness(%plot)) return "BUSONLY";
	else if(%brick.getdatablock().getname() $= "brickSpawnPointData" && $RoB::Plot[%plotx, %ploty].type !$= "R") return "RONLY";
	initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
	if(%brick.getdatablock().getname() $= "brickSpawnPointData") {
		while(%target=containersearchnext()) {
			if(%target != %brick && %target.getdatablock().getname() $= "brickSpawnPointData") %spcount++;
		}
	}
	if(%spcount >= 1) return "SPLIM";
	return "OK";
}

function FormatLinks(%text)
{
	for(%i = 0; %i < getwordcount(%text); %i++) {
		%word = getword(%text, %i);
		if(strlwr(getsubstr(%word, 0, 7)) $= "http://") {
			%word = "<a:" @ getsubstr(%word, 7, strlen(%word)-7) @ ">" @ getsubstr(%word, 7, strlen(%word)-7) @ "</a>";
		}
		if(%return !$= "") %return = %return @ " ";
		%return = %return @ %word;
	}
	return %return;
}