$RoB::MapDir = "Slate"; //This is the directory in your /saves/ folder for the map you will be using.
									//As far as I know, just take all the spaces out of the map name
										//however most flat maps share the "Slate" folder regardless of map name.
									//If you want to be sure, save something from that map and then see what folder you get.

$RoB::APrint = 46; //This should point to your "A" print and is used for clearing and indicating prints on lots no longer owned.
					//Making it blank is a bad idea because then new owners won't know which of their bricks are prints.
					//Last I checked, 46 is the correct number on a clean install but to be absolutely sure,
					//you should F11 an A print yourself and check it.
					
$RoB::GroundLevel = 0; //This is how high off the ground (in plates) the "ground level" is. [Default 0]
	//This will effectively pad the zero-design level so players must build higher than the standard level size to start paying design.
	//It's useful if you want to impose a "basement" without charging design for the "ground".


$RoB::LevelHeight = 32; //This is how tall each level is (in plates). [Default 32]
						//Once a player exceeds a given level, each brick costs an additional design.
						//Note that LevelHeight times 5, plus ground level, is the height cap of the city in plates.
						//testing found that 300 plates was way too high and there was no meaningful construction within a game at that height; only signs and facades.
						//the current default of 160 resulted in a prettier city.
						
$RoB::TransparentColors = " 20 21 22 23 24 25 26 27 28 29 30 57 58 59 60 ";
						//All of the transparent colors in the set, other than the restricted colors of 61, 62, and 63, which are used for industry bricks.
						//Paints with transparency have an engineering cost.
						//Note the spaces at the beginning and end; this made programming simpler and must remain.

	//the below do not need to be edited.

//$RoBGUI::Version = "11.01.05"; //not used in the curent version
//$RoBGUI::lastupdate = "11.01.05"; //not used in the curent version
$RoBGUI::DLURL = "www.dropbox.com/s/vnfjf7cydinx5zm/GUI_RoB2.zip?dl=1"; //link to the GUI download
$RoBGUI::RTBLink = "rtb-2992"; //rtb link to the GUI download
$PaintFXList = "flatPaintProjectile pearlPaintProjectile chromePaintProjectile glowPaintProjectile blinkPaintProjectile swirlPaintProjectile rainbowPaintProjectile stablePaintProjectile jelloPaintProjectile";
	//static list of color and shape FX projectiles; unlikely to ever change.