//RoB client with limited jets
datablock PlayerData(PlayerRoB : PlayerStandardArmor)
{
	minJetEnergy = 0.001;
	jetEnergyDrain = 0.027;
	canJet = 1;
	rechargeRate = 0;

	uiName = "RoB Player";
	showEnergyBar = true;
};

function PlayerRoB::OnTrigger(%this, %player, %type, %bool)
{
	Parent::OnTrigger(%this, %player, %type, %bool);
	if(%type == 4 && $RoB::Dynamic::LastUpdate !$= "" && %player.validgas) {
		$RoB::PData[%player.client.bl_id, gas] = mceil(%player.getenergylevel());
		$RoB::TmpGas[%player.client.bl_id] = mfloor(1000 * %player.getenergylevel()) / 1000;
		if($RoB::TmpGas[%player.client.bl_id] <= %this.jetEnergyDrain) $RoB::TmpGas[%player.client.bl_id] = "Empty";
	}
}

function PlayerRoB::OnDeath(%this, %player, %a, %b, %c, %d) //just in case
{
	$RoB::PData[%player.client.bl_id, gas] = mceil(%player.getenergylevel());
	$RoB::TmpGas[%player.client.bl_id] = mfloor(1000 * %player.getenergylevel()) / 1000;
	if($RoB::TmpGas[%player.client.bl_id] <= %this.jetEnergyDrain) $RoB::TmpGas[%player.client.bl_id] = "Empty";
	Parent::OnDeath(%this, %player, %a, %b, %c, %d);	
}