function serverCmdRoB2GUIGetText(%client, %text)
{
	commandToClient(%client, 'RoB2GUIGetText', 0, 0);
	%path = "config/Rise of Blockland/text/" @ %text @ ".txt";
	discoverFile(%path);
	if(!isFile(%path)) {
		commandToClient(%client, 'RoB2GUIGetText', "ERROR: text not found.", 1);
		commandToClient(%client, 'RoB2GUIGetText', 0, 2);
		return;
	}
	%file = new fileobject();
	%file.openforread(%path);
	while(!%file.isEoF()) {
		%text = %file.readline();
		%text = RoB2GUIpreparetextforsend(%text);
		if(strlen(%text) > 250) {
			%send = getSubStr(%text, 0, 250);
			%pos = 250;
			if(getSubStr(%send, strlen(%send) - 2, 2) $= "\\c"){
				%send = getSubStr(%send, 0, strlen(%send) - 2);
				%pos -= 2;
			} else if(getSubStr(%send, strlen(%send) - 1, 1) $= "\\"){
				%send = getSubStr(%send, 0, strlen(%send) - 1);
				%pos -= 1;
			}
			commandToClient(%client, 'RoB2GUIGetText', %send, 1);
			%done = false;
			while(!%done) {
				if(%pos + 250 >= strlen(%text)) {
					%send = getSubStr(%text, %pos, strlen(%text) - %pos);
					%done = true;
				} else {
					%send = getSubStr(%text, %pos, 250);
					%pos = %pos + 250;
					if(getSubStr(%send, strlen(%send) - 2, 2) $= "\\c"){
						%send = getSubStr(%send, 0, strlen(%send) - 2);
						%pos -= 2;
					} else if(getSubStr(%send, strlen(%send) - 1, 1) $= "\\"){
						%send = getSubStr(%send, 0, strlen(%send) - 1);
						%pos -= 1;
					}
				}
				commandToClient(%client, 'RoB2GUIGetText', %send, 1);
			}
		} else {
			commandToClient(%client, 'RoB2GUIGetText', %text, 1);
			if(!%progress) %progress = 1;
		}
	}
	commandToClient(%client, 'RoB2GUIGetText', 0, 2);
}

function RoB2GUIpreparetextforsend(%text)
{
	//%text = strreplace(%text, "\\", "\\\\");
	//%text = strreplace(%text, "\"", "\\\"");
	//%text = strreplace(%text, "\'", "\\\'");
	%text = strreplace(%text, "\\c0", "\c0");
	%text = strreplace(%text, "\\c1", "\c1");
	%text = strreplace(%text, "\\c2", "\c2");
	%text = strreplace(%text, "\\c3", "\c3");
	%text = strreplace(%text, "\\c4", "\c4");
	%text = strreplace(%text, "\\c5", "\c5");
	%text = strreplace(%text, "\\c6", "\c6");
	%text = strreplace(%text, "\\c7", "\c7");
	%text = strreplace(%text, "\\c8", "\c8");
	%text = strreplace(%text, "\\c9", "\c9");
	//%text = strreplace(%text, "\n", "\\n");
	return %text @ "\n";
}

function ServerCmdRoB2Pong(%client)
{
	cancel(%client.ping);
}

function RoB2NoPong(%client)
{
	messageclient(%client, "", "YOU MUST HAVE THE RoB 2 GUI TO BUILD HERE. " @ "<a:" @ $RoBGUI::DLURL @ ">" @ "Download the GUI here. </a>");
	messageclient(%client, "", "\c6Please ask other players if you need help.");
}

function ServerCmdIsRoB2(%client)
{
	if(!isobject(%client.player)) return;
	if($RoB::TmpGas[%client.bl_id] $= "Empty") %gas = "EMPTY";
	else %gas = mceil(%client.player.getenergylevel());
	commandtoclient(%client, 'IsRoB2', %gas);
}

//function servercmdRoB2GUICheckVersion(%client, %version)
//{
//	if($RoB2GUI::Version $= "") return;
//	%numversion = strreplace(%version, ".", "");
//	%numlatest = strreplace($RoB2GUI::Version, ".", "");
//	if(%numversion < %numlatest) commandtoclient(%client, 'MessageBoxOK', "Update Available", "You are running an outdated version of The Rise of Blockland 2 GUI!\nYour version is: " @ %version @ "\nThe Latest version is: " @ $RoB2GUI::LatestVersion @ "\nPlease update here: " @ $RoB2GUI::DLURL);
//	commandtoclient(%client, 'RoB2GUIcheckedversion');
//}

//function servercmdRoB2GUICheckUpdates(%client, %update)
//{
//	if($RoB2GUI::Version $= "") return;
//	%numupdate = strreplace(%update, ".", "");
//	%numlatest = strreplace($RoB2GUI::lastupdate, ".", "");
//	if(%numupdate < %numlatest) commandtoclient(%client, 'RoB2GUIflashupdate', $RoB2GUI::lastupdate); //to do ?
//}

function ServerCmdRoB2GUIGetPlayerInfo(%client)
{
	if(!isobject(%client) || %client.bl_id $= "") return;
	if($RoB::PData[%client.bl_id, name] $= "" && !$brickload) RoBNewPlayer(%client);
	$RoB::PData[%client.bl_id, name] = %client.name;
	commandtoclient(%client, 'RoB2GUIGetInfo', "PlayerName", %client.name);
	commandtoclient(%client, 'RoB2GUIGetInfo', "PlayerBLID", %client.bl_id);
	commandtoclient(%client, 'RoB2GUIGetInfo', "PlayerMoney", $RoB::PData[%client.bl_id, money]);
	commandtoclient(%client, 'RoB2GUIGetInfo', "PlayerFud", $RoB::PData[%client.bl_id, fud], evaluateCapacity(%client.bl_id));
	commandtoclient(%client, 'RoB2GUIGetInfo', "PlayerMat", $RoB::PData[%client.bl_id, mat], evaluateCapacity(%client.bl_id));
	commandtoclient(%client, 'RoB2GUIGetInfo', "PlayerEng", $RoB::PData[%client.bl_id, eng], evaluateCapacity(%client.bl_id));
	commandtoclient(%client, 'RoB2GUIGetInfo', "PlayerDes", $RoB::PData[%client.bl_id, des], evaluateCapacity(%client.bl_id));
	commandtoclient(%client, 'RoB2GUIGetInfo', "PlayerTec", $RoB::PData[%client.bl_id, tec], evaluateCapacity(%client.bl_id));
}

function ServerCmdRoB2GUIGetPlotInfo(%client)
{
	for(%i = 1; $RoB::Property[%client.bl_id, %i] !$= "" || %i == 1; %i++) {
		if(%i == 1 || %lname $= "") %new = true;
		else %new = false;
		%lx = getword($RoB::Property[%client.bl_id, %i], 0);
		%ly = getword($RoB::Property[%client.bl_id, %i], 1);
		%lname = $RoB::Plot[%lx, %ly].name;
		%loc = getPlotCenter(%lx SPC %ly);
		commandtoclient(%client, 'RoB2GUIGetPropList', %lname, %loc, %new);
	}
	if(!isobject(%client.player))  return;
	%plot = findPlotFromObject(%client.player);
	%x = getword(%plot, 0);
	%y = getword(%plot, 1);
	%plotobj = $RoB::plot[%x, %y];
	if(!isObject(%plotobj)) {
		commandtoclient(%client, 'RoB2GUIGetPlotInfo', "", "", "", "Outside City", "", "", 0);
		return;
	}
	%plotname = $RoB::plot[%x, %y].name;
	%plotowner = $RoB::plot[%x, %y].owner;
	if($RoB::Plot[%x, %y].blid != -1) %plotowner = %plotowner SPC "(" @ $RoB::plot[%x, %y].blid @ ")";
	if(strpos(%x SPC %y, "to", 0) == -1) %plotcoords = %x SPC %y;
	switch$($RoB::plot[%x, %y].type)
	{
		case "R":
			%plottype = "Residential";
		case "F":
			%plottype = "Food";
		case "M":
			%plottype = "Material";
		case "D":
			%plottype = "Design";
		case "E":
			%plottype = "Engineering";
		case "T":
			%plottype = "Technology";
		case "G":
			%plottype = "Gas";
		case "C":
			%plottype = "City-Owned";
		case "U":
			%plottype = "Unowned";
			%covers = 1;
		case "P":
			%plottype = "Road";
		default:
			%plottype = "Outside City";
			%plotcoords = "";
	}
	if($RoB::plot[%x, %y].blid == %client.bl_id || (%client.robadmin && %plottype !$= "Outside City")) %covers = 2;
	if($RoB::plot[%x, %y].blid == -1) {
		if(%plottype !$= "City-Owned") {
			%rp = GetPlotPrice(%client, "R") + GetCongestionPrice(%plot);
			%bp = GetPlotPrice(%client, $RoB::Plot[%x, %y].type) + GetCongestionPrice(%plot);
			%rp += $RoB::plot[%x, %y].value + $RoB::plot[%x, %y].extravalue;
			%bp += $RoB::plot[%x, %y].value + $RoB::plot[%x, %y].extravalue;
			%valstring = "$" @ %rp @ "(Home)/$" @ %bp @ "(Work)";
		} else {
			if(strpos(%x, "to", 0) != -1) {
				%xa = getsubstr(%x, 0, strpos(%x, "to", 0));
				%xb = %xa + 1;
			} else {
				%xa = %x;
				%xb = %x;
			}
			if(strpos(%y, "to", 0) != -1) {
				%ya = getsubstr(%y, 0, strpos(%y, "to", 0));
				%yb = %ya + 1;
			} else {
				%ya = %y;
				%yb = %y;
			}
			if(!$RoB::plot[%x, %y].repoed) $RoB::plot[%x, %y].value = 0; //roads that are unowned and unrepossessed are forced to zero value.
			if($RoB::Plot[%xa, %ya].blid == %client.bl_id && $RoB::Plot[%xa, %yb].blid == %client.bl_id && $RoB::Plot[%xb, %ya].blid == %client.bl_id && $RoB::Plot[%xb, %yb].blid == %client.bl_id) {
				%covers = 1;
				%pp = $RoB::Dynamic::CoreResPrice + $RoB::plot[%x, %y].value + $RoB::plot[%x, %y].extravalue;
				%valstring = "$" @ %pp @ " ($ " @ $RoB::Plot[%x, %y].value @ " bricks)";
			} else %valstring = "N/A";
			%plotowner = "City";
		}
	} else {
		%pp = GetPlotPrice(%client, $RoB::plot[%x, %y].type) + GetCongestionPrice(%plot);
		if($RoB::plot[%x, %y].blid == %client.bl_id) {
			if($RoB::plot[%x, %y].type $= "R") %pp = GetPlotPrice(%client, $RoB::plot[%x, %y].type) - $RoB::Dynamic::CoreResPrice + GetCongestionPrice(%plot);
			else %pp = GetPlotPrice(%client, $RoB::plot[%x, %y].type) - $RoB::Dynamic::CoreBusPrice + GetCongestionPrice(%plot);
			if(strpos(%x, "to", 0) != -1 || strpos(%y, "to", 0) != -1) %pp = $RoB::Dynamic::CoreResPrice;
			%pp += $RoB::plot[%x, %y].value;
			%pp += $RoB::plot[%x, %y].extravalue;
			%valstring = "$" @ %pp @ " ($" @ $RoB::plot[%x, %y].value @ " bricks)";
		} else {
			%valstring = "($" @ $RoB::plot[%x, %y].value @ " bricks)";
		}
	}
	if($RoB::plot[%x, %y].name $= "road") {
		if(%x < 0) %xside = "W. ";
		else if(%x > 1) %xside = "E. ";
		if(%y < 0) %yside = "S. ";
		else if(%y > 1) %yside = "N. ";
		if($RoB::RoadName[x, %x] !$= "") {
			if($RoB::RoadName[y, %y] !$= "") %plotname = $RoB::RoadName[y, %y] SPC "&" SPC $RoB::RoadName[x, %x];
			else %plotname = %yside @ $RoB::RoadName[x, %x];
		} else if($RoB::RoadName[y, %y] !$= "") %plotname = %xside @ $RoB::RoadName[y, %y];
		commandtoclient(%client, 'RoB2GUIGetPlotInfo', %plotname, "N/A", %plotowner, %plottype, %valstring, "Road", %covers);
	} else commandtoclient(%client, 'RoB2GUIGetPlotInfo', %plotname, %plotcoords, %plotowner, %plottype, %valstring, $RoB2GUI::PlotBuyList, %covers);
}

function ServerCmdRoB2PlotBuy(%client, %zoning)
{
	if(isObject(%client.player)) {
		%plot = findPlotFromObject(%client.player);
		%x = getword(%plot, 0);
		%y = getword(%plot, 1);
		if(!isObject($RoB::Plot[%x, %y])) {
			ServerCmdRoB2GUIGetPlotInfo(%client);
			return;
		}
		if($RoB::Plot[%x, %y].type $= "U") {
			switch(%zoning) {
				case 0:
					%type = "R";
					%price = GetPlotPrice(%client, %type);
				case 1:
					%type = "F";
					%price = GetPlotPrice(%client, %type);
				case 2:
					%type = "M";
					%price = GetPlotPrice(%client, %type);
				case 3:
					%type = "D";
					%price = GetPlotPrice(%client, %type);
				case 4:
					%type = "E";
					%price = GetPlotPrice(%client, %type);
				case 5:
					%type = "T";
					%price = GetPlotPrice(%client, %type);
				case 6:
					%type = "G";
					%price = GetPlotPrice(%client, %type);
				default:
					return;
			}
			if(%type !$= "R" && $RoB::Property[%client.bl_id, 1] $= "") {
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "You're not allowed to buy a non-residence unless you have a residence!");
				return;
			}
			for(%i = 2; $RoB::Property[%client.bl_id, %i] !$= ""; %i++) {
				%px = getword($RoB::Property[%client.bl_id, %i], 0);
				%py = getword($RoB::Property[%client.bl_id, %i], 1);
				if($RoB::Plot[%px, %py].type !$= "R") {
					%indone = $RoB::Plot[%px, %py].type;
					if(%indone !$= %type) {
						if(%indtwo $= "") %indtwo = %indone;
						else if(%indtwo !$= %indone) %maxind = true;
					}
				}
			}
			if(%type $= "R" && %indone $= "" && $RoB::Property[%client.bl_id, 1] !$= "") {
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "You're not allowed to buy another residence without a source of income!");
				return;
			} else if(%type !$= "R" && %maxind) {
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "You're not allowed to be in more than 2 industries!");
				return;
			}
			if((%x $= "-1" || %x $= "0" || %x $= "1" || %x $= "2") && (%y $= "-1" || %y $= "0" || %y $= "1" || %y $= "2")) {
				for(%i = -1; %i <= 2; %i++) {
					for(%j = -1; %j <= 2; %j++) {
						if($RoB::Plot[%i, %j].blid == %client.bl_id) {
							commandtoclient(%client, 'MessageBoxOK', "ERROR", "You're not allowed to buy two lots around Origin Park!");
							return;
						}
					}
				}
			}
			if($RoB::Property[%client.bl_id, 1] !$= "" || %type !$= "R") {
				if(!ValueCheck(%client)) return;
			}
			//%price += GetCongestionPrice(%plot);
			%finalprice = %price + $RoB::Plot[%x, %y].value + $RoB::plot[%x, %y].extravalue;
			if($RoB::PData[%client.bl_id, money] >= %finalprice || %finalprice == 0) {
				$RoB::Plot[%x, %y].blid = %client.bl_id;
				$RoB::Plot[%x, %y].owner = %client.name;
				$RoB::Plot[%x, %y].type = %type;
				$RoB::Plot[%x, %y].newbiz = true;
				$RoB::Plot[%x, %y].repoed = false;
				$RoB::PData[%client.bl_id, money] -= %finalprice;
				if(%type $= "R") %i = 1;
				else %i = 2;
				while($RoB::Property[%client.bl_id, %i] !$= "") %i++;
				$RoB::Property[%client.bl_id, %i] = %plot;
				if(%indtwo !$= "" && %type !$= "R") {
					commandtoclient(%client, 'MessageBoxOK', "Buy Property", "Success! You bought this property for: $" @ %finalprice @ "\nRemember, being in 2 different types of industry cuts all production in half!");
					$RoB::PData[%client.bl_id, twoind] = true; //twoind code
				} else commandtoclient(%client, 'MessageBoxOK', "Buy Property", "Success! You bought this property for: $" @ %finalprice);
				$RoB::Log[total, plyrplots]++;
				switch$(%type)
				{
					case "R":
					 	%plottype = "Residential";
					 	$RoB::Log[total, rplots]++;
					case "F":
			 			%plottype = "Food";
					 	$RoB::Log[total, fplots]++;
					case "M":
			 			%plottype = "Material";
					 	$RoB::Log[total, mplots]++;
					case "D":
			 			%plottype = "Design";
					 	$RoB::Log[total, dplots]++;
					case "E":
			 			%plottype = "Engineering";
					 	$RoB::Log[total, eplots]++;
					case "T":
			 			%plottype = "Technology";
					 	$RoB::Log[total, tplots]++;
					case "G":
			 			%plottype = "Gas";
					 	$RoB::Log[total, gplots]++;
				}
				%totalprod = GetTotalProd(%client.bl_id);
				%unit = mfloor(%totalprod * $RoB::Dynamic::CoreCashRate);
				%playercashcap = $RoB::Dynamic::PlayerCoreRateMax * %unit;
				%playercashamt = %playercashcap - ($RoB::PData[%client.bl_id, cashtimer] * %unit);
				if(%playercashamt < 0) %playercashamt = 0;
				%newunit = mfloor((%totalprod + $RoB::Plot[%x, %y].prodfactor) * $RoB::Dynamic::CoreCashRate);
				%newcap = $RoB::Dynamic::PlayerCoreRateMax * %newunit;
				$RoB::PData[$RoB::Plot[%x, %y].blid, cashtimer] = $RoB::Dynamic::PlayerCoreRateMax - mfloor(%playercashamt / %newunit);
				if($RoB::Plot[%x, %y].prodfactor > $RoB::Dynamic::CoreProdRate) messageclient(%client, "", "\c1The good development of this lot means that it already operates at " @ mfloor(($RoB::Plot[%x, %y].prodfactor * $RoB::Dynamic::CoreProdRate)*100) @ "% (with a good home).");
				ServerCmdRoB2GUIGetPlayerInfo(%client);
				ServerCmdRoB2GUIGetPlotInfo(%client);
				AddEvent("plotbuy: (" @ %x @ ", " @ %y @ ") bought as " @ %plottype @ " by (" @ %client.bl_id @ ") for $" @ %finalprice @ ".");
				//for(%cX = %x - 1; %cX <= %x + 1; %cX++) { //TO DO: congestion adjust for neighbors
				//	for(%cY = %y - 1; %cY <= %y + 1; %cY++) {
				//		if((%cX != %x || %cY != %y) && isObject($RoB::Plot[%sX, %sY]) && $RoB::Plot[%sX, %sY].type !$= "U") {
				//			%C = 0;
				//			for(%sX = %cX - 1; %sX <= %cX + 1; %sX++) {
				//				for(%sY = %cY - 1; %sY <= %cY + 1; %sY++) {
				//					if((%cX != %x || %cY != %y) && isObject($RoB::Plot[%sX, %sY]) && $RoB::Plot[%sX, %sY].type !$= "U") {
				//						%C++;
				//					}
				//				}
				//			}
				//			AddWorth($RoB::Plot[%cX, %cY].blid, 1250);
				//		}
				//	}
				//}
				$RoB::Log[total, plotvalue] += $RoB::Plot[%x, %y].value;
				if($RoB::Log[total, plyrplots] != 0) $RoB::Log[avg, plotvalue] = $RoB::Log[total, plotvalue] / $RoB::Log[total, plyrplots];
				$RoB::Log[avg, plyrplots] = $RoB::Log[total, plyrplots] / $RoB::Log[total, players];
			} else {
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "That would cost $" @ %finalprice @ "; you have only $" @ $RoB::PData[%client.bl_id, money] @ ".");
			}
		} else if($RoB::Plot[%x, %y].type $= "C") {
			if(!ValueCheck(%client)) return;
			%finalprice = $RoB::Dynamic::CoreResPrice + $RoB::Plot[%x, %y].value;
			if($RoB::PData[%client.bl_id, money] >= %finalprice) {
				$RoB::Plot[%x, %y].blid = %client.bl_id;
				$RoB::Plot[%x, %y].owner = %client.name;
				$RoB::Plot[%x, %y].type = "P";
				$RoB::Plot[%x, %y].repoed = false;
				$RoB::PData[%client.bl_id, money] -= %finalprice;
				commandtoclient(%client, 'MessageBoxOK', "Buy Property", "Success! You bought this road section for: $" @ %finalprice);
				ServerCmdRoB2GUIGetPlotInfo(%client);
				AddEvent("plotbuy: (" @ %x @ ", " @ %y @ ") bought as P by (" @ %client.bl_id @ ") for $" @ %finalprice @ ".");
			} else {
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "That would cost $" @ %finalprice @ "; you have only $" @ $RoB::PData[%client.bl_id, money] @ ".");
			}
		} else {
			commandtoclient(%client, 'MessageBoxOK', "ERROR", "You are not allowed to buy this property.");
		}
	} else {
		commandtoclient(%client, 'MessageBoxOK', "ERROR", "You must be standing in the plot you wish to buy.");
	}
}

function ServerCmdRoB2PlotSell(%client)
{
	if(isobject(%client.player)){
		%plot = findPlotFromObject(%client.player);
		%plotx = getword(%plot, 0);
		%ploty = getword(%plot, 1);
		if(!isObject($RoB::Plot[%plotx, %ploty])) return;
			if($RoB::Plot[%plotx, %ploty].blid == %client.bl_id) {
			initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
			while(%target=containersearchnext()) {
				if((%target.getdatablock().getname() $= "brickProductionData" || %target.getdatablock().getname() $= "brickStorageData" || %target.getdatablock().getname() $= "brickSalePointData" || %target.getdatablock().getname() $= "brickSpawnPointData") && %target.isplanted) %badbrick = true;
			}
			if(%badbrick) {
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "You must clear all industry bricks and spawns before selling.");
				return;
			}
			if(strpos(%plotx, "to", 0) != -1 || strpos(%ploty, "to", 0) != -1) {
				initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2) + 0.2) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2) - 0.21), $typemasks::fxbrickobjecttype);
				while(%target=containersearchnext()) {
					if(%target.isplanted()) {
						commandtoclient(%client, 'MessageBoxOK', "ERROR", "You must clear all bricks before selling a road section.");
						return;
					}
				}
			} else {
				%xa = %plotx - 1;
				%xb = %plotx + 1;
				%ya = %ploty - 1;
				%yb = %ploty + 1;
				if(($RoB::Plot[%plotx, %ya @ "to" @ %ploty].blid == %client.bl_id || $RoB::Plot[%plotx, %ploty @ "to" @ %yb].blid == %client.bl_id || $RoB::Plot[%xa @ "to" @ %plotx, %ploty].blid == %client.bl_id || $RoB::Plot[%plotx @ "to" @ %xb, %ploty].blid == %client.bl_id || $RoB::Plot[%xa @ "to" @ %plotx, %ya @ "to" @ %ploty].blid == %client.bl_id || $RoB::Plot[%xa @ "to" @ %plotx, %ploty @ "to" @ %yb, blid] == %client.bl_id || $RoB::Plot[%plotx @ "to" @ %xb, %ya @ "to" @ %ploty].blid == %client.bl_id || $RoB::Plot[%plotx @ "to" @ %xb, %ploty @ "to" @ %yb].blid == %client.bl_id) && !%client.lotswap) {
					commandtoclient(%client, 'MessageBoxOK', "ERROR", "You cannot sell this lot until you sell all dependent road sections.\nIf you just want to change lot type, ask the host for help.");
					return;
				}
			}
			if(%client.lotswap) %client.lotswap = false;
			switch$($RoB::Plot[%plotx, %ploty].type) {
				case "R":
					%price = GetPlotPrice(%client, "R") - $RoB::Dynamic::CoreResPrice;
					$RoB::Log[total, rplots]--;
					%type = "R";
				case "F":
					%price = GetPlotPrice(%client, "F") - $RoB::Dynamic::CoreBusPrice;
					$RoB::Log[total, fplots]--;
				case "M":
					%price = GetPlotPrice(%client, "M") - $RoB::Dynamic::CoreBusPrice;
					$RoB::Log[total, mplots]--;
				case "D":
					%price = GetPlotPrice(%client, "D") - $RoB::Dynamic::CoreBusPrice;
					$RoB::Log[total, dplots]--;
				case "E":
					%price = GetPlotPrice(%client, "E") - $RoB::Dynamic::CoreBusPrice;
					$RoB::Log[total, eplots]--;
				case "T":
					%price = GetPlotPrice(%client, "T") - $RoB::Dynamic::CoreBusPrice;
					$RoB::Log[total, tplots]--;
				case "G":
					%price = GetPlotPrice(%client, "G") - $RoB::Dynamic::CoreBusPrice;
					$RoB::Log[total, gplots]--;
				case "P":
					%price = $RoB::Dynamic::CoreResPrice;
				default:
					return;
			}
			if($RoB::Plot[%plotx, %ploty].type !$= "P") {
				$RoB::Log[total, plyrplots]--;
				//%price += GetCongestionPrice(%plot);
				%finalprice = %price + $RoB::Plot[%plotx, %ploty].value + $RoB::plot[%x, %y].extravalue;
				AddWorth(%client.bl_id, $RoB::Plot[%plotx, %ploty].stored * -15);
				%totalprod = GetTotalProd(%client.bl_id);
				%unit = mfloor(%totalprod * $RoB::Dynamic::CoreCashRate);
				%playercashcap = $RoB::Dynamic::PlayerCoreRateMax * %unit;
				%playercashamt = %playercashcap - ($RoB::PData[%client.bl_id, cashtimer] * %unit);
				if(%playercashamt < 0) %playercashamt = 0;
				%newunit = mfloor((%totalprod - $RoB::Plot[%plotx, %ploty].prodfactor) * $RoB::Dynamic::CoreCashRate);
				%newcap = $RoB::Dynamic::PlayerCoreRateMax * %newunit;
				$RoB::PData[$RoB::Plot[%x, %y].blid, cashtimer] = $RoB::Dynamic::PlayerCoreRateMax - mfloor(%playercashamt / %newunit);
				$RoB::Plot[%plotx, %ploty].blid = -1;
				$RoB::Plot[%plotx, %ploty].owner = "Unowned";
				$RoB::Plot[%plotx, %ploty].name = %plotx SPC %ploty;
				$RoB::Plot[%plotx, %ploty].type = "U";
				$RoB::Plot[%plotx, %ploty].produced = 0;
				$RoB::Plot[%plotx, %ploty].prodfrac = 0;
				$RoB::Plot[%plotx, %ploty].stored = 0;
				$RoB::Plot[%plotx, %ploty].capacity = 0;
				$RoB::Plot[%plotx, %ploty].closed = 0;
				$RoB::Plot[%plotx, %ploty].price = 15;
				initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
				while(%target=containersearchnext()) {
					if(%target.getdatablock().subcategory $= "Prints" ) %target.setPrint($RoB::APrint);
				}
				$RoB::Plot[%plotx, %ploty].newbiz = false;
				$RoB::PData[%client.bl_id, money] += %finalprice;
				
				RemoveLostProperties(%client.bl_id);
				
				//for(%i = 1; ($RoB::Property[%client.bl_id, %i] !$= "" || %i == 1); %i++) {
				//	%x = getword($RoB::Property[%client.bl_id, %i], 0);
				//	%y = getword($RoB::Property[%client.bl_id, %i], 1);
				//	if(%plotfound) $RoB::Property[%client.bl_id, (%i - 1)] = $RoB::Property[%client.bl_id, %i];
				//	else if(%mainres && $RoB::Plot[%x, %y].type $= "R") {
				//		$RoB::Property[%client.bl_id, 1] = $RoB::Property[%client.bl_id, %i];
				//		%plotfound = true;
				//	} else if((%x SPC %y) $= (%plotx SPC %ploty)) {
				//		$RoB::Property[%client.bl_id, %i] = "";
				//		if(%i == 1) %mainres = true;
				//		else %plotfound = true;
				//	}
				//}
				//if(%plotfound) $RoB::Property[%client.bl_id, (%i - 1)] = $RoB::Property[%client.bl_id, %i];
				
				
				// twoind code follows
				for(%i = 1; $RoB::Property[%client.bl_id, %i] !$= ""; %i++) {
					%x = getword($RoB::Property[%client.bl_id, %i], 0);
					%y = getword($RoB::Property[%client.bl_id, %i], 1);
					if($RoB::Plot[%x, %y].type !$= "R") {
						%temp = $RoB::Plot[%x, %y].type;
						if(!%B) %B = %temp;
						else if(%B !$= %temp) %B = "!";
					}
					CheckForProdChange($RoB::Property[%client.bl_id, %i]);
				}
				if(%B !$= "!") $RoB::PData[%client.bl_id, twoind] = false;
				// end twoind code
				commandtoclient(%client, 'MessageBoxOK', "Sell Property", "Success! You have gained $" @ %finalprice @ " from the sale of this property.");
				ServerCmdRoB2GUIGetPlayerInfo(%client);
				ServerCmdRoB2GUIGetPlotInfo(%client);
				AddEvent("plotsell: (" @ %plotx @ ", " @ %ploty @ ") sold by (" @ %client.bl_id @ ") for $" @ %finalprice @ ".");
				//for(%cX = %plotx - 1; %cX <= %plotx + 1; %cX++) { //TO DO: congestion adjustment of neighbors
				//	for(%cY = %ploty - 1; %cY <= %ploty + 1; %cY++) {
				//		if((%cX != %plotx || %cY != %ploty) && isObject($RoB::Plot[%sX, %sY]) !$= "" && $RoB::Plot[%sX, %sY].type !$= "U") {
				//			%C = 0;
				//			for(%sX = %cX - 1; %sX <= %cX + 1; %sX++) {
				//				for(%sY = %cY - 1; %sY <= %cY + 1; %sY++) {
				//					if((%cX != %plotx || %cY != %ploty) && isObject($RoB::Plot[%sX, %sY]) && $RoB::Plot[%sX, %sY].type !$= "U") {
				//						%C++;
				//					}
				//				}
				//			}
				//			AddWorth($RoB::Plot[%cX, %cY].blid, -1250); 
				//		}
				//	}
				//}
				$RoB::Log[total, plotvalue] -= $RoB::Plot[%plotx, %ploty].value;
				if($RoB::Log[total, plyrplots] != 0) $RoB::Log[avg, plotvalue] = $RoB::Log[total, plotvalue] / $RoB::Log[total, plyrplots];
				$RoB::Log[avg, plyrplots] = $RoB::Log[total, plyrplots] / $RoB::Log[total, players];
			} else {
				%finalprice = $RoB::Dynamic::CoreResPrice + $RoB::Plot[%x, %y].value;
				$RoB::Plot[%plotx, %ploty].blid = -1;
				$RoB::Plot[%plotx, %ploty].owner = "City";
				$RoB::Plot[%plotx, %ploty].type = "C";
				$RoB::PData[%client.bl_id, money] += %finalprice;
				commandtoclient(%client, 'MessageBoxOK', "Sell Property", "Success! You have gained $" @ %finalprice @ " from the sale of this road section.");
				ServerCmdRoB2GUIGetPlayerInfo(%client);
				ServerCmdRoB2GUIGetPlotInfo(%client);
				AddEvent("plotsell: (" @ %plotx @ ", " @ %ploty @ ") sold by (" @ %client.bl_id @ ") for $" @ %finalprice @ ".");
			}
		} else {
			commandtoclient(%client, 'MessageBoxOK', "ERROR", "You don't own this property!");
		}
	} else {
		commandtoclient(%client, 'MessageBoxOK', "ERROR", "You must be standing in the plot you wish to sell.");
	}
}

function ServerCmdRoB2RenamePlot(%client, %name)
{
	%name = getsubstr(%name, 0, 32);
	if(%name $= "") return;
	if(isobject(%client.player)){
		%plot = findPlotFromObject(%client.player);
		%x = getword(%plot, 0);
		%y = getword(%plot, 1);
		if(!isObject($RoB::Plot[%x, %y])) return;
		if($RoB::Plot[%x, %y].blid == %client.bl_id || %client.robadmin) {
			if(strpos(%x SPC %y, "to", 0) != -1) {
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "You are not allowed to rename roads."); 
				return;
			}
			for(%i = 0; %i < strlen(%name); %i++) {
				%char = getSubStr(%name, %i, 1);
				if(strpos("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ 1234567890!@#$%^&*()_=+[{]}|/?,<.>;\':\"", %char) == -1){
					commandtoclient(%client, 'MessageBoxOK', "ERROR", "Invalid character detected. You may only use characters normally found on an American keyboard, except you cannot use:\n~ ` - \\"); 
					return;
				}
				%text = %text @ %char;
			}
			$RoB::Plot[%x, %y].name = %text;
			ServerCmdRoB2GUIGetPlotInfo(%client);
		} else {
			commandtoclient(%client, 'MessageBoxOK', "ERROR", "You don't own this property!");
		}
	} else {
		commandtoclient(%client, 'MessageBoxOK', "ERROR", "You must be standing in the plot you wish to sell.");
	}
}

function ServerCmdRoB2Gather(%client, %dest)
{
	if(!isObject(%client.player)) return;
	%curplot = findPlotFromObject(%client.player);
	%plot = %client.activeplot;
	if(vectorDist(%curplot SPC "0", %plot SPC "0") > 34) return;
	%plotx = getword(%plot, 0);
	%ploty = getword(%plot, 1);
	if(!isobject($RoB::Plot[%plotx, %ploty]) || $RoB::Plot[%plotx, %ploty].blid != %client.bl_id || !isBusiness(%plot)) return;
	initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
	while(%target=containersearchnext()) {
		if(%target.getdatablock().getname() $= "brickProductionData" && %target.isplanted) %prodexists = 1;
	}
	if(!%prodexists) return;
	if(%client.spawn[1] $= "") {
		commandtoclient(%client, 'MessageBoxOK', "ERROR", "You cannot gather without a place of residence and a spawn brick.");
		return;
	}
	if(%dest $= "storage") {
		%room = $RoB::Plot[%plotx, %ploty].capacity - $RoB::Plot[%plotx, %ploty].stored;
		if(%room <= 0) %noroom = true;
		if(!%noroom && $RoB::Plot[%plotx, %ploty].produced > %room) {
			$RoB::Plot[%plotx, %ploty].stored = $RoB::Plot[%plotx, %ploty].capacity;
			$RoB::Plot[%plotx, %ploty].produced -= %room;
		} else if(!%noroom) {
			$RoB::Plot[%plotx, %ploty].stored += $RoB::Plot[%plotx, %ploty].produced;
			%room = $RoB::Plot[%plotx, %ploty].produced;
			$RoB::Plot[%plotx, %ploty].produced = 0;
		}
		%limit = evaluateCapacity(%client.bl_id);
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				%you = $RoB::PData[%client.bl_id, fud];
				%type = "food";
			case "M":
				%you = $RoB::PData[%client.bl_id, mat];
				%type = "material";
			case "D":
				%you = $RoB::PData[%client.bl_id, des];
				%type = "design";
			case "E":
				%you = $RoB::PData[%client.bl_id, eng];
				%type = "engineering";
			case "T":
				%you = $RoB::PData[%client.bl_id, tec];
				%type = "technology";
			case "G":
				%you = $RoB::PData[%client.bl_id, gas];
				%type = "gas";
				%limit = 100;
		}
	} else {
		%dest = "self";
		%limit = evaluateCapacity(%client.bl_id);
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				%room = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, fud];
				if(%room <= 0) %noroom = true;
				if(!%noroom && $RoB::Plot[%plotx, %ploty].produced > %room) {
					$RoB::PData[%client.bl_id, fud] = evaluateCapacity(%client.bl_id);
					$RoB::Plot[%plotx, %ploty].produced -= %room;
				} else if(!%noroom) {
					$RoB::PData[%client.bl_id, fud] += $RoB::Plot[%plotx, %ploty].produced;
					%room = $RoB::Plot[%plotx, %ploty].produced;
					$RoB::Plot[%plotx, %ploty].produced = 0;
				}
				%you = $RoB::PData[%client.bl_id, fud];
				%type = "food";
			case "M":
				%room = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, mat];
				if(%room <= 0) %noroom = true;
				if(!%noroom && $RoB::Plot[%plotx, %ploty].produced > %room) {
					$RoB::PData[%client.bl_id, mat] = evaluateCapacity(%client.bl_id);
					$RoB::Plot[%plotx, %ploty].produced -= %room;
				} else if(!%noroom) {
					$RoB::PData[%client.bl_id, mat] += $RoB::Plot[%plotx, %ploty].produced;
					%room = $RoB::Plot[%plotx, %ploty].produced;
					$RoB::Plot[%plotx, %ploty].produced = 0;
				}
				%you = $RoB::PData[%client.bl_id, mat];
				%type = "material";
			case "D":
				%room = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, des];
				if(%room <= 0) %noroom = true;
				if(!%noroom && $RoB::Plot[%plotx, %ploty].produced > %room) {
					$RoB::PData[%client.bl_id, des] = evaluateCapacity(%client.bl_id);
					$RoB::Plot[%plotx, %ploty].produced -= %room;
				} else if(!%noroom) {
					$RoB::PData[%client.bl_id, des] += $RoB::Plot[%plotx, %ploty].produced;
					%room = $RoB::Plot[%plotx, %ploty].produced;
					$RoB::Plot[%plotx, %ploty].produced = 0;
				}
				%you = $RoB::PData[%client.bl_id, des];
				%type = "design";
			case "E":
				%room = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, eng];
				if(%room <= 0) %noroom = true;
				if(!%noroom && $RoB::Plot[%plotx, %ploty].produced > %room) {
					$RoB::PData[%client.bl_id, eng] = evaluateCapacity(%client.bl_id);
					$RoB::Plot[%plotx, %ploty].produced -= %room;
				} else if(!%noroom) {
					$RoB::PData[%client.bl_id, eng] += $RoB::Plot[%plotx, %ploty].produced;
					%room = $RoB::Plot[%plotx, %ploty].produced;
					$RoB::Plot[%plotx, %ploty].produced = 0;
				}
				%you = $RoB::PData[%client.bl_id, eng];
				%type = "engineering";
			case "T":
				%room = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, tec];
				if(%room <= 0) %noroom = true;
				if(!%noroom && $RoB::Plot[%plotx, %ploty].produced > %room) {
					$RoB::PData[%client.bl_id, tec] = evaluateCapacity(%client.bl_id);
					$RoB::Plot[%plotx, %ploty].produced -= %room;
				} else if(!%noroom) {
					$RoB::PData[%client.bl_id, tec] += $RoB::Plot[%plotx, %ploty].produced;
					%room = $RoB::Plot[%plotx, %ploty].produced;
					$RoB::Plot[%plotx, %ploty].produced = 0;
				}
				%you = $RoB::PData[%client.bl_id, tec];
				%type = "technology";
			case "G":
				%room = 100 - $RoB::PData[%client.bl_id, gas];
				if(%room <= 0) %noroom = true;
				if(!%noroom && $RoB::Plot[%plotx, %ploty].produced > %room) {
					$RoB::PData[%client.bl_id, gas] = 100;
					$RoB::Plot[%plotx, %ploty].produced -= %room;
				} else if(!%noroom) {
					$RoB::PData[%client.bl_id, gas] += $RoB::Plot[%plotx, %ploty].produced;
					%room = $RoB::Plot[%plotx, %ploty].produced;
					$RoB::Plot[%plotx, %ploty].produced = 0;
				}
				%you = $RoB::PData[%client.bl_id, gas];
				%type = "gas";
				$RoB::TmpGas[%client.bl_id] = $RoB::PData[%client.bl_id, gas];
				%client.player.setenergylevel($RoB::PData[%client.bl_id, gas]);
				$limit = 100;
			default:
				return;
		}
	}
	if(%room < 0) %room = 0;
	if(%room > 0) AddEvent("coregather: (" @ %client.bl_id @ ") gathered " @ %room SPC %type @ " from (" @ %plotx @ ", " @ %ploty @ ") to " @ %dest @ ".");
	AddWorth(%client.bl_id, (%room * 15));
	commandtoclient(%client, 'RoB2ProdUpdate', $RoB::Plot[%plotx, %ploty].produced @ "/" @ mfloor($RoB::Dynamic::CoreProdCap * $RoB::Plot[%plotx, %ploty].prodfactor), %you @ "/" @ %limit, $RoB::Plot[%plotx, %ploty].stored @ "/" @ $RoB::Plot[%plotx, %ploty].capacity);
}

function ServerCmdRoB2MoveGoods(%client, %way, %amt)
{
	if(!isObject(%client.player)) return;
	%amt = mfloor(%amt);
	%curplot = findPlotFromObject(%client.player);
	%plot = %client.activeplot;
	if(vectorDist(%curplot SPC "0", %plot SPC "0") > 34) return;
	%plotx = getword(%plot, 0);
	%ploty = getword(%plot, 1);
	if(!isObject($RoB::Plot[%plotx, %ploty]) || $RoB::Plot[%plotx, %ploty].blid != %client.bl_id || !isBusiness(%plot)) return;
	initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
	while(%target=containersearchnext()) {
		if(%target.getdatablock().getname() $= "brickStorageData" && %target.isplanted) %storexists = 1;
	}
	if(!%storexists) return;
	if(%way $= "in") {
		%limit = evaluateCapacity(%client.bl_id);
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				if(%amt > $RoB::PData[%client.bl_id, fud]) %amt = $RoB::PData[%client.bl_id, fud];
			case "M":
				if(%amt > $RoB::PData[%client.bl_id, mat]) %amt = $RoB::PData[%client.bl_id, mat];
			case "D":
				if(%amt > $RoB::PData[%client.bl_id, des]) %amt = $RoB::PData[%client.bl_id, des];
			case "E":
				if(%amt > $RoB::PData[%client.bl_id, eng]) %amt = $RoB::PData[%client.bl_id, eng];
			case "T":
				if(%amt > $RoB::PData[%client.bl_id, tec]) %amt = $RoB::PData[%client.bl_id, tec];
			case "G":
				if(%amt > $RoB::PData[%client.bl_id, gas]) %amt = $RoB::PData[%client.bl_id, gas];
				%limit = 100;
		}
		%room = $RoB::Plot[%plotx, %ploty].capacity - $RoB::Plot[%plotx, %ploty].stored;
		if(%room <= 0 || %amt <= 0) return;
		if(%amt > %room) %amt = %room;
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				$RoB::PData[%client.bl_id, fud] -= %amt;
				$RoB::Plot[%plotx, %ploty].stored += %amt;
				%you = $RoB::PData[%client.bl_id, fud];
			case "M":
				$RoB::PData[%client.bl_id, mat] -= %amt;
				$RoB::Plot[%plotx, %ploty].stored += %amt;
				%you = $RoB::PData[%client.bl_id, mat];
			case "D":
				$RoB::PData[%client.bl_id, des] -= %amt;
				$RoB::Plot[%plotx, %ploty].stored += %amt;
				%you = $RoB::PData[%client.bl_id, des];
			case "E":
				$RoB::PData[%client.bl_id, eng] -= %amt;
				$RoB::Plot[%plotx, %ploty].stored += %amt;
				%you = $RoB::PData[%client.bl_id, eng];
			case "T":
				$RoB::PData[%client.bl_id, tec] -= %amt;
				$RoB::Plot[%plotx, %ploty].stored += %amt;
				%you = $RoB::PData[%client.bl_id, tec];
			case "G":
				$RoB::PData[%client.bl_id, gas] -= %amt;
				$RoB::Plot[%plotx, %ploty].stored += %amt;
				%you = $RoB::PData[%client.bl_id, gas];
				$RoB::TmpGas[%client.bl_id] = $RoB::PData[%client.bl_id, gas];
				%client.player.setenergylevel($RoB::PData[%client.bl_id, gas]);
		}
	} else {
		if(%amt > $RoB::Plot[%plotx, %ploty].stored) %amt = $RoB::Plot[%plotx, %ploty].stored;
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				%room = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, fud];
			case "M":
				%room = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, mat];
			case "D":
				%room = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, des];
			case "E":
				%room = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, eng];
			case "T":
				%room = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, tec];
			case "G":
				%room = 100 - $RoB::PData[%client.bl_id, gas];
		}
		if(%room <= 0 || %amt <= 0) return;
		if(%amt > %room) %amt = %room;
		%limit = evaluateCapacity(%client.bl_id);
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				$RoB::PData[%client.bl_id, fud] += %amt;
				$RoB::Plot[%plotx, %ploty].stored -= %amt;
				%you = $RoB::PData[%client.bl_id, fud];
			case "M":
				$RoB::PData[%client.bl_id, mat] += %amt;
				$RoB::Plot[%plotx, %ploty].stored -= %amt;
				%you = $RoB::PData[%client.bl_id, mat];
			case "D":
				$RoB::PData[%client.bl_id, des] += %amt;
				$RoB::Plot[%plotx, %ploty].stored -= %amt;
				%you = $RoB::PData[%client.bl_id, des];
			case "E":
				$RoB::PData[%client.bl_id, eng] += %amt;
				$RoB::Plot[%plotx, %ploty].stored -= %amt;
				%you = $RoB::PData[%client.bl_id, eng];
			case "T":
				$RoB::PData[%client.bl_id, tec] += %amt;
				$RoB::Plot[%plotx, %ploty].stored -= %amt;
				%you = $RoB::PData[%client.bl_id, tec];
			case "G":
				$RoB::PData[%client.bl_id, gas] += %amt;
				$RoB::Plot[%plotx, %ploty].stored -= %amt;
				%you = $RoB::PData[%client.bl_id, gas];
				$RoB::TmpGas[%client.bl_id] = $RoB::PData[%client.bl_id, gas];
				%client.player.setenergylevel($RoB::PData[%client.bl_id, gas]);
				%limit = 100;
		}
	}
	commandtoclient(%client, 'RoB2StorUpdate', $RoB::Plot[%plotx, %ploty].stored @ "/" @ $RoB::Plot[%plotx, %ploty].capacity, %you @ "/" @ %limit);
}

function ServerCmdRoB2ToggleSale(%client)
{
	if(!isObject(%client.player)) return;
	%curplot = findPlotFromObject(%client.player);
	%plot = %client.activeplot;
	if(vectorDist(%curplot SPC "0", %plot SPC "0") > 34) return;
	%plotx = getword(%plot, 0);
	%ploty = getword(%plot, 1);
	if(!isobject($RoB::Plot[%plotx, %ploty]) || $RoB::Plot[%plotx, %ploty].blid != %client.bl_id || !isBusiness(%plot)) return;
	initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
	while(%target=containersearchnext()) {
		if(%target.getdatablock().getname() $= "brickSalePointData" && %target.isplanted) %SPexists = 1;
	}
	if(!%SPexists) return;
	if($RoB::Plot[%plotx, %ploty].closed) $RoB::Plot[%plotx, %ploty].closed = false;
	else $RoB::Plot[%plotx, %ploty].closed = true;
	commandtoclient(%client, 'RoB2MySaleUpdate', $RoB::Plot[%plotx, %ploty].stored @ "/" @ $RoB::Plot[%plotx, %ploty].capacity, !$RoB::Plot[%plotx, %ploty].closed, $RoB::Plot[%plotx, %ploty].price);
}	

function ServerCmdRoB2SetPrice(%client, %price)
{
	if(!isObject(%client.player)) return;
	%curplot = findPlotFromObject(%client.player);
	%plot = %client.activeplot;
	if(vectorDist(%curplot SPC "0", %plot SPC "0") > 34) return;
	%plotx = getword(%plot, 0);
	%ploty = getword(%plot, 1);
	if(!isobject($RoB::Plot[%plotx, %ploty]) || $RoB::Plot[%plotx, %ploty].blid != %client.bl_id || (!isBusiness(%plot) && !isOtherBusiness(%plot))) return;
	initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
	while(%target=containersearchnext()) {
		if(%target.getdatablock().getname() $= "brickSalePointData" && %target.isplanted) %SPexists = 1;
	}
	if(!%SPexists) return;
	%price =  mabs(mfloor(%price));
	//if(isbusiness(%plot) && %price > 45) %price = 45;
	if(%price > 45) %price = 45;
	if(%price < 5) %price = 5;
	$RoB::Plot[%plotx, %ploty].price = %price;
	if(isbusiness(%plot)) {
		//if($RoB::Plot[%plotx, %ploty].price <= 10) %color = "\c2";
		//else if($RoB::Plot[%plotx, %ploty].price >= 20) %color = "\c0";
		//else %color = "\c6";
		%color = "\c6";
	}
	MessageClient(%client, "", "\c1Price per unit set to " @ %color @ "$" @ %price);
	commandtoclient(%client, 'RoB2MySaleUpdate', $RoB::Plot[%plotx, %ploty].stored @ "/" @ $RoB::Plot[%plotx, %ploty].capacity, !$RoB::Plot[%plotx, %ploty].closed, $RoB::Plot[%plotx, %ploty].price);
}	


	
function ServerCmdRoB2BuyGoods(%client, %amt, %price)
{
	if(!isObject(%client.player) || !$RoB::Dynamic::GameStarted) return;
	%price = getsubstr(%price, 1, strlen(%price) - 1);
	if(%price < 5) %price = getsubstr(%price, 1, strlen(%price) - 1);
	%amt = mfloor(%amt);
	%curplot = findPlotFromObject(%client.player);
	%plot = %client.activeplot;
	if(vectorDist(%curplot SPC "0", %plot SPC "0") > 34) return;
	%plotx = getword(%plot, 0);
	%ploty = getword(%plot, 1);
	if(!isobject($RoB::Plot[%plotx, %ploty]) || $RoB::Plot[%plotx, %ploty].blid == %client.bl_id || !isBusiness(%plot)) return;
	initContainerBoxSearch(getplotcenter(%plot) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize(%plot) SPC getplotYsize(%plot) SPC (($RoB::LevelHeight * 1) - ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
	while(%target=containersearchnext()) {
		if(%target.getdatablock().getname() $= "brickSalePointData" && %target.isplanted) %SPexists = 1;
	}
	if(!%SPexists) return;
	if($RoB::Plot[%plotx, %ploty].closed) return;
	if($RoB::Plot[%plotx, %ploty].stored <= 0 || %amt <= 0) return;
	if(%price != $RoB::Plot[%plotx, %ploty].price) {
		%max = mfloor($RoB::PData[%client.bl_id, money] / $RoB::Plot[%plotx, %ploty].price);
		if(%max > $RoB::Plot[%plotx, %ploty].stored) %max = $RoB::Plot[%plotx, %ploty].stored;
		%limit = evaluateCapacity(%client.bl_id);
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				%type = "Food";
				%you = $RoB::PData[%client.bl_id, fud];
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, fud]) %max = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, fud];
			case "M":
				%type = "Material";
				%you = $RoB::PData[%client.bl_id, mat];
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, mat]) %max = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, mat];
			case "D":
				%type = "Design";
				%you = $RoB::PData[%client.bl_id, des];
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, des]) %max = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, des];
			case "E":
				%type = "Engineering";
				%you = $RoB::PData[%client.bl_id, eng];
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, eng]) %max = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, eng];
			case "T":
				%type = "Technology";
				%you = $RoB::PData[%client.bl_id, tec];
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, tec]) %max = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, tec];
			case "G":
				%type = "Gas";
				%you = $RoB::PData[%client.bl_id, gas];
				if(%max > 100 - $RoB::PData[%client.bl_id, gas]) %max = 100 - $RoB::PData[%client.bl_id, gas];
				%limit = 100;
		}
		commandtoclient(%client, 'MessageBoxOK', "ERROR", "The price here has changed; please review your transaction.");
		//if($RoB::Plot[%plotx, %ploty].price <= 10) %color = 2;
		//else if($RoB::Plot[%plotx, %ploty].price >= 20) %color = 0;
		//else %color = 6;
		%color = 6;
		commandtoclient(%client, 'RoB2SaleUpdate', %type, %you @ "/" @ %limit, $RoB::Plot[%plotx, %ploty].stored, $RoB::Plot[%plotx, %ploty].price, %max, %color);
		return;
	}
	if(%amt > $RoB::Plot[%plotx, %ploty].stored) %amt = $RoB::Plot[%plotx, %ploty].stored;
	%price = %amt * $RoB::Plot[%plotx, %ploty].price;
	while(%price > $RoB::PData[%client.bl_id, money]) {
		%amt--;
		%price -= $RoB::Plot[%plotx, %ploty].price;
	}
	%limit = evaluateCapacity(%client.bl_id);
	switch$($RoB::Plot[%plotx, %ploty].type)
	{
		case "F":
			if(%amt > (evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, fud])) %amt = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, fud];
			%type = "Food";
			$RoB::PData[%client.bl_id, fud] += %amt;
			%you = $RoB::PData[%client.bl_id, fud];
		case "M":
			if(%amt > (evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, mat])) %amt = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, mat];
			%type = "Material";
			$RoB::PData[%client.bl_id, mat] += %amt;
			%you = $RoB::PData[%client.bl_id, mat];
		case "D":
			if(%amt > (evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, des])) %amt = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, des];
			%type = "Design";
			$RoB::PData[%client.bl_id, des] += %amt;
			%you = $RoB::PData[%client.bl_id, des];
		case "E":
			if(%amt > (evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, eng])) %amt = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, eng];
			%type = "Engineering";
			$RoB::PData[%client.bl_id, eng] += %amt;
			%you = $RoB::PData[%client.bl_id, eng];
		case "T":
			if(%amt > (evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, tec])) %amt = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, tec];
			%type = "Technology";
			$RoB::PData[%client.bl_id, tec] += %amt;
			%you = $RoB::PData[%client.bl_id, tec];
		case "G":
			if(%amt > (100 - $RoB::PData[%client.bl_id, gas])) %amt = 100 - $RoB::PData[%client.bl_id, gas];
			%type = "Gas";
			$RoB::PData[%client.bl_id, gas] += %amt;
			%you = $RoB::PData[%client.bl_id, gas];
			$RoB::TmpGas[%client.bl_id] = $RoB::PData[%client.bl_id, gas];
			%client.player.setenergylevel($RoB::PData[%client.bl_id, gas]);
			%limit = 100;
		default:
			return;
	}
	if(%amt <= 0) return;
	%price = %amt * $RoB::Plot[%plotx, %ploty].price;
	$RoB::Plot[%plotx, %ploty].stored -= %amt;
	$RoB::PData[%client.bl_id, money] -= %price;
	%logtype = strlwr($RoB::Plot[%plotx, %ploty].type);
	$RoB::Log[total, %logtype @ "sales"] += %amt;
	$RoB::Log[total, %logtype @ "gross"] += %price;
	$RoB::Log[avg, %logtype @ "price"] = $RoB::Log[total, %logtype @ "gross"] / $RoB::Log[total, %logtype @ "sales"];
	%max = mfloor($RoB::PData[%client.bl_id, money] / $RoB::Plot[%plotx, %ploty].price);
	if(%max > $RoB::Plot[%plotx, %ploty].stored) %max = $RoB::Plot[%plotx, %ploty].stored;
	switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, fud]) %max = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, fud];
			case "M":
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, mat]) %max = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, mat];
			case "D":
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, des]) %max = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, des];
			case "E":
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, eng]) %max = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, eng];
			case "T":
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, tec]) %max = evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, tec];
			case "G":
				if(%max > 100 - $RoB::PData[%client.bl_id, gas]) %max = 100 - $RoB::PData[%client.bl_id, gas];
		}
	%owner = findPlotOwnerBLID(%plot);
	$RoB::PData[%owner, money] += %price;
	%ingame = findClientByBL_ID(%owner);
	if(isObject(%ingame)) messageclient(%ingame, "", "\c2You have gained $" @ %price @ " from the sale of " @ %amt SPC %type @ ".");
	//if($RoB::Plot[%plotx, %ploty].price <= 10) %color = 2;
	//else if($RoB::Plot[%plotx, %ploty].price >= 20) %color = 0;
	//else %color = 6;
	%color = 6;
	commandtoclient(%client, 'RoB2SaleUpdate', %type, %you @ "/" @ %limit, $RoB::Plot[%plotx, %ploty].stored, $RoB::Plot[%plotx, %ploty].price, %max, %color);
	MessageClient(%client, "", "\c2You spent $" @ %price @ " on " @ %amt SPC strlwr(%type) @ ".");
	AddEvent("corebuy: (" @ %client.bl_id @ ") bought " @ %amt SPC %type @ " at $" @ $RoB::Plot[%plotx, %ploty].price @ " each (total $" @ %price @ ") from (" @ %plotx @ ", " @ %ploty @ ") owned by (" @ $RoB::Plot[%plotx, %ploty].blid @ ")."); 
	AddWorth(%client.bl_id, (%amt * 15) - %price);
	AddWorth($RoB::Plot[%plotx, %ploty].blid, %price - (%amt * 15));
}

function ClickedProd(%brick, %client)
{
	if(!isObject(%client.player) || !isObject(%brick)) return;
	$RoB::PData[%client.bl_id, gas] = mceil(%client.player.getenergylevel());
	%plot = findPlotFromObject(%brick);
	%plotx = getword(%plot, 0);
	%ploty = getword(%plot, 1);
	if(!isObject($RoB::Plot[%plotx, %ploty])) return;
	if($RoB::Plot[%plotx, %ploty].blid != %client.bl_id) return;
	if(isBusiness(%plot)) {
		%client.activeplot = %plot;
		%limit = evaluateCapacity(%client.bl_id);
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				%you = $RoB::PData[%client.bl_id, fud];
			case "M":
				%you = $RoB::PData[%client.bl_id, mat];
			case "D":
				%you = $RoB::PData[%client.bl_id, des];
			case "E":
				%you = $RoB::PData[%client.bl_id, eng];
			case "T":
				%you = $RoB::PData[%client.bl_id, tec];
			case "G":
				%you = $RoB::PData[%client.bl_id, gas];
				%limit = 100;
		}
		commandtoclient(%client, 'RoB2PushProd');
		commandtoclient(%client, 'RoB2ProdUpdate', $RoB::Plot[%plotx, %ploty].produced @ "/" @ mfloor($RoB::Dynamic::CoreProdCap * $RoB::Plot[%plotx, %ploty].prodfactor), %you @ "/" @ %limit, $RoB::Plot[%plotx, %ploty].stored @ "/" @ $RoB::Plot[%plotx, %ploty].capacity);
	}
}

function ClickedStor(%brick, %client)
{
	if(!isObject(%client.player) || !isObject(%brick)) return;
	$RoB::PData[%client.bl_id, gas] = mceil(%client.player.getenergylevel());
	%plot = findPlotFromObject(%brick);
	%plotx = getword(%plot, 0);
	%ploty = getword(%plot, 1);
	if(!isObject($RoB::Plot[%plotx, %ploty])) return;
	if($RoB::Plot[%plotx, %ploty].blid != %client.bl_id) return;
	if(isBusiness(%plot)) {
		%client.activeplot = %plot;
		%limit = evaluateCapacity(%client.bl_id);
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				%you = $RoB::PData[%client.bl_id, fud];
			case "M":
				%you = $RoB::PData[%client.bl_id, mat];
			case "D":
				%you = $RoB::PData[%client.bl_id, des];
			case "E":
				%you = $RoB::PData[%client.bl_id, eng];
			case "T":
				%you = $RoB::PData[%client.bl_id, tec];
			case "G":
				%you = $RoB::PData[%client.bl_id, gas];
				%limit = 100;
		}
		commandtoclient(%client, 'RoB2PushStor');
		commandtoclient(%client, 'RoB2StorUpdate', $RoB::Plot[%plotx, %ploty].stored @ "/" @ $RoB::Plot[%plotx, %ploty].capacity, %you @ "/" @ %limit);
	}
}

function ClickedSale(%brick, %client)
{
	if(!isObject(%client.player) || !isObject(%brick)) return;
	$RoB::PData[%client.bl_id, gas] = mceil(%client.player.getenergylevel());
	%plot = findPlotFromObject(%brick);
	%plotx = getword(%plot, 0);
	%ploty = getword(%plot, 1);
	if(!isObject($RoB::Plot[%plotx, %ploty])) return;
	if(!isBusiness(%plot)) return;
	%client.activeplot = %plot;
	if($RoB::Plot[%plotx, %ploty].blid == %client.bl_id) {
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				%you = $RoB::PData[%client.bl_id, fud];
			case "M":
				%you = $RoB::PData[%client.bl_id, mat];
			case "D":
				%you = $RoB::PData[%client.bl_id, des];
			case "E":
				%you = $RoB::PData[%client.bl_id, eng];
			case "T":
				%you = $RoB::PData[%client.bl_id, tec];
			case "G":
				%you = $RoB::PData[%client.bl_id, gas];
		}
		commandtoclient(%client, 'RoB2PushMySale');
		commandtoclient(%client, 'RoB2MySaleUpdate', $RoB::Plot[%plotx, %ploty].stored @ "/" @ $RoB::Plot[%plotx, %ploty].capacity, !$RoB::Plot[%plotx, %ploty].closed, $RoB::Plot[%plotx, %ploty].price);
	} else {
		if(!$RoB::Dynamic::GameStarted) {
			messageclient(%client, "", "\c1Transactions are not allowed during pre-game setup.");
			return;
		} else if($RoB::Plot[%plotx, %ploty].closed) {
			messageclient(%client, "", "\c1This business is closed.");
			return;
		} else if($RoB::Plot[%plotx, %ploty].stored < 1) {
			messageclient(%client, "", "\c1This business is sold out.");
			return;
		}
		%max = mfloor($RoB::PData[%client.bl_id, money] / $RoB::Plot[%plotx, %ploty].price);
		if(%max > $RoB::Plot[%plotx, %ploty, stored]) %max = $RoB::Plot[%plotx, %ploty].stored;
		%client.activeplot = %plot;
		switch$($RoB::Plot[%plotx, %ploty].type)
		{
			case "F":
				%type = "Food";
				%you = $RoB::PData[%client.bl_id, fud];
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, fud]) %max = max(evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, fud], 0);
				//if($RoB::Plot[%plotx, %ploty].price <= 10) %color = 2;
				//else if($RoB::Plot[%plotx, %ploty, price] >= 20) %color = 0;
				//else %color = 6;
				%color = 6;
				commandtoclient(%client, 'RoB2PushSale');
				commandtoclient(%client, 'RoB2SaleUpdate', %type, %you @ "/" @ evaluateCapacity(%client.bl_id), $RoB::Plot[%plotx, %ploty].stored, $RoB::Plot[%plotx, %ploty].price, %max, %color);
			case "M":
				%type = "Material";
				%you = $RoB::PData[%client.bl_id, mat];
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, mat]) %max = max(evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, mat], 0);
				//if($RoB::Plot[%plotx, %ploty].price <= 10) %color = 2;
				//else if($RoB::Plot[%plotx, %ploty, price] >= 20) %color = 0;
				//else %color = 6;
				%color = 6;
				commandtoclient(%client, 'RoB2PushSale');
				commandtoclient(%client, 'RoB2SaleUpdate', %type, %you @ "/" @ evaluateCapacity(%client.bl_id), $RoB::Plot[%plotx, %ploty].stored, $RoB::Plot[%plotx, %ploty].price, %max, %color);
			case "D":
				%type = "Design";
				%you = $RoB::PData[%client.bl_id, des];
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, des]) %max = max(evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, des], 0);
				//if($RoB::Plot[%plotx, %ploty].price <= 10) %color = 2;
				//else if($RoB::Plot[%plotx, %ploty, price] >= 20) %color = 0;
				//else %color = 6;
				%color = 6;
				commandtoclient(%client, 'RoB2PushSale');
				commandtoclient(%client, 'RoB2SaleUpdate', %type, %you @ "/" @ evaluateCapacity(%client.bl_id), $RoB::Plot[%plotx, %ploty].stored, $RoB::Plot[%plotx, %ploty].price, %max, %color);
			case "E":
				%type = "Engineering";
				%you = $RoB::PData[%client.bl_id, eng];
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, eng]) %max = max(evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, eng], 0);
				//if($RoB::Plot[%plotx, %ploty].price <= 10) %color = 2;
				//else if($RoB::Plot[%plotx, %ploty, price] >= 20) %color = 0;
				//else %color = 6;
				%color = 6;
				commandtoclient(%client, 'RoB2PushSale');
				commandtoclient(%client, 'RoB2SaleUpdate', %type, %you @ "/" @ evaluateCapacity(%client.bl_id), $RoB::Plot[%plotx, %ploty].stored, $RoB::Plot[%plotx, %ploty].price, %max, %color);
			case "T":
				%type = "Technology";
				%you = $RoB::PData[%client.bl_id, tec];
				if(%max > evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, tec]) %max = max(evaluateCapacity(%client.bl_id) - $RoB::PData[%client.bl_id, tec], 0);
				//if($RoB::Plot[%plotx, %ploty].price <= 10) %color = 2;
				//else if($RoB::Plot[%plotx, %ploty, price] >= 20) %color = 0;
				//else %color = 6;
				%color = 6;
				commandtoclient(%client, 'RoB2PushSale');
				commandtoclient(%client, 'RoB2SaleUpdate', %type, %you @ "/" @ evaluateCapacity(%client.bl_id), $RoB::Plot[%plotx, %ploty].stored, $RoB::Plot[%plotx, %ploty].price, %max, %color);
			case "G":
				%type = "Gas";
				%you = $RoB::PData[%client.bl_id, gas];
				if(%max > 100 - $RoB::PData[%client.bl_id, gas]) %max = max(100 - $RoB::PData[%client.bl_id, gas], 0);
				//if($RoB::Plot[%plotx, %ploty].price <= 10) %color = 2;
				//else if($RoB::Plot[%plotx, %ploty, price] >= 20) %color = 0;
				//else %color = 6;
				%color = 6;
				commandtoclient(%client, 'RoB2PushSale');
				commandtoclient(%client, 'RoB2SaleUpdate', %type, %you @ "/100", $RoB::Plot[%plotx, %ploty].stored, $RoB::Plot[%plotx, %ploty].price, %max, %color);
		}	
	}
}

function ServerCmdProd(%client)
{
	messageClient(%client, "", "\c7This command is obsolete; just click on the brick!");
	return;
}

function ServerCmdStor(%client)
{
	messageClient(%client, "", "\c7This command is obsolete; just click on the brick!");
	return;
}	

function ServerCmdSell(%client)
{
	messageClient(%client, "", "\c7This command is obsolete; just click on the brick!");
	return;
}

function ServerCmdBuy(%client)
{
	messageClient(%client, "", "\c7This command is obsolete; just click on the brick!");
	return;
}








function ServerCmdRoB2GUIGetRatings(%client)
{
	//parameters for reply:
		//cash amount for player meter
		//case capacity for player meter
		//cash amount for lot meter
		//cash capacity for lot meter
		//rating of lot (0 for N/A)
		//the rating the player has given it (0 for N/A)
		//string of special flags seperated by spaces, all that apply:
			//"FEW" means the lot has too few ratings to be affected
			//"POOR" means the owner has too little net worth to be affected
			//"LOW" means the player is in danger of being flagged a downvoter
			//"DOWN" means the player is a downvoter and can't vote 1 or 2
			//"HIGH" means the player is in danger of being flagged an upvoter
			//"UP" means the player is an upvoter and can't vote 4 or 5
			//"EDGY" means the player is in danger of being flagged a 1-or-5er
			//"EXTREME" means the player is a 1-or-5er and can't vote 1 or 5
	%totalprod = GetTotalProd(%client.bl_id);
	%unit = (%totalprod / $RoB::Dynamic::CoreProdRate) * $RoB::Dynamic::CoreCashRate;
	%playercashcap = max(0,mfloor($RoB::Dynamic::PlayerCoreRateMax * %unit));
	%playercashamt = max(0,mfloor(%playercashcap - ($RoB::PData[%client.bl_id, cashtimer] * %unit)));
	if(%playercashamt < 0) %playercashamt = 0;

	for(%i = 1; %i < 6; %i++) {
		%t += $RoB::RateTMP[%client.bl_id, %i] * %i;
		%c += $RoB::RateTMP[%client.bl_id, %i];
		if(%i == 1 || %i == 5) %e += $RoB::RateTMP[%client.bl_id, %i];
		else if(%i == 3) %m += $RoB::RateTMP[%client.bl_id, %i];
	}
	%plAvgRating = %t / %c;
	%plExtremism = %e / %m;
	
	if(%c >= 5) { //no restrictions until the 6th rating
		if(%plAvgRating < 2.2) %tags = "DOWN";
		else if(%plAvgRating < 2.5) %tags = "LOW";
		else if(%plAvgRating > 3.8) %tags = "UP";
		else if(%plAvgRating > 3.5) %tags = "HIGH";
		if(%plExtremism > 1) %tags = ltrim(%tags SPC "EXTREME");
		else if(%plExtremism > 0.84) %tags = ltrim(%tags SPC "EDGY");
	} else if(%c > 2) {
		if(%plAvgRating < 2.5) %tags = "LOW";
		else if(%plAvgRating > 3.5) %tags = "HIGH";
		if(%plExtremism > 0.84) %tags = ltrim(%tags SPC "EDGY");
	}
	
	if(!isobject(%client.player) || !$RoB::Dynamic::GameStarted) {
		commandtoclient(%client, 'RoB2GUIGetRateInfo', %playercashamt, %playercashcap, 0, 0, 0, 0, "");
		return;
	}
	%plot = findPlotFromObject(%client.player);
	%x = getword(%plot, 0);
	%y = getword(%plot, 1);
	%plotobj = $RoB::plot[%x, %y];
	if(!isObject(%plotobj)) {
		commandtoclient(%client, 'RoB2GUIGetRateInfo', %playercashamt, %playercashcap, 0, 0, 0, 0, "");
		return;
	}
	if(%plotobj.blid == -1) {
		commandtoclient(%client, 'RoB2GUIGetRateInfo', %playercashamt, %playercashcap, 0, 0, 0, 0, "");
		return;
	}
	%rating = "NONE";
	if(%plotobj.blid == %client.bl_id || %client.robadmin) {
		%plotcashamt = 0;
		%plotcashcap = 0;
		%rating = "AVG" SPC getPlotRating(%plotobj);
	} else {
		for(%i = 1; %i <= %plotobj.ratings[index]; %i++) {
			if(getword(%plotobj.ratings[%i], 0) == %client.bl_id) {
				%plotusedscore = %plotobj.cashtimer[%i];
				%rating = "SELF" SPC getword(%plotobj.ratings[%i], 1);
				%plotcashcap = max(0,mfloor($RoB::Dynamic::PlotCoreRateMax * %unit));
				%plotcashamt = max(0,mfloor(%plotcashcap - (%plotusedscore * %unit)));
				if(%plotcashamt < 0) %plotcashamt = 0;
			}
		}
		if(!%plotcashcap) {
			%plotcashcap = max(0,mfloor($RoB::Dynamic::PlotCoreRateMax * %unit));
			%plotcashamt = %plotcashcap;
		}
	}
	
	if(%plotobj.ratings[index] <= 5) %tags = ltrim(%tags SPC "FEW");
	
	WorthValidation(%plotobj.blid);
	if($RoB::PData[%plotobj.blid, networth] < $RoB::Dynamic::PoorWorthCutoff) %tags = ltrim(%tags SPC "POOR");
	
	commandtoclient(%client, 'RoB2GUIGetRateInfo', %playercashamt, %playercashcap, %plotcashamt, %plotcashcap, %rating, %tags);
}


function serverCmdRoB2GUIRatePlot(%client, %rating)
{	
	%rating = mfloor(%rating);
	if(%rating > 5 || %rating < 1 || !isObject(%client.player)) {
		ServerCmdRoB2GUIGetRatings(%client);
		return;
	}
	%plot = findPlotFromObject(%client.player);
	%x = getword(%plot, 0);
	%y = getword(%plot, 1);
	%plotobj = $RoB::plot[%x, %y];
	if(!isObject(%plotobj) || (!isbusiness(%plotobj) && %plotobj.type !$= "R") || %plotobj.blid == %client.bl_id) {
		ServerCmdRoB2GUIGetRatings(%client);
		return;
	}
	
	for(%i = 1; %i < 6; %i++) {
		%t += $RoB::RateTMP[%client.bl_id, %i] * %i;
		%c += $RoB::RateTMP[%client.bl_id, %i];
		if(%i == 1 || %i == 5) %e += $RoB::RateTMP[%client.bl_id, %i];
		else if(%i == 3) %m += $RoB::RateTMP[%client.bl_id, %i];
	}
	%plAvgRating = %t / %c;
	%plExtremism = %e / %m;
	
	if(%c >= 5) { //no restrictions until the 6th rating
		if(%plAvgRating < 2.2 && %rating < 3) return;
		if(%plAvgRating > 3.8 && %rating > 3) return;
		if(%plExtremism > 1 && (%rating < 2 || %rating > 4)) return;
	}
	
	for(%i = 1; %i <= %plotobj.ratings[index]; %i++) {
		if(getword(%plotobj.ratings[%i], 0) == %client.bl_id) {
			%rateLoc = %i;
			%oldRating = getword(%plotobj.ratings[%i], 1);
		}
	}
	
	%totalprod = GetTotalProd(%client.bl_id);
	%unit = mfloor(%totalprod / $RoB::Dynamic::CoreProdRate * $RoB::Dynamic::CoreCashRate);
	if(!%rateloc) {
		%plotobj.ratings[index]++;
		%rateLoc = %plotobj.ratings[index];
	}
	
	%plotobj.rateTimer[%rateLoc] = 750;
	%capacity = min(($RoB::Dynamic::PlayerCoreRateMax-$RoB::PData[%client.bl_id, cashtimer]),($RoB::Dynamic::PlotCoreRateMax-%plotobj.cashtimer[%rateLoc]));
	
	
	if(%capacity > 0) {
		$RoB::PData[%client.bl_id, cashtimer] += %capacity;
		%plotobj.cashtimer[%rateLoc] += %capacity;
		%totalprod = GetTotalProd(%client.bl_id);
		%unit = (%totalprod / $RoB::Dynamic::CoreProdRate) * $RoB::Dynamic::CoreCashRate;
		%money = mfloor(%unit * %capacity);
		%change = %money - (%unit * %capacity);
		$RoB::PData[%client.bl_id, cashfrac] += %change;
		if($RoB::PData[%client.bl_id, cashfrac] >= 1) {
			$RoB::PData[%client.bl_id, cashfrac]--;
			%money++;
		}
		$RoB::PData[%client.bl_id, money] += %money;
	}
	
	%plotobj.ratings[%rateLoc] = %client.bl_id SPC %rating;
	
	if(%oldRating) $RoB::RateTMP[%client.bl_id, %oldRating]--;
	$RoB::RateTMP[%client.bl_id, %rating]++;
	
	
	
	AddEvent("rate: (" @ %client.bl_id @ ") rated " @ %rating @ " on (" @ %x @ ", " @ %y @ "), gaining $" @ %money + %change @ ". Old rating: " @ %oldRating);
	ServerCmdRoB2GUIGetPlayerInfo(%client);
	ServerCmdRoB2GUIGetRatings(%client);
}

