package RoBPackage {
	function serverCmdMessageSent(%client, %text)
	{
		if($RoB::Muted[%client.bl_id]) {
			messageclient(%client, "", "You are currently muted.");
			return;
		}
		if(getsubstr(%text, 0, 5) $= "1C@31") {
			MessageClient(%client, "", "Encrypted text is forbidden on the server because it spams up the already-noisy chat.");
			return;
		}
		if(%client.floodcontrol) return;
		%client.floodcontrol = true;
		%client.schedule(200, "FloodOff");
		%text = StripMLControlChars(%text);
		%text = FormatLinks(strreplace(strreplace(%text, "<", "<\c6"), "<\c63", "<3\c6"));
		echo(%client.name @ ":" SPC %text);
		%file = new FileObject();
		%file.openForAppend("config/chatlog.txt");
		%file.writeline(getdatetime() SPC %client.name SPC "(" @ %client.bl_id @ "):" SPC %text);
		%file.close();
		%file.delete();
		%message = '\c7%1\c3%2\c7%3\c6: %4' @ ($RoB::PData[%client.bl_id,donator] ? "<bitmap:base/client/ui/CI/blueRibbon.png>" : "") @ "\c7" @ %client.clanprefix @ "\c3" @ %client.name @ "\c7" @ %client.clansuffix @ "\c6: " @ %text;
		commandToAll('chatMessage',%client,'','',%message,($RoB::PData[%client.bl_id,donator] ? "<bitmap:base/client/ui/CI/blueRibbon.png>\c7" : "") @ %client.clanprefix,%client.name,%client.clansuffix,%text);
		//Parent::serverCmdMessageSent(%client, %text);
	}
	
	function serverCmdTeamMessageSent(%client, %text)
	{
		if($RoB::Muted[%client.bl_id]) {
			messageclient(%client, "", "You are currently muted.");
		} else {
			if($RoB::PData[%client.bl_id, ignorehelp]) {
				messageclient(%client, "", "\c2You are ignoring the help channel; say /ignorehelp.");
				return;
			}
			if(getsubstr(%text, 0, 5) $= "1C@31") {
				MessageClient(%client, "", "Encrypted text is forbidden on the server because it spams up the already-noisy chat.");
				return;
			}
			if(%client.floodcontrol) return;
			%client.floodcontrol = true;
			%client.schedule(200, "FloodOff");
			%text = StripMLControlChars(%text);
			%text = FormatLinks(strreplace(%text, "<", "<\c6"));
			echo("[HELP]" @ %client.name @ ":" SPC %text);
			%file = new FileObject();
			%file.openForAppend("config/chatlog.txt");
			%file.writeline(getdatetime() SPC "[HELP]" SPC %client.name SPC "(" @ %client.bl_id @ "):" SPC %text);
			%file.close();
			%file.delete();
			for(%i = 0; %i < clientgroup.getcount(); %i++) {
				%cl = clientgroup.getobject(%i);
				if(!%cl.ighelp) messageclient(%cl, "", "\c4[HELP]" @ ($RoB::PData[%client.bl_id,donator] ? "<bitmap:base/client/ui/CI/blueRibbon.png>" : "") @ "\c3" @ %client.name @ "\c6: " @ %text);
			}
		}
	}
	
	function servercmdclearspambricks(%client)
	{
		return;
	}
	
	function servercmdplantbrick(%client)
	{
		%tmp = %client.player.tempbrick;
		if(!isobject(%tmp)) return;
		%plot = findplotfromobject(%tmp);
		%plotx = getword(%plot, 0);
		%ploty = getword(%plot, 1);
		%x = getword(%tmp.position, 0);
		%y = getword(%tmp.position, 1);
		%bx = %tmp.getdatablock().bricksizeX;
		%by = %tmp.getdatablock().bricksizeY;
		%bz = %tmp.getdatablock().bricksizeZ;
		%cost = (%bx * %by * %bz);
		//if(%tmp.getdatablock().subcategory $= "Prints") %cost *= 2;
		if(%tmp.getdatablock().getname() $= "brickVehicleSpawnData") {
			commandtoclient(%client, 'MessageBoxOK', "ERROR", "This brick type can never be placed.");
			return;
		}
		if(%tmp.getdatablock().getname() $= "brickProductionData" || %tmp.getdatablock().getname() $= "brickSpawnPointData") %cost = 0;
		if(%tmp.getdatablock().getname() $= "brickStorageData" || %tmp.getdatablock().getname() $= "brickSalePointData") %cost = 1000;
		%des = GetDesignCost(getword(%tmp.position, 2), %bz);
		%pap = PropertyAllowablePlant(%client, %tmp, %bx, %by, %bz);
		switch$(%pap)
		{
			case "NOTOWNER":
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "This is not your property!");
			case "OVERLAP":
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "You must build entirely within the quarter-space property.");
			case "CLEARPATH":
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "You must leave a clear path down the center of the road.");
			case "TOOHIGH":
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "Bricks cannot be placed so high.");
			case "PRODLIM":
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "Only one Production Brick allowed on a single property.");
			case "STORLIM":
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "This property can support no more Storage Bricks.");
			case "BUSONLY":
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "This brick can only be planted in a business property.");
			case "RONLY":
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "This brick can only be planted in a residential property.");
			case "SPLIM":
				commandtoclient(%client, 'MessageBoxOK', "ERROR", "This property can support no more spawn points.");
			case "OK":
				if($RoB::PData[%client.bl_id, money] < %cost) {
					commandtoclient(%client, 'MessageBoxOK', "ERROR", "This brick costs $" @ %cost @ " to place, but you only have $" @ $RoB::PData[%client.bl_id, money] @ "!");
				} else if($RoB::PData[%client.bl_id, mat] <= 0 && %tmp.getdatablock().getname() !$= "brickProductionData" && %tmp.getdatablock().getname() !$= "brickStorageData" && %tmp.getdatablock().getname() !$= "brickSalePointData" && %tmp.getdatablock().getname() !$= "brickSpawnPointData") {
					commandtoclient(%client, 'MessageBoxOK', "ERROR", "You don't have enough material!");
				} else if($RoB::PData[%client.bl_id, fud] <= 0 && %tmp.getdatablock().getname() !$= "brickProductionData" && %tmp.getdatablock().getname() !$= "brickStorageData" && %tmp.getdatablock().getname() !$= "brickSalePointData" && %tmp.getdatablock().getname() !$= "brickSpawnPointData") {
					commandtoclient(%client, 'MessageBoxOK', "ERROR", "You're too hungry!");
				} else if($RoB::PData[%client.bl_id, des] < %des && %des) {
					commandtoclient(%client, 'MessageBoxOK', "ERROR", "You need more design to build this high.");
				} else if($RoB::PData[%client.bl_id, eng] < GetEngCost(%tmp) && GetEngCost(%tmp)) {
					commandtoclient(%client, 'MessageBoxOK', "ERROR", "You don't have enough engineering! Engineering is used for odd shapes and transparent colors.");
				} else if(%tmp.getdatablock().subcategory $= "Prints" && $RoB::PData[%client.bl_id, tec] < 3) {
					commandtoclient(%client, 'MessageBoxOK', "ERROR", "You don't have enough technology for a print!");
				} else Parent::servercmdplantbrick(%client);
			case "ADMIN":
				Parent::servercmdplantbrick(%client);
		}		
	}
	
	function fXDTSBrick::OnPlant(%brick)
	{
		%plot = findPlotFromObject(%brick);
		%owner = findPlotOwnerBLID(%plot);
		%x = getword(%plot, 0);
		%y = getword(%plot, 1);
		%bx = %brick.getdatablock().bricksizeX;
		%by = %brick.getdatablock().bricksizeY;
		%bz = %brick.getdatablock().bricksizeZ;
		%cost = (%bx * %by * %bz);
		if(%brick.getdatablock().subcategory $= "Prints") %tec = 3;
		%des = GetDesignCost(getword(%brick.position, 2), %bz);
		if(%brick.getdatablock().getname() $= "brickSalePointData") {
			schedule(100, 0, "setcolor", %brick, 63);
			%cost = 1000;
		} else if(%brick.getdatablock().getname() $= "brickStorageData") {
			schedule(100, 0, "setcolor", %brick, 62);
			$RoB::Plot[%x, %y].capacity += $RoB::Dynamic::CoreStorAmt;
			%cost = 1000;
		} else if(%brick.getdatablock().getname() $= "brickProductionData") {
			schedule(100, 0, "setcolor", %brick, 61);
			%cost = 0;
		} else if(%brick.getdatablock().getname() $= "brickSpawnPointData") {
			schedule(100, 0, "SetupSpawn", %brick);
			%cost = 0;
		} else schedule(100, 0, "ConfirmColor", %brick);
		parent::OnPlant(%brick);
		schedule(100, 0, "buildbrick", %owner, %brick, %x, %y, %cost, %des, GetEngCost(%brick), %tec);
	}
	
	function fxDTSBrick::OnDeath(%this)
	{
		%plot = findPlotFromObject(%this);
		%plotx = getword(%plot, 0);
		%ploty = getword(%plot, 1);
		%owner = findPlotOwnerBLID(%plot);
		%bx = %this.getdatablock().bricksizeX;
		%by = %this.getdatablock().bricksizeY;
		%bz = %this.getdatablock().bricksizeZ;
		%cost = (%bx * %by * %bz);
		//if(%this.getdatablock().subcategory $= "Prints") %cost *= 2;
		%des = GetDesignCost(getword(%this.position, 2), %bz);
		//%energy = getBrickEventTotalPrice(%this);
		if(%this.getdatablock().getname() $= "brickProductionData") {
			%cost = 0;
		} else if(%this.getdatablock().getname() $= "brickStorageData") {
			%cost = 1000;
			$RoB::Plot[%plotx, %ploty].capacity -= $RoB::Dynamic::CoreStorAmt;
		} else if(%this.getdatablock().getname() $= "brickSalePointData") {
			%cost = 1000;
		} else if(%this.getdatablock().getname() $= "brickSpawnPointData") {
			%cost = 0;
			removespawn(%this);
		}
		%vcost = 15 * %des;
		if(%this.getdatablock().getname() !$= "brickProductionData" && %this.getdatablock().getname() !$= "brickStorageData" && %this.getdatablock().getname() !$= "brickSalePointData" && %this.getdatablock().getname() !$= "brickSpawnPointData") %vcost += %cost + 15; //+15 is for the mat
		//%vcost += %energy;
		
		$RoB::Plot[%plotx, %ploty].extravalue -= getTechCost(%this) * 15;
		
		
		if(isObject($RoB::Plot[%plotx, %ploty])) {
			$RoB::Plot[%plotx, %ploty].value -= %vcost;
			CheckForProdChange(%plot);
			$RoB::Log[total, plotvalue] -= %vcost;
		}
	
		if(%owner == -1) return;
		
		$RoB::PData[%owner, money] += %cost;
		if(%this.getdatablock().getname() !$= "brickProductionData" && %this.getdatablock().getname() !$= "brickStorageData" && %this.getdatablock().getname() !$= "brickSalePointData" && %this.getdatablock().getname() !$= "brickSpawnPointData") $RoB::PData[%owner, mat]++;
		if(GetEngCost(%this)) {
			$RoB::PData[%owner, eng] += GetEngCost(%this);
			if(isObject($RoB::Plot[%plotx, %ploty])) {
				$RoB::Plot[%plotx, %ploty].value -= GetEngCost(%this) * 5;
				$RoB::Plot[%plotx, %ploty].extravalue -= GetEngCost(%this) * 10;
			}
		}
		$RoB::PData[%owner, tec] += getTechCost(%this);
		//$RoB::PData[%owner, energy] += %energy;
		if($RoB::Log[total, plyrplots] != 0) $RoB::Log[avg, plotvalue] = $RoB::Log[total, plotvalue] / $RoB::Log[total, plyrplots];
		AddWorth(%owner, %des * -15);
		ServerCmdRoB2GUIGetPlayerInfo(findClientByBL_ID(%owner));
		Parent::OnDeath(%this);
	}
	
	function hammerImage::onHitObject(%this, %player, %a, %brick, %particle, %f)
	{
		if(!%brick.isplanted) return;
		%hammerer = %player.client;
		%plot = findPlotFromObject(%brick);
		%plotx = getword(%plot, 0);
		%ploty = getword(%plot, 1);
		%owner = findPlotOwnerBLID(%plot);
		if(%hammerer.bl_id != %owner && !%hammerer.robadmin) return;
		%bx = %brick.getdatablock().bricksizeX;
		%by = %brick.getdatablock().bricksizeY;
		%bz = %brick.getdatablock().bricksizeZ;
		%cost = %bx * %by * %bz * 2;
		%des = GetDesignCost(getword(%brick.position, 2), %bz);
		if($RoB::PData[%owner, mat] + 1 > evaluateCapacity(%owner)) {
			if(%hammerer.RoBadmin) Parent::OnHitObject(%this, %player, %a, %brick, %particle, %f);
			else if(%hammerer.bl_id == %owner && %brick.getdatablock().getname() !$=  "brickProductionData" && %brick.getdatablock().getname() !$= "brickSpawnPointData" && %brick.getdatablock().getname() !$=  "brickStorageData" && %brick.getdatablock().getname() !$=  "brickSalePointData") commandtoclient(%hammerer, 'MessageBoxOK', "ERROR", "You can't hold the material refund of this brick.");
			else Parent::OnHitObject(%this, %player, %a, %brick, %particle, %f);
		//} else if($RoB::PData[%owner, energy] + getBrickEventTotalPrice(%brick) > 100) {
		//	if(%hammerer.RoBadmin) Parent::OnHitObject(%this, %player, %a, %brick, %particle, %f);
		//	else if(%hammerer.bl_id == %owner) commandtoclient(%hammerer, 'MessageBoxOK', "ERROR", "You can't hold the energy refund of this brick.");
		//	else Parent::OnHitObject(%this, %player, %a, %brick, %particle, %f);
		} else if($RoB::PData[%owner, eng] + GetEngCost(%brick) > evaluateCapacity(%owner) && GetEngCost(%brick)) {
			if(%hammerer.RoBadmin) Parent::OnHitObject(%this, %player, %a, %brick, %particle, %f);
			else if(%hammerer.bl_id == %owner ) commandtoclient(%hammerer, 'MessageBoxOK', "ERROR", "You can't hold the engineering refund of this brick.");
			else Parent::OnHitObject(%this, %player, %a, %brick, %particle, %f);
		} else Parent::OnHitObject(%this, %player, %a, %brick, %particle, %f);
	}
	
	function servercmddropcameraatplayer(%client)
	{
		if(!%client.robadmin) return;
		parent::servercmddropcameraatplayer(%client);
	}
	
	function servercmddropplayeratcamera(%client)
	{
		if(!%client.robadmin) return;
		parent::servercmddropplayeratcamera(%client);
	}
	
	function GameConnection::OnClientEnterGame(%client)
	{
		Parent::OnClientEnterGame(%client);
		schedule(1000, 0, "robconnect", %client);
	}
	
	function GameConnection::OnClientLeaveGame(%client)
	{
		RepossessEmptyLots(%client.bl_id);
		Parent::OnClientLeaveGame(%client);
	}
	
	function serverCmdTrust_Invite(%a, %b, %c, %d)
	{
		commandToClient(%a, 'MessageBoxOK', "Rise of Blockland 2", "Trust doesn't do anything in Rise of Blockland, so don't bother.");
		return;
	}
	
	function GameConnection::SpawnPlayer(%client)
	{
		Parent::SpawnPlayer(%client);
		schedule(1000, 0, "commandToClient", %client, 'RoB2Ping');
		cancel(%client.ping);
		%client.ping = schedule(3000, 0, "RoB2NoPong", %client);
	}
	
	function servercmddoplayericons(%client)
	{
		return;
	}
	
	function servercmdwand(%client)
	{
		return;
	}
	
	function servercmdundobrick(%client, %a, %b)
	{
		return;
	}
	
	function fXDTSBrick::OnActivate(%brick, %player, %client, %playerpos, %point3f)
	{
		if(%brick.getdatablock().getname() $= "brickSalePointData") ClickedSale(%brick, %client);
		if(%brick.getdatablock().getname() $= "brickStorageData") ClickedStor(%brick, %client);
		if(%brick.getdatablock().getname() $= "brickProductionData") ClickedProd(%brick, %client);
		Parent::OnActivate(%brick, %player, %client, %playerpos, %point3f);
	}
	
	function paintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(%a.colorID == 61 || %a.colorID == 62 || %a.colorID == 63) return;
		if(!getTrustLevel(%b, %c)) return;
		if(!%c.isplanted) return;
		if(%c.getdatablock().getname() $= "brickSalePointData" || %c.getdatablock().getname() $= "brickStorageData" || %c.getdatablock().getname() $= "brickProductionData") return;
		
		%plot = findPlotFromObject(%c);
		%x = getword(%plot, 0);
		%y = getword(%plot, 1);
		if(!isObject($RoB::Plot[%x, %y])) return;
		%blid = $RoB::Plot[%x, %y].blid;
		
		if(strstr($RoB::TransparentColors, " " @ %a.colorID @ " ") != -1 && strstr($RoB::TransparentColors, " " @ %c.colorID @ " ") == -1) { //adding transparency
			if($RoB::PData[%blid, eng] < 3 && !%b.sourceobject.client.robadmin) {
				%client = findClientByBL_ID(%blid);
				if(isObject(%client)) commandtoclient(%client, 'MessageBoxOK', "ERROR", "You don't have enough engineering!");
				return;
			} else $RoB::PData[%blid, eng] -= 3;
		} else if(strstr($RoB::TransparentColors, " " @ %a.colorID @ " ") == -1 && strstr($RoB::TransparentColors, " " @ %c.colorID @ " ") != -1) { //removing transparency
			$RoB::PData[%blid, eng] += 3;
		}
		Parent::OnCollision(%a, %b, %c, %d, %e, %f, %g);
	}
	
	function flatPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(!%c.isplanted) return;
		if(!getTrustLevel(%b, %c)) return;
		if(%c.getdatablock().getname() $= "brickSalePointData" || %c.getdatablock().getname() $= "brickStorageData" || %c.getdatablock().getname() $= "brickProductionData") return;
		
		ProcessColorFXChange(%b.sourceobject.client, %c, 0);
	}
	
	function pearlPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(!%c.isplanted) return;
		if(!getTrustLevel(%b, %c)) return;
		if(%c.getdatablock().getname() $= "brickSalePointData" || %c.getdatablock().getname() $= "brickStorageData" || %c.getdatablock().getname() $= "brickProductionData") return;
		
		ProcessColorFXChange(%b.sourceobject.client, %c, 1);
	}
	
	function chromePaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(!%c.isplanted) return;
		if(!getTrustLevel(%b, %c)) return;
		if(%c.getdatablock().getname() $= "brickSalePointData" || %c.getdatablock().getname() $= "brickStorageData" || %c.getdatablock().getname() $= "brickProductionData") return;
		
		ProcessColorFXChange(%b.sourceobject.client, %c, 2);
	}
	
	function glowPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(!%c.isplanted) return;
		if(!getTrustLevel(%b, %c)) return;
		if(%c.getdatablock().getname() $= "brickSalePointData" || %c.getdatablock().getname() $= "brickStorageData" || %c.getdatablock().getname() $= "brickProductionData") return;
		
		ProcessColorFXChange(%b.sourceobject.client, %c, 3);
	}
	
	function blinkPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(!%c.isplanted) return;
		if(!getTrustLevel(%b, %c)) return;
		if(%c.getdatablock().getname() $= "brickSalePointData" || %c.getdatablock().getname() $= "brickStorageData" || %c.getdatablock().getname() $= "brickProductionData") return;
		
		ProcessColorFXChange(%b.sourceobject.client, %c, 4);
	}
	
	function swirlPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(!%c.isplanted) return;
		if(!getTrustLevel(%b, %c)) return;
		if(%c.getdatablock().getname() $= "brickSalePointData" || %c.getdatablock().getname() $= "brickStorageData" || %c.getdatablock().getname() $= "brickProductionData") return;
		
		ProcessColorFXChange(%b.sourceobject.client, %c, 5);
	}
	
	function rainbowPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(!%c.isplanted) return;
		if(!getTrustLevel(%b, %c)) return;
		if(%c.getdatablock().getname() $= "brickSalePointData" || %c.getdatablock().getname() $= "brickStorageData" || %c.getdatablock().getname() $= "brickProductionData") return;
		
		ProcessColorFXChange(%b.sourceobject.client, %c, 6);
	}
	
	function stablePaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(!%c.isplanted) return;
		if(!getTrustLevel(%b, %c)) return;
		if(%c.getdatablock().getname() $= "brickSalePointData" || %c.getdatablock().getname() $= "brickStorageData" || %c.getdatablock().getname() $= "brickProductionData") return;
		
		ProcessShapeFXChange(%b.sourceobject.client, %c, 0);
	}
	
	function jelloPaintProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
	{
		if(!%c.isplanted) return;
		if(!getTrustLevel(%b, %c)) return;
		if(%c.getdatablock().getname() $= "brickSalePointData" || %c.getdatablock().getname() $= "brickStorageData" || %c.getdatablock().getname() $= "brickProductionData") return;
		
		ProcessShapeFXChange(%b.sourceobject.client, %c, 1);
	}
	
	function PlayerStandardArmor::OnAdd(%a, %b)
	{
		Parent::OnAdd(%a, %b);
		if(!%b.client.robadmin) %b.setdatablock(PlayerRoB);
		//%b.setrechargerate(0);
		schedule(200, 0, "SetPlayerEnergy", %b);
	}
	
	function servercmdcreateminigame(%client,%a,%b,%c,%d,%f,%g){
		return;
	}
	
	function servercmdclearbricks(%client)
	{
		if(!%client.robadmin) return;
		parent::servercmdclearbricks(%client);
	}
	
	function GameConnection::getSpawnPoint(%client)
	{
		if($brickload) {
			%i = 0;
			while($RoB::Dynamic::DefaultSpawn[%i] !$= "") %i++;
			if(%i) return $RoB::Dynamic::DefaultSpawn[getrandom(0, (%i - 1))];
			else Parent::getspawnpoint(%client);
			return;
		}
		if(%client.spawn[1] $= "") {
			if(!%client.lastspawn) {
				%client.lastspawn = 1;
				%j = 1;
				%i = 1;
				while($RoB::Property[%client.bl_id, %i] !$= "") {
					%x = getword($RoB::Property[%client.bl_id, %i], 0);
					%y = getword($RoB::Property[%client.bl_id, %i], 1);
					initContainerBoxSearch(getplotcenter($RoB::Property[%client.bl_id, %i]) SPC ((($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)) / 2), getplotXsize($RoB::Property[%client.bl_id, %i]) SPC getplotYsize($RoB::Property[%client.bl_id, %i]) SPC (($RoB::LevelHeight * 1) + ($RoB::GroundLevel * 0.2)), $typemasks::fxbrickobjecttype);
					while(%target=containersearchnext()) {
						if(%target.getdatablock().getname() $= "brickSpawnPointData") {
							%client.spawn[%j] = %target.gettransform();
							%j++;
						}
					}
					%i++;
				}
				if(%client.spawn[1]) return %client.spawn[1];
				else {
					%i = 0;
					while($RoB::Dynamic::DefaultSpawn[%i] !$= "") %i++;
					if(%i) return $RoB::Dynamic::DefaultSpawn[getrandom(0, (%i - 1))];
					else Parent::getSpawnPoint(%client);
				}
			} else {
				%i = 0;
				while($RoB::Dynamic::DefaultSpawn[%i] !$= "") %i++;
				if(%i) return $RoB::Dynamic::DefaultSpawn[getrandom(0, (%i - 1))];
				else Parent::getSpawnPoint(%client);
			}
		} else {
			%client.lastspawn++;
			if(%client.spawn[%client.lastspawn] $= "") %client.lastspawn = 1;
			return %client.spawn[%client.lastspawn];
		}
	}
	
	function gettrustlevel(%a, %b)
	{
		if(%a.getclassname() $= "fxDTSBrick" && %b.getclassname() $= "fxDTSBrick") {
			%plot = FindPlotFromObject(%a);
			%owner = FindPlotOwnerBLID(%plot);
			%player = getBrickGroupFromObject(%b).client;
			if(%player.robadmin) return 3;
			else if(%player.bl_id == %owner) return 2;
			else return 0;
		} else {
			%plot = FindPlotFromObject(%b);
			%owner = FindPlotOwnerBLID(%plot);
			%player = getBrickGroupFromObject(%a).client;
			if(%player.bl_id == %owner || %player.RoBadmin) {
				%x = getword(%plot, 0);
				%y = getword(%plot, 1);
				if(%player.RoBadmin) return 3;
				else if($RoB::Plot[%x, %y].type !$= "P" || getword(%b.gettransform(), 2) > 0.1) return 2;
				else return 0;
			} else return 0;
		}
	}
	
	function Player::GiveDefaultEquipment(%this)
	{
		//%this.clearinventory();
		%this.tool[0] = nametoID(hammerItem);
		%this.tool[1] = nametoID(wrenchItem);
		%this.tool[2] = nametoID(printGun);
		messageClient(%this.client, 'MsgItemPickup', '', 0, nametoID(hammerItem));
		messageClient(%this.client, 'MsgItemPickup', '', 1, nametoID(wrenchItem));
		messageClient(%this.client, 'MsgItemPickup', '', 2, nametoID(printGun));
		messageClient(%this.client, 'MsgItemPickup', '', 3, 0);
		messageClient(%this.client, 'MsgItemPickup', '', 4, 0);
	}
	
	
	function servercmdSetWrenchData(%client, %params)
	{
		if(!%client.RobAdmin) {
			CenterPrint(%client, "For now, you're only allowed to use the wrench to buy events.", 5, 3);
			return;
		}
		Parent::servercmdSetWrenchData(%client, %params);
	}
	
	function servercmdClearEvents(%client)
	{
		%plot = FindPlotFromObject(%client.wrenchBrick);
		%plotx = getword(%plot, 0);
		%ploty = getword(%plot, 1);
		if(!%client.RoBAdmin && %client.bl_id != $RoB::Plot[%plotx, %ploty].blid) return;
		%client.eventPricing = getBrickEventTotalPrice(%client.wrenchBrick) * -1;
		Parent::servercmdClearEvents(%client);
		%client.eventChargeSched = schedule(200, 0, "EventCharges", %client);
	}
	
	function serverCmdAddEvent(%client, %a, %b, %delay, %d, %e, %f, %g)
	{
		%plot = FindPlotFromObject(%client.wrenchBrick);
		%plotx = getword(%plot, 0);
		%ploty = getword(%plot, 1);
		if(!%client.RoBAdmin && %client.bl_id != $RoB::Plot[%plotx, %ploty].blid) return;
		Parent::serverCmdAddEvent(%client, %a, %b, 0, %d, %e, %f, %g);
		eval("%client.eventPricing += getBrickEventPrice(%client.wrenchBrick, " @ (%client.wrenchBrick.numEvents - 1) @ ");");
		%client.eventUse = true;
		cancel(%client.eventChargeSched);
		%client.eventChargeSched = schedule(200, 0, "EventCharges", %client);
	}
	
	
};
ActivatePackage(RoBPackage);